/* EM_CMDS_DECL.C 910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"

/* ===========================================================================

   function name: em_declare
   input	       : mode		- integer for mode of operation (scalar or
				                 parallel)
   output	    : ---
   return value : status	- SUCCESS, if no errors
				               - FAIL, otherwise

   global vars  : input_fp	- pointer to input file descriptor
		            bitslice	- number of bitslices allocated

   description	 : This routine  handles the 'decl_pa' and 'decl_sc' inter-
 		            mediate opcodes. The assembly language code which is
		            generated will declare identifers in the scalar or
		            parallel memory. If there is not enough room in the
		            parallel memory to declare the specified field, FAIL
		            is returned; otherwise, SUCCESS is returned.

=========================================================================== */
long atol();

em_declare(mode)
int mode;
{
   char charg1[TOKEN_SIZE];	/* name of identifier to be declared */
   char charg2[TOKEN_SIZE];	/* repeat count */
   char charg3[TOKEN_SIZE];	/* charg3 is an initial value */
   char charg4[TOKEN_SIZE];   /* charg4 is width of exponent - expt */
   char charg5[TOKEN_SIZE];   /* charg5 is width of mantisa - signif*/
   char charg6[TOKEN_SIZE];   /* charg6 is io shape of variable */
										/* not used for T_CNST */
			      /* total width is arg4+arg5 */
   double d1, atof();
	long l1;
	float f1;
   int arg2,arg3,arg4,arg5,i,j;	/* integer values for charg2 thru charg5  */
   int status;			         /* program error status -- SUCCESS or FAIL */
   int mode1,mode2;
   int address,endi,leng;
   unsigned long int larg3, ltemp;
   char arg[LINE_LENGTH];
	char chan[LINE_LENGTH];
	char *cpnt;
   union forx {
	  long int fhex;
	  float flt_dat;}
	fltint;

   mode1 = mode / SIZE_MODE2;
	mode2 = mode % SIZE_MODE2;

	status = SUCCESS;
   strcpy(charg6,"CS$");

   if(mode1 == T_CSTR)
	  {getc(input_fp);
		i=0;
		while ((chan[i++] = getc(input_fp)) != ' ');
//		chan[i-1] = '\0';  020505
		chan[i-1] = 0;
		i=0;
		while ((arg[i++] = getc(input_fp)) != '\n');
//		arg[i-2] = '\0';   020505
		arg[i-2] = 0;
	  }
	else if(mode2 == T_CNST)
    {fscanf(input_fp,"%s %s %s %s %s",charg1,charg2,charg3,charg4,charg5);
     arg2=atoi(charg2); 
     arg3=atoi(charg3);
     larg3=atol(charg3);
     arg4=atoi(charg4);
     arg5=atoi(charg5);
     status = SUCCESS;
	 }
	else
    {fscanf(input_fp,"%s %s %s %s %s %s",
				charg1,charg2,charg3,charg4,charg5,charg6);
     arg2=atoi(charg2);
     arg3=atoi(charg3);
     larg3=atol(charg3);
     arg4=atoi(charg4);
     arg5=atoi(charg5);
     status = SUCCESS;
	 }

   if(in_sub <= 0 || mode2 == T_CNST)
     switch (mode2)
      {case T_CNST     :
            if(mode1 == T_CSTR)
			 {leng=strlen(arg)+1;
//020505	  cpnt = (char *) em_alloc((unsigned long)leng,(unsigned long)sizeof(char));
			  cpnt = (char *) em_alloc(leng,sizeof(char));
			  strcpy(cpnt,arg);
			  em_insert(mode1,mode2,chan, (int)cpnt,0,1,0,0.0,"CS$");}
            if(mode1 == T_CSTR) break;
       case T_SCALAR:    /* allow fall through if not T_CSTR */
	     if(fetch(charg1)==FAIL)
			{address = tosm_bl;
	         /* check for defvars */
	         status = 0;
  	         for(i=0; i<defvar_cnt && status == 0; i++)
		       if(strcmp(defvar_table[i].ida,charg1) == 0 )
		         if((address=get_caddo(defvar_table[i].idb))==FAIL)
                    {printf("ERROR - no address for idb. defvar = %s %s\n",
			         defvar_table[i].ida,defvar_table[i].idb);
			         status = FAIL;}
	             else
			        {address = address + defvar_table[i].cnb
                               - arg2 *(arg4 +arg5)
                               + get_size(defvar_table[i].idb);
			         status = SUCCESS;}
	             if(status == 0)  /*init memory  and update tosm_bl */
                   if(mode1 == T_REAL)
                      {for(i=0;i<arg2*((arg5+arg4-1)/SIZE_HOST+1);i++)
                         {if((d1 = atof(charg3)) == 0)
									 f1 = 0.0;
								  else
									 f1 = (float) d1;
								  fltint.flt_dat = f1;
								  l1 = fltint.fhex;
								  l1 >>= 16;
								  sc_mem[tosm_bl++] =  fltint.fhex;
								  sc_mem[tosm_bl++] =  l1;
                          }
							     if(tosm_bl >= sc_mem_size)
		                      {printf("ERROR - scalar memory overflow on %s.\n",charg1);
		                       status = FAIL; }
			                 else status = SUCCESS;
			               }
                   else if(mode1 == T_CHAR)
								  {for(j=0;j<arg2;j++)
								     {endi = (arg5-1)/SIZE_HOST;
                              for(i=endi;i>=0;i--)
									     sc_mem[tosm_bl++]=(int)(charg3[i*2]<<8 | charg3[i*2+1]);
									  }
	                      if(tosm_bl >= sc_mem_size)
		                      {printf("ERROR - scalar memory overflow on %s.\n",charg1);
		                       status = FAIL; }
			                 else status = SUCCESS;
			                }
                   else
					   /* 6115 */
                        {if(larg3 == 0)
                           tosm_bl += arg2*((arg4+arg5-1)/SIZE_HOST+1);
								 else
            				  for(j=0;j<arg2;j++)
								   {endi = (arg5-1)/SIZE_HOST+1;
                            for(i=0;i<endi;i++)
									  {ltemp = larg3>>(SIZE_HOST*i);
									   sc_mem[tosm_bl++]= (int) ltemp;}}
	                      if(tosm_bl >= sc_mem_size)
		                     {printf("ERROR - scalar memory overflow on %s.\n",charg1);
		                      status = FAIL; }
			                else status = SUCCESS;
			                }
               if(status != FAIL)
	                em_insert(mode1,mode2,charg1,address,arg4+arg5,1,arg2,(float) arg3, charg6);
					}
		       break;
       case T_PARALLEL :
	             address = bitslice;
	             /* check for defvars */
	             status = 0;
  	             for(i=0; i<defvar_cnt && status == 0; i++)
		            if(strcmp(defvar_table[i].ida,charg1) == 0 )
		              if((address=get_caddo(defvar_table[i].idb))==FAIL)
                       {printf("ERROR - no address for idb. defvar = %s %s\n",
			                              defvar_table[i].ida,defvar_table[i].idb);
			               status = FAIL;}
	                 else
/* the emulator stores the data "backwards".  That is, the address is
   the address of the sign bit, the least significant bit is at add+size-1.
	Therefor to align left most bits of a:8[$] and b:24[$] must use
	  defvar(a,b-(size(b)-size(a)));
	To align rightmost bits use
	  defvar(a,b);
for arrays, and full fields, define the array in terms of the field,
thus
defvar(exbits, expon);
card parallel expon:7[$], exbits:1[$,7];

defvar (rittok, tokchr+40);
defvar (leftok, tokchr+32);
int parallel tokchr:8[$,6], rittok:40[$], leftok:40[$];

              Ŀ
                0    1    2    3    4    5  
              
                    ^                       ^     ^
tokchr            base                     +32   +40

                    Ŀ
                                                 
                    
                                                  ^
rittok                                           base
              Ŀ
                                            
              
                                             ^
leftok                                      base
                                                */
			             {address = address + defvar_table[i].cnb
                                         - arg2 *(arg4 +arg5)
	                                      + get_size(defvar_table[i].idb);
				           status = SUCCESS;}
                    if(status == 0)   /* update bitslice */
			             {bitslice += arg2*(arg4+arg5);
	                    if(bitslice > PA_MEM_SIZE*sizeof(int))
			                {printf("%d ERROR - parallel memory overflow.\n",linenum);
			                 status = FAIL; }
			              else
								  status = SUCCESS;
			             }
	                 if(status != FAIL)
                      {em_insert(mode1,mode2,charg1,address,arg4+arg5,NOOFW,arg2,0.0,charg6);}
		         break;

       default: printf("ERROR - unrecognized mode2 %d (mode=%x) in decl for %s\n",
								mode2,mode,charg1);
   }
   return(status);
}


em_deflog()
{
   char charg1[TOKEN_SIZE], charg2[TOKEN_SIZE];
   int status;

   status=SUCCESS;
   fscanf(input_fp,"%s %s",charg1,charg2);
   if(in_sub <= 1)
     if (strcmp(charg2,"1") == 0)
       em_insert(T_LOGICAL,T_CNST,charg1,0,0,0,0,-1.0,"CS$");
     else if (strcmp(charg2,"0") == 0)
       em_insert(T_LOGICAL,T_CNST,charg1,0,0,0,0,0.0,"CS$");
     else
       {status=FAIL;
        print_err("Unrecognized argument for DEFLOG",0,0);}
   return(status);
}


em_defvar()
{
   char charg1[TOKEN_SIZE], charg2[TOKEN_SIZE];
   char charg3[TOKEN_SIZE], charg4[TOKEN_SIZE];
   int status;

   status=SUCCESS;
   fscanf(input_fp,"%s %s %s %s",charg1,charg2,charg3,charg4);

   if(in_sub <= 1)
   if ( defvar_cnt < MAX_DEFVAR)
     {defvar_table[defvar_cnt].ida = (char *) em_malloc(strlen(charg1)+1);
      strcpy(defvar_table[defvar_cnt].ida, charg1);
      defvar_table[defvar_cnt].idb = (char *) em_malloc(strlen(charg2)+1);
      strcpy(defvar_table[defvar_cnt].idb, charg2);
      defvar_table[defvar_cnt].opb = atoi(charg3);
      defvar_table[defvar_cnt].cnb = atoi(charg4);
      defvar_cnt++;}
   else
	  {printf("%d ERROR - defvar_table overflow\n",linenum);
	   status = FAIL;}

   return(status);
 }


