/* EM_CMDS_MOV.C  910415  */
/* CHAR fileds are left justified, INT fields are right justified.
   scpamv right justifies smaller fields in larger fields.
   Thus "char strings" end up in the middle of the field   */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"
#include "p2_parser.h"

em_move(optype,mode)
int optype,mode;
{
   int arg1, arg2, arg3, arg4, sarg; /* arg1 is right side, arg2 is left */
   int status;
   int size1,size2,size3;
   int mode1,mode2;

   mode = fixmode(mode);
   mode1 = mode / SIZE_MODE2;
   mode2 = mode % SIZE_MODE2;

 if(em_debug == 2)
	 printf("In cmds_mov, optype=%x, mode=%x, mode1=%d, mode2=%d\n",
						  optype, mode, mode1, mode2);

   status=SUCCESS;
   switch(optype)
     {case T_MVSC  :
	 if (mode2 == T_MASKEDMOVE) /* ASNA_IDXPA MVSCPA - 4706 */
	   {em_scano_3();  /* sc to pa - masked by arg1 */
	     em_carg_3(&arg1,&arg2,&arg3);/* mask,sc,pa */
			    em_stack_buf();
			    size2 = get_size(carg2);
			    size3 = get_size(carg3);
	     if(!noex_bl)
	       {if(mode1 == T_CHAR)
		  if(size2 <= SC_TEMP_SIZE && (sarg=get_add("SC_TEMP")) != FAIL)
		    {/* converts char (left) to int (right) adjustment - required by suite58 */
		     em_chrcnv(arg2,sarg,size2);
		     scpamvmk(sarg,arg3,arg1,size2,size3);}
		  else
		   printf("%d ERROR - T_MVSC 4706 oversize, size2=%d, carg1=%s, sarg=%d\n",
			linenum,size2,carg1,sarg);
		 else
		    scpamvmk(arg2,arg3,arg1,size2,size3);
		 /* check for size3 > 1, i.e. logical,
		  so value is not overwritten by "sign" */
		 if(mode1 != T_CHAR &&
		    mode1 != T_CARD &&
		    mode1 != T_LOGICAL &&
		    mode1 != T_REAL)
			 if(size2 >= size3 && size3 > 1)
			   {if((1<<(size2-1))&sc_mem[arg2])
			      papamvmk(get_add("TRUE$"),arg3,arg1,1);
			    else
			      papamvmk(get_add("FALSE$"),arg3,arg1,1);}
			 else  /* size2 < size3 */
			    pasnexmk(arg3+size3-size2,arg3,arg1,size3-size2);
		 }
	    }
	       else if (mode2 == T_PARALLEL) /*  MVSC_PA - 4702 */
		   {em_scano_3();  /* sc to pa - masked by MREG */
		    em_carg_2(&arg1,&arg2);/* sc,pa,size */
		    em_stack_buf();
		    size1 = get_size(carg1);
		    size2 = (int) get_value(carg3);
		    if(!noex_bl)
		      {if(mode1 == T_CHAR)
			 if(size1 <= SC_TEMP_SIZE && (sarg=get_add("SC_TEMP")) != FAIL)
			   {em_chrcnv(arg1,sarg,size1);
			    scpamvmk(sarg,arg2,MREG,size1,size2);}
			 else
			   printf("%d ERROR - T_MVSC 4702 oversize, size1=%d, sarg=%d\n",
				   linenum,size1,sarg);
		       else
			 scpamvmk(arg1,arg2,MREG,size1,size2);
		       /* check for size2 > 1, i.e. logical,
			  so value is not overwritten by "sign" */
		       put_size(carg2,size2);
		       if(mode1 != T_LOGICAL &&
			  mode1 != T_CARD &&
			  mode1 != T_CHAR)
			  if(size1 >= size2 && size2 > 1)
			    {if((1<<(size1-1)) & sc_mem[arg1])
				papamvmk(get_add("TRUE$"),arg2,MREG,1);
			     else
				papamvmk(get_add("FALSE$"),arg2,MREG,1);}
			  else if(size1 < size2)
			     pasnexmk(arg2+size2-size1,arg2,MREG,size2-size1);
		       }
	    }
	  else if (mode2 == T_SCALAR) /* MVSCSC - 4701 */
			   {em_scano_2();
			    em_carg_2(&arg1,&arg2);
			    em_stack_buf();
			    if(!noex_bl)
				{size1 = get_size(carg1);
				 size2 = get_size(carg2);
/*printf("At 4701, line=%d,  size1=%d, size2=%d, mode1=%d\n",linenum,size1,size2,mode1);*/
				 if(mode1 == T_CHAR &&
				    size1 < size2   &&
				    strchr(carg2,'$') == NULL)
				      movchr(arg1,arg2,size1,size2);
				 else
				 {put_size(carg2,size1);
				  if(mode1 == T_CHAR)
				    em_cnvchr(arg1,arg2,size1);
				  else
				    scscmv(arg1,arg2,size1);}
				}
				status=SUCCESS;
			    }
	  else status=FAIL;
	  break;
      case T_MVPA  :
		  if (mode2 == T_PARALLEL) /* MVPAPA - 4802 */
			   {em_scano_2();
			    em_carg_2(&arg1,&arg2);
			    em_stack_buf();
			    size1 = get_size(carg1);
			    size2 = get_size(carg2);
			    if(!noex_bl)
			      if (mode1 == T_CHAR || mode1 == T_LOGICAL)
				   papamvmk(arg1,arg2,MREG,size2);
			      else em_mvpa(MREG,arg1,arg2,size1,size2);
			   }
		 else if (mode2 == T_SCALAR || mode2 == T_REG_SCALAR) /* MVPASC - 4801, 4807 */
			   {status = SUCCESS;
			    em_scano_4();
			    em_carg_4(&arg1,&arg2,&arg3,&arg4);
			    em_stack_buf();
			    if(noex_bl) return(status);
			    size1 = get_size(carg1);
			    size2 = (int) get_value(carg4);
			    if(size1 > size2 && strchr(carg2,'$') == NULL)
			       pascmvsx(arg1+sc_mem[arg4]-size2,arg2,arg3,size2);
			    else
			       pascmvsx(arg1,arg2,arg3,size1);
			    maskit(arg2,size2);
			    put_size(carg2,size1);
			    if(mode1 == T_CHAR)        /*931104*/
			       {if(size2 <= SC_TEMP_SIZE && (sarg=get_add("SC_TEMP")) != FAIL)
				  {em_cnvchr(arg2,sarg,size2);
				   scscmv(sarg,arg2,size2);}
				else
		   {printf("%d ERROR - T_MVPA 4807 oversize, size2=%d, carg1=%s, sarg=%d\n",
			linenum,size2,carg1,sarg);
			printf("Must adjust SC_TEMP_SIZE\n");}
			       }
	      }
			 else
		      printf("WARNING - illegal T_MVPAPA quadruple %x%x.\n",optype,mode);
			 break;
      default  :
			 status=FAIL;
			 break;

      }
  if (status == FAIL)
     print_err("Unrecognize intermediate code for move quadruples.",0,0);
  return(status);
}

void maskit(int arg2, int size)
{
  int i;

    for(i=0; i <(size-1)/SIZE_HOST + 1; i++)
       sc_mem[arg2+i] &= 0xFFFF;
}

int em_copy()
{
   int arg1,arg2;
	int size;

	em_scano_2();
	em_carg_2(&arg1,&arg2);
	em_stack_buf();
	if(noex_bl) return(SUCCESS);
   size = get_size(carg1);
   papamvmkhl(arg1,arg2,MREG,size);
   return SUCCESS;
}

/* assumes destination size is larger than source.
   Moves source (arg1) into destination (arg2)
   Left adjusted in field - word wise, bytes not moved */
void movchr(int arg1, int arg2, int size1, int size2)
{
  int wd1,wd2,wdd,i;

  wd1 = (size1-1)/SIZE_HOST + 1;
  wd2 = (size2-1)/SIZE_HOST + 1;
  for(i=0; i<wd2; i++) sc_mem[arg2+i] = 0;
  wdd = wd2-wd1;
  for(i=0; i<wd1; i++) sc_mem[arg2+i+wdd] = sc_mem[arg1+i];
}

/* routine to convert T_CHAR packing (left justified) to T_INT
   packing (right justified), i.e.
	0_       ->  _0        or    0___      -> ___0
		  01       ->  01              01__      -> __01
		  01 2_    ->  _0 12           012_      -> _012
		  01 23    ->  01 23           0123      -> 0123
												 0123 4___ -> ___0 1234
											    0123 45__ -> __01 2345
T_CHAR data is packed in scalar memory as:
 |    word n   |    |    word 1   |    word 0   |
 | ch2n |ch2n-1| .. |  ch3 |  ch2 |  ch1 |  ch0 |
 |ch2n-1|ch2n-2| .. |  ch2 |  ch1 |  ch0 |000000| - T_CHAR
 |00000 |ch2n  | .. |  ch3 |  ch2 |  ch1 |  ch0 | - T_INT
*/

em_chrint_old(mode)
int mode;
{
   int arg1,arg2;
	int mode2,size;

   mode2 = mode % SIZE_MODE2;
	em_scano_2();
	em_carg_2(&arg1,&arg2);
	em_stack_buf();
	if(noex_bl) return(SUCCESS);

   size = get_size(carg1);
   put_size(carg2,size);
	if (mode2 == T_PARALLEL)
     { /* seems to work ok as is */
		 /*if(size != W_CHAR)
		     printf("%d WARNING - parallel chrint conversion not implemented\n",linenum);*/
	    /*pa_chrcnv(arg1,arg2,size);*/
	   papamvmk(arg1,arg2,MREG,size);
	  }
	else if (mode2 == T_SCALAR || mode2 == T_CNST || mode2 == T_REG_SCALAR)
     em_chrcnv(arg1,arg2,size);
	else
		printf("%d ERROR - Unrecognized mode2 %d for CHRINT quadruple.\n",
				  linenum,mode2);

   return(SUCCESS);
}

em_chrint(mode)
int mode;
{
   int arg1,arg2;
	int mode2,mode1,size;
   int sarg,i,tint;
   char *chrtmp, chrfoo[20];

   mode2 = mode % SIZE_MODE2;
   mode1 = mode / SIZE_MODE2;
	em_scano_2();
	em_carg_2(&arg1,&arg2);
	em_stack_buf();
	if(noex_bl) return(SUCCESS);

   size = get_size(carg1);
   put_size(carg2,size);
	if (mode2 == T_PARALLEL)
     { /* seems to work ok as is */
		 /*if(size != W_CHAR)
		     printf("%d WARNING - parallel chrint conversion not implemented\n",linenum);*/
	    /*pa_chrcnv(arg1,arg2,size);*/
	   papamvmk(arg1,arg2,MREG,size);
	  }
	else if (mode2 == T_SCALAR || mode2 == T_CNST || mode2 == T_REG_SCALAR)
	    if(mode1 == T_CHAR)
	       {/*printf("In em_chrint %d, true\n",linenum);*/
		em_chrcnv(arg1,arg2,size);}
	    else
	      {sarg = get_add("SC_TEMP");
/*             printf("In em_chrint %d, false, calling em_chrcnv\n",linenum);*/
/*             nw_chrcnv(arg1,sarg,size); */
	       em_chrcnv(arg1,sarg,size);
	       for(i=(size-1)/SIZE_HOST; i>=0; i--)
		   {chrtmp = chrfoo;
		   *chrtmp = sc_mem[sarg+i]>>8;
		   if(*chrtmp != 0) chrtmp++;
		   *chrtmp = sc_mem[sarg+i] & 255;
		   if(*chrtmp != 0) chrtmp++;
		   *chrtmp = 0;
		   tint = 0;
		   sscanf(chrfoo,"%d",&tint);
/*printf("In em_chrint, after false, chrfoo=%s, tint=%x\n",chrfoo,tint);*/
		   sc_mem[arg2+i] = tint;
		  }
	      }
	else
		printf("%d ERROR - Unrecognized mode2 %d for CHRINT quadruple.\n",
				  linenum,mode2);
/*
printf("In em_chrint\n");
printf("%d arg1=%x, %x, %x, %x, arg2=%x, %x, %x, %x\n",linenum,
sc_mem[arg1+3],sc_mem[arg1+2],sc_mem[arg1+1],sc_mem[arg1],
sc_mem[arg2+3],sc_mem[arg2+2],sc_mem[arg2+1],sc_mem[arg2]);
*/
   return(SUCCESS);
}


/* routine to convert char to int */
/* right adjust - I dont think this does anything? */
int em_chrcnv(int arg1, int arg2, int size)
{
  int i,iend;

  if(SIZE_HOST == 16)
    {iend = size/SIZE_HOST;
     if(size % SIZE_HOST != 0)
       {for(i=0; i<iend; i++)
	 {sc_mem[arg2+i] = sc_mem[arg1+i]>>CHAR_SIZE;
	  sc_mem[arg2+i] |= sc_mem[arg1+i+1]<<CHAR_SIZE;
	 }
	sc_mem[arg2+iend] = sc_mem[arg1+iend]>>CHAR_SIZE;
       }
     else
       for(i=0; i<iend; i++)
	   sc_mem[arg2+i] = sc_mem[arg1+i];
    }
  else
    printf("ERROR - SIZE_HOST != 16 in em_chrcnv\n");
  
  return(SUCCESS);
}

/* routine to convert char to int for CHCL T_EQ in
  em_c_ari line 433 routine */
/* this one right adjusts, em_chrcnv does nothing? */
/* the != 0 true part has not been debugged */
nw_chrcnv(arg1,arg2,size)
int arg1,arg2,size;
{
  int i,j,k,iend;

  if(SIZE_HOST == 16)
    {iend = (size-1)/SIZE_HOST;
     sc_mem[arg2] = 0;
     if(size % SIZE_HOST != 0)
       {for(i=0; i<iend; i++)
	 {sc_mem[arg2+i] = sc_mem[arg1+i]>>CHAR_SIZE;
	  sc_mem[arg2+i] |= sc_mem[arg1+i+1]<<CHAR_SIZE;
	  }
	sc_mem[arg2+iend] = sc_mem[arg1+iend]>>CHAR_SIZE;
	}
     else
	 {j=0; k=0;
	  for(i=0; i<iend+1; i++)
	    if(sc_mem[arg1+i] == 0) sc_mem[arg2+k++]=0; else {j=i; break;}
	  for(i=j; i<iend+1; i++)
	     sc_mem[arg2+k++] = sc_mem[arg1+i];
	  }
   }
  else
	 printf("ERROR - SIZE_HOST != 16 in em_chrcnv\n");
  return(SUCCESS);
}

/* routine to convert int to char */
/* _0    -> 0_    - only one tested
   01    -> 01
	_0 12 -> 01 2_
	01 23 -> 01 23                  */
em_cnvchr_foo(arg1,arg2,size)
int arg1,arg2,size;
{
  int i,iend,stemp;

printf("In cnvchr before, arg1=%x %x, arg2=%x %x\n",
sc_mem[arg1+1],sc_mem[arg1],sc_mem[arg2+1], sc_mem[arg2]);
  if(SIZE_HOST == 16)
    {iend = size/SIZE_HOST;
     if(size % SIZE_HOST != 0)
       {for(i=iend; i>0; i--)
	   {stemp = sc_mem[arg1+i]<<CHAR_SIZE;
	    stemp |= sc_mem[arg1+i-1]>>CHAR_SIZE;
	    sc_mem[arg2+i] = stemp;}
	sc_mem[arg2] = sc_mem[arg1]<<CHAR_SIZE;}
     else
	for(i=0; i<iend+1; i++)
	  sc_mem[arg2+i] = sc_mem[arg1+i]<<CHAR_SIZE;
    }
  else
	 printf("ERROR - SIZE_HOST != 16 in em_chrcnv\n");

printf("In cnvchr after, arg1=%x %x, arg2=%x %x\n",
sc_mem[arg1+1],sc_mem[arg1],sc_mem[arg2+1], sc_mem[arg2]);
  return(SUCCESS);
}

long int tocl(arg1)
int arg1;
{
  union forx
   { long int fhex;
     float flt_dat;}
  fltint;

  fltint.fhex = 0;
  fltint.fhex = (unsigned) sc_mem[arg1+1] & 0xFFFF;
  fltint.fhex <<=  16;
  fltint.fhex |= (unsigned) sc_mem[arg1] & 0xFFFF;
  return fltint.fhex;
}

/* convert from long c to long asc */
/* toascl(sc_mem, long int)        */
void toascl(int arg1, long int arg2)
{
  union forx
   { long int fhex;
     long int flt_dat;}
  fltint;

  /* the union construct is not necessary but is used to be consistent
     with similar data conversion routines. */

  fltint.flt_dat = arg2;
  sc_mem[arg1+1] = (unsigned) (fltint.fhex >> 16) & 0xFFFF;
  sc_mem[arg1] = (unsigned) fltint.fhex & 0xFFFF;
}

em_intchr(mode)
int mode;
{
	int arg1,arg2,sarg;
	int mode2,mode1,size;
	char chrtmp[20];
	int i;

	mode2 = mode % SIZE_MODE2;
	mode1 = mode / SIZE_MODE2;
	em_scano_2();
	em_carg_2(&arg1,&arg2);
	em_stack_buf();
	if(noex_bl) return(SUCCESS);

	size = get_size(carg1);
	put_size(carg2,size);
	if (mode2 == T_PARALLEL)
	   {printf("%d WARNING - parallel intchr conversion not implemented\n",linenum);
	    papamvmk(arg1,arg2,MREG,size);}
	else if (mode2 == T_CNST) /* assumes ascii code - left justifies only*/
	    em_cnvchr(arg1,arg2,size);
	else if (mode2 == T_SCALAR)
	    {/* encodes decimal number */
/* needs to convert from long int to ascii */
sarg=get_add("SC_TEMP");
for(i=(size-1)/SIZE_HOST; i>=0; i--)
  {sprintf(chrtmp,"%d",sc_mem[arg1+i]);
   if(*chrtmp != 0) sc_mem[sarg+i] = (*chrtmp);
   if(*(chrtmp+1) != 0) sc_mem[sarg+i] = sc_mem[sarg+i]*256 + *(chrtmp+1);
   else sc_mem[sarg+i] += 48*256; /* ascii zero left adjusted */
   em_cnvchr(sarg,arg2,size);
  }
	    }

	else
	   print_err("Unrecognized mode for INTCHR quadruple.",0,0);

   return(SUCCESS);
}

int em_mvid(int mode)  /* @sc = log_exp */
/* size2 of indirect field must be passed as a parameter */
{
   int arg1, arg2, size2, dsize;
   int status;
   int mode2;

   mode2 = mode % SIZE_MODE2;
   em_scano_3();
   em_carg_3(&arg1,&arg2,&size2);
   dsize = size2 - get_size(carg1);
   status=SUCCESS;
   em_stack_buf();
   if(noex_bl) return(status);
   switch (mode2)
     {/* this call may be in error */
      case T_SCALAR   :
			scpamvmk(arg1,sc_mem[arg2],MREG,get_size(carg1),size2);
			break;
      case T_PARALLEL :
			papamvmk(arg1,sc_mem[arg2],MREG,dsize);
	      break;
       default        :
			status=FAIL;
			break;
      }
   return(status);
}


void em_mvpaid()   /* address = @sc[] */
{
   int arg1, arg2, arg3, arg4;

   em_scano_4();
   em_carg_4(&arg1,&arg2,&arg3,&arg4);
   em_stack_buf();
   printf("In em_mvpaid().  Quadruple not implemented - see em_cmds_mov.c\n");
/*   if(!noex_bl) papamvmk(sc_mem[arg2],arg3+get_size(carg3)-arg4,arg4); */
/* above statement is missing an argument - size i think. */
}




int em_mvcb()  /* shift */
/* mvcb_  parallel, parallel, shift */
{
   int arg1, arg2, size, shift, mod, rotate;
   int status;

   em_scano_5();
   size = em_carg_5(&arg1,&arg2,&shift,&mod,&rotate);
   status=SUCCESS;
   em_stack_buf();
   if(noex_bl > 0) return(status);
   papamvsh(arg1,arg2,size,shift,mod,rotate);
   size = get_size(carg1);
   put_size(carg2,size);
   return(status);
}
/* cnvchr left adjusts integer fields to make them
   char fields */
/* inarg and outarg may be the same field */
em_cnvchr(inarg,outarg,size)
int size, inarg, outarg;
{ int iend, i, j;

  iend = (size-1)/SIZE_HOST;
  for(i=iend; i>=0; i--)
    if(sc_mem[inarg+i] != 0) break;
    else
      {sc_mem[outarg+i] = 0;
       if(i == 0) return 0;}
  if(sc_mem[inarg+i] & 255<<8)
    for(j=i; j>=0; j--,iend--)
       sc_mem[outarg+iend] = sc_mem[inarg+j];
  else
    {for(j=i; j>0; j--,iend--)
       sc_mem[outarg+iend] =
	  sc_mem[inarg+j] << 8 | sc_mem[inarg+j-1]>>8;
     sc_mem[outarg+iend] =
	sc_mem[inarg+j] << 8;
     iend--;
     }
  for(i=0; i<=iend; i++) sc_mem[outarg+i]=0;
return 0;
}

