/* EM_DIMP.C  */
/* DIMP is the direct input routine - from readln to parallel field via
   scpamv
*/
/* ASC maintains a table called filetab for OPENed files.  The table
   contains a pointer to the inputfile name, filein, a pointer to the
   output file name, fileot, and the output stream number, streamot.
   The entires in the table are offset by -6 to allow for system
   handle numbers.  I.e. handle #7 which is the first user # available
   is in slot #1.  There are also flages to record that there was input and
   or output on this stream.
*/

#include "stdio.h"
#include "p2_common.h"
#include "em_common.h"
#include "p2_symtab.h"


/* em_dimp inputs a single value from sc_mem[arg1] */
/* quadruple is of form
      dimp_ b711 sc_mem_add  description
   description is not currently used  */

int em_dimp(int mode)
{
  long int longtemp;
  int arg1,arg2,mode1,mode2;
  char *pnt;
  int i,j,size;
  long lw;
  int mod, word;
  union forx {
		long int fhex;
		float flt_dat;}
  fltint;
  int sc_mem_dx;
  int *address;
  int status;

	/* initialize local variables */
  longtemp = 0;
  arg1 = 0;
  arg2 = 0;
  mode1 = 0;
  mode2 = 0;
  pnt = NULL;
  i = 0;
  j = 0;
  size = 0;
  lw = 0;
  mod = 0;
  word = 0;
  fltint.fhex = 0;;
  sc_mem_dx = 0;
  address = NULL;
  status = 0;

  mode = fixmode(mode);
  mode1 = mode/SIZE_MODE2;
  mode2 = mode%SIZE_MODE2;

  em_scano_2();
  em_carg_2(&arg1,&arg2);
  em_stack_buf();
  if(noex_bl > 0) return FAIL;

   sc_mem_dx = arg1; /* for em_strcpy routine */
   address = sc_mem + arg1; /* make address a pointer */
   size = atoi(carg2);
   put_size(carg1,size);
   token_length = ((size-1)/CHAR_SIZE)+1;

   pnt = datapnt;
   while(*pnt == ' ') pnt++; /* strip blanks */
   if(pnt == NULL)
     {printf("%d ERROR insufficient data=%s.\n",linenum,pnt);
      status = FAIL; }
   switch(mode1)
    {case T_LOGICAL:
     case T_INT:
          sscanf(pnt,"%d ",address);
	  break;
     case T_LONGINT:
	  sscanf(pnt,"%ld ",&longtemp);
          lw = longtemp >> SIZE_PACK;
	  sc_mem[sc_mem_dx+1] = (int) lw;
          lw = longtemp << SIZE_PACK;
          lw = lw >> SIZE_PACK;
          sc_mem[sc_mem_dx] = (int) lw;
	  break;
     case T_BIN:
          scanbin(pnt,address);  /* 16 bits only */
	  break;
     case T_DOL:
     case T_REAL:
          sscanf(pnt,"%f ",&fltint.flt_dat);
	  longtemp = fltint.fhex;
	  lw = fltint.fhex >> SIZE_PACK;
	  sc_mem[sc_mem_dx+1] = (int) lw;
          lw = longtemp << SIZE_PACK;
          lw = lw >> SIZE_PACK;
          sc_mem[sc_mem_dx] = (int) lw;
	  break;
     case T_OCT:  sscanf(pnt,"%o ",address); break;  /* 16 bits only??? */
     case T_HEX:  sscanf(pnt,"%x ",address); break;
     case T_CHAR: /* values will be left adjusted */
                  j = token_length/2;
                  for(i=0; i<j; i++) sc_mem[arg1+i]=0;
                  mod = SIZE_PACK/CHAR_SIZE;
                  while(*pnt != ' ' && *pnt != 0)
                    {word = 0;
                     for (i=0; i<mod; i++)
                       if(*pnt != 0 && *pnt != ' ')
                          word |= (*pnt++ & 255) << ((mod-1-i)*CHAR_SIZE);
                       else
                          word |= (0  & 255) << ((mod-1-i)*CHAR_SIZE);
                     sc_mem[sc_mem_dx+j-1] = word;
                     j--;
                    }
                  datapnt = pnt;
                  break; /* requires an index */
     case T_CARD: sscanf(pnt,"%u ",address); break;
     default :    printf("%d ERROR in em_dimp. Unrecognized data type %d.\n",linenum,mode1);
		       break;
      }
 if(mode1 != T_CHAR)
    {while(*pnt != ' ') pnt++; /* advance datapnt for non T_CHAR */
     datapnt = pnt;}

if(em_debug_4) printf("At end of em_dimp, address = %x(hex), pnt=%x, sc_mem=%d\n",
  address,pnt,sc_mem[sc_mem_dx]);

return status;
}
