#include "errno.h"
#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"
#include "p2_parser.h"

/* this routine parses an input table */
/* the quadruple if of the form 
       load  handle association
	the source code is:
       load ("file","ext",association);
   Pass1 "opens" file and converts it into a handle for the load quadruple
   object == association
   The quadruple is:
	   T_LOAD HANDLE$,C0D$ ASSOCIATION
*/

int get_mode1(char *);
/* em_load.c constants and prototyes */
#define MAX_COL_SIZE 10
#define MAX_NAME_SIZE 4
#define MAX_TOKEN_SIZE 50
#define true 1
#define false 0
#define L_INT_SIZE 16 //the size of int input by em_load

/* initialize col_name_index to zero and names to null */
void init_col_name();
void em_load(int);
void cl_strip(char *);
int parse_header();
void decl_col_names();
int parse_row(int);
int get_col_add(int);
int get_col_type(int);
int em_read_line(int, long unsigned int);
int col_name_index[MAX_COL_SIZE];
int col_sz[MAX_COL_SIZE];
char col_name[MAX_COL_SIZE][MAX_NAME_SIZE][MAX_TOKEN_SIZE];
int col_num; //the numberr of columns parsed from the table
char row_dl, col_dl;
/* end em_load.c constants and prototypes */
/* defined in p2_main.c - em_common.m/mh
int token_length;
char token[MAX_NO_LEN], *pnt, data[MAX_NO_LEN], *datapnt; */

extern int LOAD_FLAG;

/* em_load parses a table */
void em_load(int mode)
{ int arg1,arg2,tstln;
  long unsigned int lw = 0;
  int result;
  em_scano_2();     // load 5b00 handle,c0d$ bi_id
  em_carg_2(&arg1,&arg2);
  em_stack_buf();

//printf("In em_load, noex_bl=%d, arg1=%d, arg2=%d\n",noex_bl, arg1,arg2);
if(noex_bl <= 0)
 {
	LOAD_FLAG = TRUE;
	 if(strcmp(carg1,"SYSIN") == 0)
     tstln = 1;
  else
    {lw = (unsigned) sc_mem[arg1];
     lw <<= 16;
     lw += (unsigned) sc_mem[arg1+1] & 0xFFFF;
     tstln =2;}
//printf("em_load, lw=%x, sc_mem[%d]=%x, sc_mem[%d]=%x\n",
//	   lw,arg1,sc_mem[arg1],arg1+1,sc_mem[arg1+1]);

  init_col_name();
  /* establish row and col delimeters from table*/
  //read_line inputs data into a global buffer called data.
  if(em_read_line(tstln,lw))
	row_dl = data[0];
  else
	  printf("ERROR - empty table in em_load\n");
  if((result = em_read_line(tstln,lw)))
	col_dl = data[0];
  else
	  printf("ERROR - one line table in em_load\n");

//  printf("Before parse_header, result=%d, row_dl=%c, col_dl=%c\n",result,row_dl,col_dl);
  /* if a line of data has been input, parse it */
  while (result == true)
	{if(!parse_header()) break; 
     result = em_read_line(tstln,lw);
	}

  // if header pares successful, declare column names
  // and make association entry
//printf("Before decl_col_names\n");
  decl_col_names(fetch(carg2));

//loop until eof or blank line?
while ((result = em_read_line(tstln,lw)) != false)
	{while (result != false)
		{if(!parse_row(arg2)) break; 
		 result = em_read_line(tstln,lw);
		}
	}
//dump_atab();

	LOAD_FLAG = FALSE;	
   
  } /* end if noex_bl */
}

/* reads one line of input into buffer data  */
/* from STDIN if tstln == 1, from handle lw if tstln == 2 */
/* if no more data, data is set to zero */
int em_read_line(int tstln, long unsigned int lw)
{int result;
//printf("In em_read_line, lw=%x",lw);
   result = true;
	if(tstln == 1)
	{if(gets(data) == NULL) 
		{*data = 0;
		 result = false;}}
    else if (tstln == 2)
    {if(fgets(data,MAX_NO_LEN,(FILE *) lw) == NULL)
		{*data = 0;
		result = false;}}
	else 
	  result = false;
//printf("data=%s#\n",data);
  return result; 
}

/* parses one line of header data in buffer data.  Returns false when row delemeter detected */
/* input (one row at a time) is of the form:
    | first   | second col |         |
	| col     |            |third col|
	| (int)   | (float)    | char    |
	----------------
*/
int parse_header()
{   char * col_pt;
    char * data_pt;
    char * tok_pt;
    char * tok_lst_pt;
    int i;
    int delta;
	char token[MAX_TOKEN_SIZE];
	char token_list[MAX_TOKEN_SIZE*MAX_NAME_SIZE];
    char tok_del[3];
	
//	printf("In parse_header,data=%c, col_dl=%c, data=%s\n",*data,col_dl,data);
	tok_del[0] = col_dl;  /* break on blanks and col delimeters */ 
	tok_del[1] = ' ';
	tok_del[2] = 0;
	data_pt = data;
	if(*data_pt == row_dl) return false; /* exit if end of row */
	data_pt++; //skip initial col delimeter
	col_num = 1;
	while (col_num < MAX_COL_SIZE)
	{if((col_pt = strchr(data_pt,col_dl)) != NULL) 
       {delta = col_pt-data_pt + 1;  //include col delemeter
	    strncpy(token_list,data_pt,delta);
		*(token_list+delta) = 0;  //terminate string
		tok_lst_pt = token_list;
		if((unsigned) col_sz[col_num] < strlen(token_list)) col_sz[col_num] = strlen(token_list);
        data_pt += delta;
	    cl_strip(token_list);
		tok_pt = strpbrk(tok_lst_pt,tok_del);
		i = col_name_index[col_num];
		delta = tok_pt - tok_lst_pt;	 
		while (tok_pt != NULL && delta >= 0)
			{ if(delta > 0)
				{strncpy(token,tok_lst_pt,delta);
				*(token+delta) = 0;  //terminate string
				tok_lst_pt += (delta + 1);
				cl_strip(tok_lst_pt);}
			 else
				strcpy(token,tok_lst_pt);
	         cl_strip(token);
	         if (i<MAX_NAME_SIZE)
				{strcpy(col_name[col_num][i],token);
			 i++;}
			 else
				{printf("ERROR - MAX_NAME_SIZE exceeded\n");
				return false;}
			 tok_pt = strpbrk(tok_lst_pt,tok_del);
     		 delta = tok_pt - tok_lst_pt;	 
			 if(delta == 0) //terminate loop if no more
				 delta = -1;
		}
	    col_name_index[col_num] = i;
	    col_num++;
       }
	  else
       break; //exit while loop
	}
	return true;
}


/* initialize col_name_index to zero and names to null */
void init_col_name()
{int i, j;
//printf("In init_col_name\n");
   for(i=0; i<MAX_COL_SIZE; i++)
   { col_name_index[i] = 0;
     col_sz[i] = 0;
     for(j=0; j<MAX_NAME_SIZE; j++)
		 *col_name[i][j] = 0;
   }
}

void cl_strip(char * token)
{
 char tmpbuf[MAX_TOKEN_SIZE*MAX_NAME_SIZE];
 char *ptr;
 int len;
//printf("In cl_strip, token=%s\n",token);
if(*token != 0)
{strcpy(tmpbuf,token);
 ptr = tmpbuf;
 len = strlen(token);
 while(*(ptr+len-1) == ' ') len--;
 while(*ptr == ' ') {ptr++; len--;}
// printf("after strip, token=%s, tmpbuf=%s, ptr=%s, len=%d\n",token,tmpbuf,ptr,len);
 strncpy(token,ptr,len);
 *(token+len) = 0;  //terminate string

}
}

int parse_row(int assoc_dx)
{   char * col_pt;
    char * data_pt;
	char * tok_pt;
	char * tok_lst_pt;
    int delta;
	char token[MAX_TOKEN_SIZE];
	char token_list[MAX_TOKEN_SIZE*MAX_NAME_SIZE];
    char tok_del[3];
	int index_dx;  //index into a logical parallel variable
	int field_dx;  //index of column
    int sarg;
	int c_type;
//printf("In parse_row, data=%s#\n",data);
	tok_del[0] = col_dl;  /* break on blanks and col delimeters */ 
	tok_del[1] = ' ';
	tok_del[2] = 0;
	data_pt = data;
	if(*data_pt == row_dl) return false; /* exit if end of row */
    cl_strip(data_pt);
//printf("In parse_row, after strip data_pt=%s#\n",data_pt);
	if(strlen(data_pt)<=0) return false; //null line consists of newline only
	if(*data_pt == '\n') return false; /* exit if new line only */
	data_pt++;
	col_num = 1;
/*  allocate xx in new[$]                            */
/*  balloc(xx, new, 1);                             */
	index_dx = fillds;  //the temp slice at top of the stack
    balloc(index_dx, assoc_dx, 1);
	while (col_num < MAX_COL_SIZE)
	{if((col_pt = strchr(data_pt,col_dl)) != NULL) 
       {delta = col_pt-data_pt+1;  //include col delemeter
	    strncpy(token_list,data_pt,delta);
		*(token_list+delta) = 0;  //terminate string
		tok_lst_pt = token_list;
        data_pt += delta;
	    cl_strip(token_list);
		tok_pt = strpbrk(tok_lst_pt,tok_del);
		delta = tok_pt-tok_lst_pt;
//printf("In while 1, delta=%d\n",delta );
	    while (tok_pt != NULL && delta >= 0)
			{if(delta > 0)
				{strncpy(token,tok_lst_pt,delta);
			     *(token+delta) = 0;  //terminate string
                 tok_lst_pt += delta + 1;
				 cl_strip(tok_lst_pt);}
			 else
				 strcpy(token,tok_lst_pt);
             cl_strip(token);
             field_dx = get_col_add(col_num);
			c_type=get_col_type(col_num);
//printf("    field_dx for col %d is %d, c_type=%d, token=%s\n",col_num,field_dx,c_type,token);
             switch(c_type)
			 {case T_INT:
/*                 scpamvmk(sc,pa,mask,size1,size2) */
				   sarg = get_add("SC_TEMP");
				   sscanf(token,"%d",&sc_mem[sarg]);
//printf("     saving token=%s into sc_mem[%d]=%d, filed_dx=%d\n",
//	   token,sarg,sc_mem[sarg],field_dx);
				   scpamvmk(sarg,field_dx,index_dx,L_INT_SIZE,L_INT_SIZE);
                   break;
			  case T_REAL:
			  case T_CHAR:
			  default: 
				  printf("ERROR - unsupported type %d in parse_row\n",c_type);
				  break;
			 }
		     tok_pt = strpbrk(tok_lst_pt,tok_del);
			 delta = tok_pt - tok_lst_pt;
             if(delta == 0) //terminate loop
				 delta = -1;
		}
	    col_num++;
       }
	  else
	  {//printf("pntr = NULL\n");
	  break;}  //exit while loop
	}
	return true;
}
 
/* em_insert(
   mode1 - T_LOGICAL
   mode2 - T_CNST,T_SCALAR
   label - name
   address - address
   width - number of bits
   depth - number of C words required for one ASPROL word
   count - number of ASPROL words in array
   value - initial value
   shape - io specification)   */
// em_insert(T_INT,T_PARALLEL,"TEMP2",PA_MEM_SIZE-2*INT_SIZE-2,INT_SIZE,1,0,0.0,"CS$");
// em_insert(mode1,mode2,charg1,address,arg4+arg5,NOOFW,arg2,0.0,charg6);
  	 
/* decl_col_names allocates memory and inserts the column names into
   the symbol table.  
   It also puts the symbol_index into the association table 
   And it adds a shape to column names */

void decl_col_names(int assoc_dx)
{  int address;
   int i,j;
   char token_list[MAX_TOKEN_SIZE*MAX_NAME_SIZE];
   int cdx;
   int twidth = 0;
   int tllen;
   char * shape;
   //assume integers only 

   /* allocate atab, store in symtab and initialize atabnum */
   atab_num++;
   if(atab_num >= MAX_ATAB_SIZE)
   {printf("ERROR - ATAB overflow, atab_num=%d\n",atab_num);
    exit(1);}
   atab[atab_num].assocdx = assoc_dx; /* save assocition index */
   atab[atab_num].acol_num = col_num - 2; //adjust for col_num being > and acol_num being <=
   atab[atab_num].acol_size = 10; /* the default total width of the association */
   fatabnum[assoc_dx] = atab_num;

//printf("In decl_col_names, col_num=%d, atab_num=%d, assoc_dx=%d, flabel=%s, fatabnum=%d\n",
//	   col_num,atab_num, assoc_dx, flabel[assoc_dx],fatabnum[assoc_dx]);

   //integer
   for(i=1; i<col_num; i++)
	  {//printf("col_name[i][0]=%s\n",col_name[i][0]);
	   strcpy(token_list,col_name[i][0]);
	   for(j=1; j<col_name_index[i]; j++)
	       strcat(token_list,col_name[i][j]);
	   address = bitslice;
       bitslice += INT_SIZE;
       if(bitslice > PA_MEM_SIZE*sizeof(int))
		 printf("%d ERROR - parallel memory overflow.\n",linenum);
	   else
	   {cdx = fetch(token_list);
	    if (cdx == FAIL) 
			{em_insert(T_INT,T_PARALLEL,token_list,address,L_INT_SIZE,NOOFW,1,0.0,"CS$");
			cdx = fetch(token_list);}
		if (strcmp(fshape[cdx],"CS$") == 0)
			{tllen = strlen(token_list);
             shape = make_shape(tllen);
		     if ((int) fetch(shape) == FAIL)
			    em_insert(T_CHAR,T_CNST,token_list, (int)shape,0,1,0,0.0,"CS$");
             fshape[cdx] = shape;
		     twidth += tllen;
			 twidth++;}	   
	    else 
			{twidth += shape_size(fshape[cdx]);
			 twidth++;}
		atab[atab_num].symtabdx[i-1] = cdx;
	   }
   }
   //save twdith
   atab[atab_num].acol_size = twidth+1;
}
   
int get_col_type(int i) //type is mode1, int, float, etc.
{char token_list[MAX_TOKEN_SIZE*MAX_NAME_SIZE];
 int j;
 int c_type;
//   printf("In get_col_type(), ");
 strcpy(token_list,col_name[i][0]);
 for(j=1; j<col_name_index[i]; j++)
     strcat(token_list,col_name[i][j]);
	c_type = get_mode1(token_list);
//printf("token_list=%s, c_type=%d\n",token_list,c_type);
  return c_type;
}

int get_col_add(int i)
{char token_list[MAX_TOKEN_SIZE*MAX_NAME_SIZE];
 int j;
//   printf("In get_col_add(), ");
 strcpy(token_list,col_name[i][0]);
 for(j=1; j<col_name_index[i]; j++)
     strcat(token_list,col_name[i][j]);
//printf("token_list=%s\n",token_list);
 return get_add(token_list);
}


void dump_atab()
{int i,j;
 int assoc_dx;

 printf("Dump of atab, atab_num = %d\n",atab_num); 
  for(i=0; i<=atab_num; i++)
  {assoc_dx = atab[i].assocdx;
   printf("Association %s has the following columns:\n",flabel[assoc_dx]);
     for(j=0; j<=atab[i].acol_num; j++)
		 printf("%s at symbol table location %d with shape %s\n",
		 flabel[atab[i].symtabdx[j]], atab[i].symtabdx[j],
		 fshape[atab[i].symtabdx[j]]);
  }
}


/* quadruple is
	T_STORE ca00  handle assoc
*/

void em_store(int mode)
{ int arg1,arg2,tstln;
  long unsigned int lw = 0;
  FILE * lw2;
  int assoc_dx;
  int atabnum;
  int handin;
  int i;
  int mode1;
  int argt, size;
  int arg4 = 0;
  char temp[50];
  int twidth;
  char * shape;

  em_scano_2();     // load 5b00 handle,c0d$ bi_id
  em_carg_2(&arg1,&arg2);
  em_stack_buf();

  mode1 = mode / SIZE_MODE2;
 
//printf("In em_store, noex_bl=%d, arg1=%d, arg2=%d\n",noex_bl, arg1,arg2);
if(noex_bl <= 0)
 {if(strcmp(carg1,"SYSOT") == 0)
     tstln = 1;
  else
    {lw = (unsigned) sc_mem[arg1];
     lw <<= 16;
     lw += (unsigned) sc_mem[arg1+1] & 0xFFFF;
     handin = fileno((FILE *) lw)-NOOFSY; /* adjust for system files*/
     lw2 = filetab[handin].streamot;
     tstln =2;}
//printf("em_store, lw=%x, sc_mem[%d]=%x, sc_mem[%d]=%x\n",
//	   lw,arg1,sc_mem[arg1],arg1+1,sc_mem[arg1+1]);
  assoc_dx = fetch(carg2); // fetch symbol table index of association
  atabnum = fatabnum[assoc_dx]; //and association table number
  //Generate table header
  gen_line_delim(lw2, tstln,atab[atabnum].acol_size);
  for(i=0; i<=atab[atabnum].acol_num; i++)
	{gen_col_delim(lw2, tstln);
//fshape[atab[i].symtabdx[j]]
//flabel[atab[i].symtabdx[j]]
//printf("atab[%d].symtabdx[%d]=%d\n",atabnum,i,atab[atabnum].symtabdx[i]);
//printf("fshape=%s, flabel=%s\n",fshape[atab[atabnum].symtabdx[i]],
//	   flabel[atab[atabnum].symtabdx[i]]);
     //make shape for header
     twidth = shape_size(fshape[atab[atabnum].symtabdx[i]]);
	 if(twidth <= 0)
		  twidth = strlen(flabel[atab[atabnum].symtabdx[i]]);
	 shape = make_head_shape(twidth);
	 if(tstln == 1)
	   printf(shape,flabel[atab[atabnum].symtabdx[i]]);
	 else if(tstln == 2)
	   fprintf(lw2, shape,flabel[atab[atabnum].symtabdx[i]]);
	 else
	   printf("ERROR in print header\n");
	}
  if(tstln == 1)
	 printf("|\n");  
  else if(tstln == 2)
     fprintf(lw2,"|\n");  
  gen_line_delim(lw2, tstln,atab[atabnum].acol_size);

//printf("em_store 1\n");
 papamvun(arg2,IOMASK,1);
 while(em_responders(IOMASK))
 {for(i=0; i<=atab[atabnum].acol_num; i++)
	{gen_col_delim(lw2, tstln);
     // the following is for T_INT only, put switch here for other types
     argt = get_add("TEMP2");
     size = L_INT_SIZE;
     pascmvsx(faddress[atab[atabnum].symtabdx[i]],argt,IOMASK,size);
     strcpy(temp,fshape[atab[atabnum].symtabdx[i]]);
     *(temp+strlen(temp)-2) = 0 ; // skip initial 
	 if(tstln == 1)
	   if(strlen(temp+1) > 2) printf(temp+1,sc_mem[argt]);
		 else printf("%4d ",sc_mem[argt]);  
	 else if(tstln == 2)
	   if(strlen(temp+1) > 2) fprintf(lw2,temp+1,sc_mem[argt]);
		 else fprintf(lw2,"%4d ",sc_mem[argt]);  
	 else
	   printf("ERROR in print header\n");
	}
// printf("em_store 3\n");
	 if(tstln == 1)
		 printf("|\n");  
	 else if(tstln == 2)
         fprintf(lw2,"|\n");  
  gen_line_delim(lw2, tstln,atab[atabnum].acol_size);
  step(IOMASK,IOMASK);
 }
}
}

void gen_col_delim(FILE * lw2, int tstln)
  { if(tstln == 1)
    printf("|");
 else if(tstln == 2)
    fprintf(lw2,"|");
 else printf("ERROR in gen_col_delim\n");
}

void gen_line_delim(FILE * lw2, int tstln, int len)
{ int i;
  if(tstln == 1)
  {for(i=0; i<len; i++) printf("-"); printf("\n");}
 else if(tstln == 2)
 {for(i=0; i<len; i++) fprintf(lw2,"-"); fprintf(lw2,"\n");}
 else printf("ERROR in gen_col_delim\n");
}


char *make_shape(int counter)
{
   char *label;		/* pointer to new label */
   char num[5];		/* string for integer used at the end of label */
   int slen;

   /*if (debug == 2) printf ("In make_shape().........................\n");

   em_itoa(counter, num);
/* printf ("In make_shape().........................1\n"); */
 slen = strlen (num) + 2;
   label = (char *)calloc (slen, sizeof(char));
   if(label == NULL)
	  {printf("In make_shape, out of memory.");
		exit(1);}
// printf ("In make_shape().........................3\n");
   strcpy(label,"%");   
   strcat (label, num);
   strcat (label,"s");
   if (debug == 2) printf ("make_shape() returning : %s\n", label);

   return(label);

} /* end of make_shape() */

char *make_head_shape(int counter)
{
   char *label;		/* pointer to new label */
   char num[5];		/* string for integer used at the end of label */
   int slen;

   if (debug == 2) printf ("In make_head_shape().........................\n");

   em_itoa(counter, num);
// printf ("In make_head_shape().........................1\n"); 
   slen = strlen (num) + 2;
   label = (char *)calloc (slen, sizeof(char));
   if(label == NULL)
	  {printf("In make_head_shape, out of memory.");
		exit(1);}
// printf ("In make_head_shape().........................3\n");
   strcpy (label, "%");
   strcat (label, num);
   strcat (label,"s");
   if (debug == 2) printf ("make_head_shape() returning : %s\n", label);

   return(label);

} /* end of make_head_shape() */

/* extract the width from the shape spec */
/* will work for single digit sizes only */
int shape_size(char * shape)
{int result;
//printf("In shape_size, shape=%s\n",shape);
	result = atoi(shape+2);
//	printf("result = %d\n",result);
	return result;
}

