/* EM_NEW_ARI.C 920225 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "math.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"

/* fixed common left add and subtract- masked */
/* two sizes allow scalar variable to be smaller than parallel */
/* fxcrad2(pa,sc,pa,size1,size2) */
void fxcladsb2(opcode, arg1, arg2, arg3, size1, size2)
int opcode, size1, size2, arg1, arg2, arg3;
{
  int argt, argtt;

  if(opcode == T_SUB)
    {argtt = get_add("TEMP2");
     fxpamin(arg1, argtt, size1);
     inc_pa_perform(-size2*3);}
  else
    argtt = arg1;
  argt = em_stack_temp(size1);
  scpamvmk(arg2,argt,MREG,size2,size1);
  fxpaad(argtt,argt,arg3,size1);
  inc_pa_perform(-size1*2);
  em_pop_temp(size1);
}

/* fixed common right add or subtract - masked */
/* two sizes allow scalar variable to be smaller than parallel */
/* fxcrad2(pa,sc,pa,size1,size2) */
void fxcradsb2(opcode, arg1, arg2, arg3, size1, size2)
int opcode, size1, size2, arg1, arg2, arg3;
{
      int argt, argtt;

      if(opcode == T_SUB)
	{if((argtt = get_add("SC_TEMP")) == FAIL)
	    printf("ERROR - Can't find SC_TEMP.\n");
	 fxscmin(arg2, argtt, size2);
	 inc_pa_perform(-size2*3);}
      else
	 argtt = arg2;
      argt = em_stack_temp(size1);
      scpamvmk(argtt,argt,MREG,size2,size1);
      fxpaad(arg1,argt,arg3,size1);
      inc_pa_perform(-size1*2);
      em_pop_temp(size1);
 }

/* fixed common right add - masked */
/* two sizes allow scalar variable to be smaller than parallel */
/* fxcrad2(pa,sc,pa,size1,size2) */
void fxcrad2(int arg1, int arg2, int arg3, int size1, int size2)
{
      int argt;

      argt = em_stack_temp(size1);
      scpamvmk(arg2,argt,MREG,size2,size1);
      fxpaad(arg1,argt,arg3,size1);
      inc_pa_perform(-size1*2);
      em_pop_temp(size1);
}

/* fixed common right  multiply - masked */
/* two sizes allow scalar variable to be smaller than parallel */
/* fxcrml2(pa,sc,pa,size1,size2) */
void fxcrml2(arg1, arg2, arg3, size1, size2)
int size1, size2, arg1, arg2, arg3;
{
      int argt;

      argt = em_stack_temp(size1);
      scpamvmk(arg2,argt,MREG,size2,size1);
      inc_pa_perform(-size1);
      fxpaml(arg1,argt,arg3,size1);
		em_pop_temp(size1);
}

/* fixed common right divide */
void fxcrdv2(arg1,arg2,arg3,size1, size2)
/* fxcrdv2(pa,sc,pa,size) */
int size1, size2, arg1, arg2, arg3;
{ int argt;

  argt = em_stack_temp(size1);
  scpamvmk(arg2,argt,MREG,size2,size1);
  inc_pa_perform(-size1*2);
  fxpadv(arg1,argt,arg3,size1);
  em_pop_temp(size1);
}

/* fixed common left modulo */
void fxclmd2(arg1,arg2,arg3,size1,size2)
/* fxclmd2(sc,pa,pa,size1,size2) */
int size1,size2, arg1, arg2, arg3;
{ int argt;

  argt = em_stack_temp(size2);
  scpamvmk(arg1,argt,MREG,size1,size2);
  inc_pa_perform(-size2*2);
  fxpadv(argt,arg2,arg3,size2);
  em_pop_temp(size2);
}

/* fixed common left divide */
void fxcldv2(arg1,arg2,arg3,size1,size2)
/* fxcldv2(sc,pa,pa,size1,size2) */
int size1,size2, arg1, arg2, arg3;
{ int argt;

  argt = em_stack_temp(size2);
  scpamvmk(arg1,argt,MREG,size1,size2);
  inc_pa_perform(-size2*2);
  fxpadv(argt,arg2,arg3,size2);
  em_pop_temp(size2);
}

/* fixed common right less than */
/* fxcrlt2(pa,sc,pa,size1,size2) */
void fxcrlt2(arg1, arg2, arg3, size1, size2)
int size1, size2, arg1, arg2, arg3;
{
    int argt;

    argt = em_stack_temp(size1);
	 scpamvmk(arg2,argt,MREG,size2,size1);
    inc_pa_perform(-2*size1);
    fxpalt(arg1,argt,arg3,size1);
    inc_pa_perform(-2*size1);
	 em_pop_temp(size1);
 }


/* fixed common right less than or equal */
/* fxcrle2(pa,sc,pa,size1,size2); */
void fxcrle2(arg1, arg2, arg3, size1, size2)
int size1, size2, arg1, arg2, arg3;
{
    int argt;

    argt = em_stack_temp(size1);
	 scpamvmk(arg2,argt,MREG,size2,size1);
    inc_pa_perform(-2*size1);
    fxpale(arg1,argt,arg3,size1);
    inc_pa_perform(-2*size1);
	 em_pop_temp(size1);
 }

/* fixed common right equal */
/* fxcreq2(pa,sc,pa,size1,size2);*/
/* CHAR fields are left justified, INT fields are right justified.
   scpamvmk right justifies smaller fields in larger fields.
   Thus "char strings" end up in the middle of the field   */
void fxcreq2(int arg1, int  arg2, int  arg3, int size1, int size2)
{
    int argt;

// printf("In fxcreq2 at line %d, size1=%d, size2=%d\n",linenum,size1,size2);
// printf("arg2=%x, %x, %x, %x\n",sc_mem[arg2+3],sc_mem[arg2+2],sc_mem[arg2+1],sc_mem[arg2]);
    argt = em_stack_temp(size1);
    paclrun(argt,size1);
    scpamvmk(arg2,argt,MREG,size2,size1);
/*
 printf("In fxcreq2 at line %d, size1=%d, size2=%d\n",linenum,size1,size2);
 printf("arg2=%x, %x, %x, %x\n",sc_mem[arg2+3],sc_mem[arg2+2],sc_mem[arg2+1],sc_mem[arg2]);
printf("arg1=0,16,32,48\n");
 pdump(arg1,16,T_HEX);
 pdump(arg1+16,16,T_HEX);
 pdump(arg1+32,16,T_HEX);
 pdump(arg1+48,16,T_HEX);
printf("arg2=argt=0,16,32,48\n");
 pdump(argt,16,T_HEX);
 pdump(argt+16,16,T_HEX);
 pdump(argt+32,16,T_HEX);
 pdump(argt+48,16,T_HEX);
*/

    inc_pa_perform(-2*size1);
    fxpaeq(arg1,argt,arg3,size1);
/*
printf("Result of fxpaeq\n");
pdump(arg3,1,T_LOGICAL);
*/
    inc_pa_perform(-2*size1);
    em_pop_temp(size1);
}

/* fixed common right greater than */
/* fxcrgt2(pa,sc,pa,size1,size2) */
void fxcrgt2(arg1, arg2, arg3, size1, size2)
int size1, size2, arg1, arg2, arg3;
{
    int argt;

    argt = em_stack_temp(size1);
	 scpamvmk(arg2,argt,MREG,size2,size1);
    inc_pa_perform(-2*size1);
    fxpagt(arg1,argt,arg3,size1);
    inc_pa_perform(-2*size1);
	 em_pop_temp(size1);
 }


/* fixed common right greater than or equal */
/* fxcrge2(pa,sc,pa,size1,size2); */
void fxcrge2(arg1, arg2, arg3, size1, size2)
int size1, size2, arg1, arg2, arg3;
{
    int argt;

    argt = em_stack_temp(size1);
    scpamvmk(arg2,argt,MREG,size2,size1);
    inc_pa_perform(-2*size1);
    fxpage(arg1,argt,arg3,size1);
    inc_pa_perform(-2*size1);
    em_pop_temp(size1);
}

/* fixed common right not  equal */
/* fxcrne2(pa,sc,pa,size1,size2) */
void fxcrne2(arg1, arg2, arg3, size1, size2)
int size1, size2, arg1, arg2, arg3;
{
    int argt;

    argt = em_stack_temp(size1);
	 scpamvmk(arg2,argt,MREG,size2,size1);
    inc_pa_perform(-2*size1);
    fxpane(arg1,argt,arg3,size1);
    inc_pa_perform(-2*size1);
	 em_pop_temp(size1);
 }

void fxscmd(int arg1, int arg2, int arg3)
{
sc_mem[arg3] = sc_mem[arg1] % sc_mem[arg2];
}

/* converts an asc floating point number into a c floating point
   which is the returned value */
float toc(arg1)
int arg1;
{
  union forx
   { long int fhex;
     float flt_dat;}
  fltint;

  fltint.fhex = 0;
  fltint.fhex = (unsigned) sc_mem[arg1+1] & 0xFFFF;
  fltint.fhex <<=  16;
  fltint.fhex |= (unsigned) sc_mem[arg1] & 0xFFFF;
  return fltint.flt_dat;
}

/* converts a c floating point (arg1) into an asc floating point (arg2) */
int toasc(float f3, int arg3)
{
  long int l1;
  union forx
   { long int fhex;
     float flt_dat;}
  fltint;

  fltint.fhex = 0;
  fltint.flt_dat = f3;
  l1 = (unsigned long)fltint.fhex;
  l1 >>= 16;
  sc_mem[arg3+1] =  l1;
  sc_mem[arg3] =  (unsigned)fltint.fhex;
//  printf("In toasc, fltint.fhex=%x, l1=%x, sc_mem[+1]=%x, sc_mem[]=%x\n",
//	  fltint.fhex,l1,sc_mem[arg3+1],sc_mem[arg3]);
return SUCCESS;
}

void fxpamd(int arg1, int  arg2, int arg3)
{
  int argt,argt1,targ1,targ2,targ3;
  int size1,size2,size3;
  int f1, f2, f3;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating add\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  size1 = get_size(carg1);
  size2 = get_size(carg2);
  size3 = get_size(carg3);

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg1,targ1,argt,size1);
     f1 = sc_mem[targ1];
     pascmv(arg2,targ2,argt,size2);
     f2 = sc_mem[targ2];
     f3 = f1 % f2;
     sc_mem[targ3] = f3;
     scpamvmk(targ3,arg3,argt,size3,size3);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
    }

}

void flpaad(int op, int arg1, int arg2, int arg3)
{
  int argt,argt1,targ1,targ2,targ3;
  int size1,size2,size3;
  float f1, f2, f3;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating add\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  size1 = get_size(carg1);
  size2 = get_size(carg2);
  size3 = get_size(carg3);
  if(op == T_MINUS) size3 = size2;

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg1,targ1,argt,size1);
     f1 = toc(targ1);
     pascmv(arg2,targ2,argt,size2);
     f2 = toc(targ2);
     switch(op)
		 {case T_ADD: f3 = f1+f2; break;
		  case T_SUB: f3 = f1-f2; break;
		  case T_MULT: f3 = f1*f2; break;
		  case T_MINUS: f3 = -f1;  break;
		  case T_MOD: printf("%d ERROR - flpa is an illegal mode for modulo operation\n",linenum); break;
		  case T_DIV: if(f2 != 0) f3 = f1/f2;
		       else {f3 = 0.0;
 printf("%d ERROR - divide by zero, result set to %f\n",linenum,f3);
			  }
						  break;
		  default: printf("%d ERROR - unrecognized floating op %x\n",linenum,op); break;
		  }
     toasc(f3,targ3);
     scpamvmk(targ3,arg3,argt,size3,size3);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
	  }
}

void flcmadd(int op, int arg1, int arg2, int arg3)
{
  int argt,argt1,targ1,targ2,targ3;
  int size1,size2,size3;
  float f1, f2, f3;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating add\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  size1 = get_size(carg1);
  size2 = get_size(carg2);
  if((size3 = get_size(carg3)) == FAIL)
     size3 = size2;

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  f1 = toc(arg1);
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg2,targ2,argt,size2);
     f2 = toc(targ2);
     switch(op)
		 {case T_ADD: f3 = f1+f2; break;
		  case T_SUB: f3 = f1-f2; break;
		  case T_MULT: f3 = f1*f2; break;
		  case T_MINUS: f3 = -f1; break;
		  case T_MOD:  printf("%d ERROR - flcm is an illegal mode for modulo operation\n",linenum); break;
		  case T_DIV: if(f2 != 0.0) f3 = f1/f2;
			      else {f3 = 0.0;
 printf("%d ERROR - divide by zero, result set to %f\n",linenum,f3);
				    }
			      break;
		  default: printf("%d ERROR - unrecognized floating op %x\n",linenum,op); break;
		  }
     toasc(f3,targ3);
     scpamvmk(targ3,arg3,argt,size3,size3);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
	  }
}

/* common right for subtract and divide */
void flcmaddcr(int op, int arg1, int arg2, int arg3)
{
  int argt,argt1,targ1,targ2,targ3;
  int size1,size2,size3;
  float f1, f2, f3;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating add\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  size1 = get_size(carg1);
  size2 = get_size(carg2);
  size3 = get_size(carg3);

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  f1 = toc(arg2);
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg1,targ2,argt,size1);
     f2 = toc(targ2);
     switch(op)
       {case T_SUB: f3 = f2-f1; break;
	case T_MOD:  printf("%d ERROR - flcmcr is an illegal mode for modulo operation\n",linenum); break;
	case T_DIV: if(f1 != 0) f3 = f2/f1;
	  else {f3 = 0.0;
 printf("%d ERROR - divide by zero, result set to %f\n",linenum,f3);
		}
	  break;
	default: printf("%d ERROR - unrecognized floating op %x\n",linenum,op); break;
		  }
     toasc(f3,targ3);
     scpamvmk(targ3,arg3,argt,size3,size3);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
  }
}
/*
fxclmd2(arg1, arg2, arg3)
int arg1, arg2, arg3;
{
  int argt,argt1,targ1,targ2,targ3;
  int size1,size2,size3;
  int f1, f2, f3;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating add\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  size1 = get_size(carg1);
  size2 = get_size(carg2);
  if((size3 = get_size(carg3)) == FAIL)
     size3 = size2;

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  f1 = sc_mem[arg1];
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg2,targ2,argt,size2);
     f2 = sc_mem[targ2];
     f3 = f1 % f2;
     sc_mem[targ3] = f3;
     scpamvmk(targ3,arg3,argt,size3,size3);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
	  }
}
*/

/* common right for modulo */
void fxcrmd2(int arg1, int arg2, int arg3)
{
  int argt,argt1,targ1,targ2,targ3;
  int size1,size2,size3;
  int f1, f2, f3;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating add\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  size1 = get_size(carg1);
  size2 = get_size(carg2);
  size3 = get_size(carg3);

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  f1 = sc_mem[arg2];
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg1,targ2,argt,size1);
     f2 = sc_mem[targ2];
if (f2 < 0 ) printf("%d ERROR - negative argument two %f to mod operation\n",linenum,f2);
if (f1 < 0 ) printf("%d ERROR - negative argument one %f to mod operation\n",linenum,f1);
     f3 = f2 % f1;
     sc_mem[targ3] = f3;
     scpamvmk(targ3,arg3,argt,size3,size3);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
  }
}

void flpacmp(int op, int arg1, int arg2, int arg3)
{
  int argt,argt1,targ1,targ2,targ3;
  int size1,size2,size3;
  float f1, f2;
  int f3;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating add\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  size1 = get_size(carg1);
  size2 = get_size(carg2);
  size3 = get_size(carg3);

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg1,targ1,argt,size1);
     f1 = toc(targ1);
     pascmv(arg2,targ2,argt,size2);
     f2 = toc(targ2);
     switch(op)
		 {case T_LE: f3 = f1<=f2; break;
		  case T_LT: f3 = f1<f2; break;
		  case T_GT: f3 = f1>f2; break;
		  case T_GE: f3 = f1>=f2; break;
		  case T_NE: f3 = f1!=f2; break;
		  case T_EQ: f3 = f1==f2; break;
		  default: printf("%d ERROR - unrecognized floating cmp %x\n",linenum,op); break;
		  }
     sc_mem[targ3] = f3;
     scpamvmk(targ3,arg3,argt,size3,size3);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
	  }
}

void pa_float(int mode1, int arg1, int arg2)
{
  int argt,argt1,targ1,targ2;
  int size1,size2;
  long int l1;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating conversion\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;

  size1 = get_size(carg1);
  size2 = get_size(carg2);

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg1,targ1,argt,size1);
     l1 = 0;
     if(size1 > 16)
       {l1 = (unsigned) sc_mem[targ1+1];
	l1 <<=  16;
	l1 |= (unsigned) sc_mem[targ1];}
      else
       {l1 = (unsigned) sc_mem[targ1];
	l1 <<=  16;
	l1 >>= 16;}
     toasc((float) l1, targ2);
     scpamvmk(targ2,arg2,argt,size2,size2);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
     }
}

/* convert scalar int asc (arg1) to floating asc (arg2) */
void sc_float(int mode1, int arg1, int arg2)
{
  int size1,size2;
  float f1;
  long int l1;

  size1 = get_size(carg1);
  /* INT_SIZE is 32 */
  if(mode1 == T_LONGINT && size1 < INT_SIZE) size1 = INT_SIZE;
  size2 = get_size(carg2);
  l1 = 0;
  if(size1 > 16)  
	{l1 = (unsigned) sc_mem[arg1+1];
	 l1 <<=  16;
	 l1 |= (unsigned) sc_mem[arg1];
 	 }
  else if ( size1 < 16)
     l1 = sc_mem[arg1];
  else if (size1 == 16)
	{if(sc_mem[arg1] & 0x8000)
		{l1 = -1;
		 l1 <<= 16;
	     l1 |= (unsigned) sc_mem[arg1];
		}
	 else
	    l1 = (unsigned) sc_mem[arg1];
	}

//  printf("In sc_float, size1=%d, sc_mem[]=%x, l1=%x",size1, sc_mem[arg1],l1);
  
  f1 = (float) l1; //cast to avoid warning, but data may be lost
//  printf(", f1=%f\n",f1);
   toasc(f1,arg2);
}
/* convert scalar floating asc to int asc */
int sc_fix(int arg1, int arg2)
{
  int size1,size2;
  float f1;
  long int l1,l2;
  union forx {
		long int fhex;
		float flt_dat;}
	fltint;

  size1 = get_size(carg1);
  size2 = INT_SIZE;
  put_size(carg2,size2);

     l1 = 0;
     l1 = (unsigned) sc_mem[arg1+1];
     l1 <<=  16;
     l1 |= (unsigned) sc_mem[arg1];
     fltint.fhex = l1;
     f1 = fltint.flt_dat;
     l2 = 0;
     l2 = (long) f1;  //cast to avoid warning, but data may be lost
     sc_mem[arg2] =  (unsigned) l2;
     l1 = (l2>>16) & (255 | 255<<8);
     sc_mem[arg2+1] = 0;
     if(size2 > 16)
	 sc_mem[arg2+1] = (unsigned) l1;

  return SUCCESS;
}

/* common  left */
/* common right switches arguments */
/* flpacmp(op, sc, pa, pa) */
void flcmcmp(int op, int arg1, int arg2, int arg3)
{
  int argt,argt1,argt2,targ1,targ2,targ3;
  int size1,size2,size3;
  float f1, f2;
  int f3;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  argt2 = get_add("TEMP4");
 if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating add\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  size1 = get_size(carg1);
  size2 = get_size(carg2);
  size3 = get_size(carg3);

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  f1 = toc(arg1);
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg2,targ2,argt,size2);
     f2 = toc(targ2);
     switch(op)
		 {case T_LE: f3 = f1<=f2; break;
		  case T_LT: f3 = f1<f2; break;
		  case T_GT: f3 = f1>f2; break;
		  case T_GE: f3 = f1>=f2; break;
		  case T_NE: f3 = f1!=f2; break;
		  case T_EQ: f3 = f1==f2; break;
		  default: printf("%d ERROR - unrecognized floating cmp %x\n",linenum,op); break;
		  }
     sc_mem[targ3] = f3;
     scpamvmk(targ3,arg3,argt,size3,size3);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
	  }
}


void flscad(int op, int arg1, int arg2, int arg3)
{
  float f1, f2, f3;

  f1 = toc(arg1);
  f2 = toc(arg2);
     switch(op)
		 {case T_ADD: f3 = f1+f2; break;
		  case T_SUB: f3 = f1-f2; break;
		  case T_MULT: f3 = f1*f2; break;
		  case T_MINUS: f3 = -f1; break;
		  case T_MOD:  printf("%d ERROR - flsc is an illegal mode for modulo operation\n",linenum); break;
		  case T_DIV: if(f2 != 0) f3 = f1/f2;
			      else {f3 = 0.0;
 printf("%d ERROR - divide by zero, result set to %f\n",linenum,f3);
			  }
						  break;
		  default: printf("%d ERROR - unrecognized floating op %x\n",linenum,op); break;
		  }
 toasc(f3,arg3);
 return;
}

/* flsccmp(op, sc, sc, sc) */
void flsccmp(int op, int arg1, int arg2, int arg3)
{
  float f1, f2;
  int f3;

  f1 = toc(arg1);
  f2 = toc(arg2);
  switch(op)
	 {case T_LE: f3 = f1<=f2; break;
	  case T_LT: f3 = f1<f2; break;
	  case T_GT: f3 = f1>f2; break;
	  case T_GE: f3 = f1>=f2; break;
	  case T_NE: f3 = f1!=f2; break;
	  case T_EQ: f3 = f1==f2; break;
	  default: printf("%d ERROR - unrecognized floating cmp %x\n",linenum,op); break;
	  }
  sc_mem[arg3] =  f3;
}

/* routine to convert parallel char to int */
int pa_chrcnv(int arg1, int arg2, int size)
{
printf("In pa_chrcnv\n");
pdump(arg1,size,T_CHAR);
pdump(arg1,size,T_INT);
/*
  if(SIZE_HOST == 16)
    {iend = size/SIZE_HOST;
     if(size % SIZE_HOST != 0)
       {for(i=0; i<iend; i++)
			 {sc_mem[arg2+i] = sc_mem[arg1+i]>>CHAR_SIZE;
			  sc_mem[arg2+i] |= sc_mem[arg1+i+1]<<CHAR_SIZE;}
		  sc_mem[arg2+iend] = sc_mem[arg1+iend]>>CHAR_SIZE;}
	  else
		 for(i=0; i<iend+1; i++)
			  sc_mem[arg2+i] = sc_mem[arg1+i];
	  }
  else
	 printf("ERROR - SIZE_HOST != 16 in em_chrcnv\n");
*/
  return(SUCCESS);
}

/* floating parallel sum */
int flpasm(int arg1, int arg2)
{
  int argt,argt1,targ1;
  int size1;
  float f1,f2;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  targ1 = get_add("SC_TEMP");
  size1 = get_size(carg1);

  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  f2 = 0;
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg1,targ1,argt,size1);
     f1 = toc(targ1);
     f2 += f1;
     step(argt1,argt1);
     papamvun(argt1,argt,1);
  }
 toasc(f2,arg2);
 return 0;
}

double sin();
int sc_sin(int arg1, int arg2)
{
  float f1, f2;
  double d1, d2;

  f1 = toc(arg1);
  d1 = f1;
  d2 = sin(d1);
  f2 = (float) d2; // cast to avoid warning, data may be lost
  toasc(f2,arg2);
  return SUCCESS;
}

double cos();
int sc_cos(int arg1, int arg2)
{
  float f1, f2;
  double d1, d2;

  f1 = toc(arg1);
  d1 = f1;
  d2 = cos(d1);
  f2 = (float) d2;  // cast to avoid warning, data may be lost
  toasc(f2,arg2);
  return SUCCESS;
}

double exp();
int sc_exp(int arg1, int arg2)
{
  float f1, f2;
  double d1, d2;

  f1 = toc(arg1);
  d1 = f1;
  d2 = exp(d1);
  f2 = (float) d2;  // cast to avoid warning, data may be lost
  toasc(f2,arg2);
  return SUCCESS;
}

// dummy routine if stdlib rand function not available
int sc_rand(int arg2)
{
  long d2;

  d2 = rand();
  toascl(arg2,d2); /* convert to long asc */
  return SUCCESS;
}


double pow();
int sc_power(int arg1, int arg2, int arg3)
{
  float f1, f2, f3;
  double d1, d2, d3;

  /* initialize local variables */
 f1 = 0.0;
 f2 = 0.0;
 f3 = 0.0;
 d1 = 0.0;
 d2 = 0.0;
 d3 = 0.0;

  f1 = toc(arg1);
  d1 = f1;
  f2 = toc(arg2);
  d2 = f2;
  if(d1 >= 0.0)
     d3 = pow(d1,d2);
  else printf("%d ERROR - Pow can not raise a negative number %f\n",
	       linenum,d1);

  f3 = (float) d3;  // cast to avoid warning, data may be lost
  toasc(f3,arg3);

  return SUCCESS;
}

double sqrt();
int sc_sqrt(int arg1, int arg2)
{
  float f1, f2;
  double d1, d2;

  f1 = toc(arg1);
  d1 = f1;
  if(d1 >= 0.0) d2 = sqrt(d1);
  else
     {printf("%d ERROR - can't sqrt a negative number %f\n",linenum,d1);
      d2 = 0.0;}
  f2 = (float) d2;  // cast to avoid warning, data may be lost
  toasc(f2,arg2);
  return SUCCESS;
}

/* pa_iterate iterates over parallel fields for internal functions. */
/* T_EXP and T_SQRT use arg1 (input) and arg3 (output)
   T_POWER uses arg1, arg2 (inputs) and arg3 (output)
   T_RAND uses arg3 (output)
*/
int pa_iterate(int opcode, int arg1, int arg2, int arg3, int size1, int size2)
{
  int argt,argt1,targ1,targ2,targ3;
  int result;

  argt = get_add("TEMP2");
  argt1 = get_add("TEMP3");
  if(SC_MEM_SIZE < 6)
	 printf("%d ERROR - insufficient sc temps for floating conversion\n",linenum);
  targ1 = get_add("SC_TEMP");
  targ2 = targ1+2;
  targ3 = targ1+4;

  if((size1 > 32) | (size2 > 32))
    {printf("%d ERROR - oversized scalar %d %d in pa_iterate\n",
     linenum,size1,size2);
     return FAIL;}
  papamvun(MREG,argt,1);
  papamvun(MREG,argt1,1);
  while(em_responders(argt) == TRUE)
    {resvfst(argt);
     pascmv(arg1,targ1,argt,size1);
     switch(opcode)
      {case T_POWER:
	    pascmv(arg2,targ2,argt,size2);
	    result = sc_power(targ1, targ2, targ3); break;
       case T_EXP:   result = sc_exp(targ1, targ3); break;
       case T_SQRT:  result = sc_sqrt(targ1, targ3); break;
       case T_COS:   result = sc_cos(targ1, targ3); break;
       case T_SIN:   result = sc_sin(targ1, targ3); break;
       case T_FIX:   result = sc_fix(targ1, targ3); break;
       case T_RAND:  result = sc_rand(targ3); break;
       default: printf("%d ERROR - unrecognized opcode %x in pa_functions\n",
		       linenum,opcode);
      }
     scpamvmk(targ3,arg3,argt,size2,size2);
     step(argt1,argt1);
     papamvun(argt1,argt,1);
     }
return result;
}
