/* EM_QUADS.C 910415  */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"

/* IN ALL OF THE ROUTINES IN THIS MODULE:
      arg1,arg2,.. are the numeric addresses of the variable
      carg1,carg2,.. are the symbolic names of the variables  */

void em_subroutine()
{
   em_scano_1();
}

char *tolowers(char *arg)
{
  char *sarg;

  sarg = arg;
  while(*arg != 0)
	 {if(isupper(*arg) != 0) *arg = tolower(*arg); arg++;}
  return(sarg);
}

void em_call()
{int i, arg1;

 em_scano_2();
 em_carg_1(&arg1);
 sprintf((char *) buffer_bl,"%15s %x 1 %s",code_bl,command_bl,carg2);
 em_stack_buf();
if(em_debug == 12)
   {printf("Entering em_call() %s with noex_bl=%d, save_bl=%d, called=%d\n",
		      carg2,noex_bl,save_bl,called);
    printf("     in_sub=%d, quad_bl=%d, toqs_bl=%d quads_sc=",in_sub,quad_bl,toqs_bl);
for(i=0; i<NOOFSTK; i++)printf(" %d,",quads_sc[i]);
printf("\n");
   }
 if(noex_bl <= 0)
   {strcpy(sub_file,tolowers(carg2));
    strcat(sub_file,".iob");
/*printf("Before push_sub, toqs_bl=%d, quad_bl=%d, quad_dx=%d\n",
	toqs_bl, quad_bl, quad_dx);*/
    push_sub(arg1);/* arg1=0 if from source, 1 if from stack */
    if(source_bl == INPUT) save_bl++;
   }
 if(em_debug == 34)
	{for(i=0; i<in_sub; i++) printf(".");
	 printf("Calling %s\n",sub_file);}
if(em_debug == 12)
     {printf("Exiting em_call() with noex_bl=%d, save_bl=%d, called=%d\n",
		      noex_bl,save_bl,called);
      printf("     in_sub=%d, quad_bl=%d, toqs_bl=%d\n",in_sub,quad_bl,toqs_bl);}
}

void em_include()  /* Generate system includes and defines */
{
/* Do nothing for now */
}

void em_return()
{
   em_scano_0();
   printf("ERROR - illegal return in emulation mode.\n");
}


void em_entry()
{
   em_scano_1();
}


void em_extrn()
{
   em_scano_1();
}


void em_scareg()
{
   em_scano_0();
}

void em_regsca()
{
  em_scano_0();
}


void em_mindex()
{
   int arg1,arg2,size;

   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
   if(noex_bl <= 0)
     { size = get_size(carg1);
       mindex(arg1,arg2,MREG,size);   }
}


void em_minval()
{
   int arg1,arg2,size;

   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
   if(noex_bl <= 0)
     { size = get_size(carg1);
       put_size(carg2,size);
       minval(arg1,arg2,MREG,size);   }

}


void em_maxdex()
{
   int arg1,arg2,size;

   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
   if(noex_bl <= 0)
     { size = get_size(carg1);
       maxdex(arg1,arg2,MREG,size);   }

}


void em_maxval()
{
   int arg1,arg2,size;

   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
   if(noex_bl <= 0)
     {size = get_size(carg1);
      put_size(carg2,size);
      maxval(arg1,arg2,MREG,size);   }

}

void em_nthval()
{
   int arg1,arg2,arg3,argt,argt1,size,i;

   em_scano_3();
   em_carg_3(&arg1,&arg2,&arg3);
   em_stack_buf();
   if(noex_bl <= 0)
     { argt = get_add("TEMP3");
		 argt1 = get_add("TEMP4");
		 papamvun(MREG,argt,1);
		 size = get_size(carg1);
       put_size(carg2,size);
       for(i=0; i<sc_mem[arg3]-1; i++)
	  {mindex(arg1,argt1,argt,size);
			  lgpaxor(argt1,argt,argt,1);   }
		 minval(arg1,arg2,argt,size);
	  }

}

void em_nthdex()
{
   int arg1,arg2,arg3,argt,argt1,size,i;

   em_scano_3();
   em_carg_3(&arg1,&arg2,&arg3);
   em_stack_buf();
   if(noex_bl <= 0)
	 {  argt = get_add("TEMP3");
		 argt1 = get_add("TEMP4");
		 papamvun(MREG,argt,1);
		 size = get_size(carg1);
       put_size(carg2,size);
       for(i=0; i<sc_mem[arg3]; i++)
	  {mindex(arg1,argt1,argt,size);
			  lgpaxor(argt1,argt,argt,1);  }
		 papamvun(argt1,arg2,1);
	  }

}

void em_resfst()
{
  int arg1,arg2;

   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
   if(noex_bl <= 0)
     {papamvun(arg1,arg2,1);
      put_size(carg2,1);
      resvfst(arg2);  }

}

void em_stack_scope()
{
   int arg1;

   em_scano_1();
   em_carg_1(&arg1);
   em_stack_buf();
   if(noex_bl <= 0)
     {papamvun(arg1,MREG,1);
      em_stack(MREG); }
}

void em_stack_gen(int mode)
{
   int arg1,size1;
   int mode1,mode2;

   mode1 = mode / SIZE_MODE2;
   mode2 = mode % SIZE_MODE2;
   em_scano_1();
   size1 = em_carg_1(&arg1);
   em_stack_buf();
   if(noex_bl_sk <= 0)
     if(mode2 == T_PARALLEL)
       em_stack_field(arg1,size1);
     else em_stack_sc(arg1);
}

/* the parallel stack -field */
void em_stack_field(int arg1, int size1)
{
//  printf("in em_stack_field, size1=%d, emptys=%d, fillds=%d\n",size1,emptys,fillds);
  emptys -= size1; fillds -= size1;
  papamvun(arg1,fillds,size1);
  if(emptys <= bitslice)
    {printf("ERROR - array stack overflow.\n");
     printf("line number %d, quadruple %s %4x\n",linenum,code_bl,&command_bl);
    }
}

/* the parallel stack - temp */
int em_stack_temp(int size1)
{
//  printf("in em_stack_temp, size1=%d, emptys=%d, fillds=%d\n",size1,emptys,fillds);
  emptys -= size1; fillds -= size1;
  if(emptys <= bitslice)
    {printf("ERROR - array temp stack overflow.\n");
     printf("line number %d, quadruple %s %4x\n",linenum,code_bl,&command_bl);
    }
  return(fillds);
}

/* the parallel stack - registers and flags */
void em_stack(int arg1)
{
//  printf("in em_stack, emptys=%d, fillds=%d\n",emptys,fillds);
      papamvun(arg1,emptys--,1); fillds--;
      if(emptys <= bitslice)
	{printf("ERROR - array flag stack overflow.\n");
	 printf("line number %d, quadruple %s %4x\n",linenum,code_bl,&command_bl);
	 printf(" emptys=%d, bitslice=%d\n",emptys,bitslice);
	}
}

void em_stack_sc(int arg1)
{
  int size,i;

  size = get_size(carg1);
  for(i=0; i<((size-1)/SIZE_HOST)+1; i++)
     sc_mem[--sc_mem_size] = sc_mem[arg1+i];

  if (tosm_bl >= sc_mem_size)
    {printf("ERROR - scalar memory overflow, adjust SC_MEM_SIZE \n");
     printf("line number %d, quadruple %s %4x\n",linenum,code_bl,&command_bl);}

}

void em_pop_scope()
{
   em_scano_0();
   em_stack_buf();
   if(noex_bl <= 0)
     {  papamvun(++fillds,MREG,1); emptys++;
	if(fillds > TOM)
	 {printf("ERROR - array stack underflow. Logic error.\n");
	  printf("line number %d, quadruple %s %4x\n",linenum,code_bl,&command_bl);}
     }
 }


/* The parallel pop -registers and flags */
void em_pop(int arg1)
{
  papamvun(fillds++,arg1,1); emptys++;
  if(fillds > TOM)
     {printf("ERROR - array stack underflow. Logic error.\n");
      printf("line number %d, quadruple %s %4x\n",linenum,code_bl,&command_bl);}
}

void em_poprc(int mode)
{
   int arg1,arg2,size1;
   int mode1,mode2;

   mode1 = mode / SIZE_MODE2;
   mode2 = mode % SIZE_MODE2;
   em_scano_2();
   em_carg_2(&arg1,&arg2);
	size1 = get_size(carg2);
   em_stack_buf();
   if(noex_bl_sk <= 0 && sc_mem[arg1] >= STACK_STOP)
     if(mode2 == T_PARALLEL) em_pop_field(arg2,size1);
	  else em_pop_sc(arg2);
}

void em_pop_gen(int mode)
{
   int arg1,size1;
   int mode1,mode2;

   mode1 = mode / SIZE_MODE2;
   mode2 = mode % SIZE_MODE2;

   em_scano_1();
   em_carg_1(&arg1);
	size1 = get_size(carg1);
   em_stack_buf();
   if(noex_bl_sk <= 0 )
     if(mode2 == T_PARALLEL) em_pop_field(arg1,size1);
	  else em_pop_sc(arg1);
}


/* The parallel pop - fields*/
void em_pop_field(int arg1, int size1)
{
  papamvun(fillds,arg1,size1);
  fillds += size1;  emptys += size1;
  if(fillds > TOM)
     {printf("ERROR - array stack underflow. Logic error.\n");
      printf("%d %s, quadruple %s %4x\n",linenum,&sub_file_stack[in_sub][0],
							code_bl,&command_bl);}
}

/* The parallel pop - temp*/
void em_pop_temp(int size1)
{
  fillds += size1;  emptys += size1;
  if(fillds > TOM)
     {printf("ERROR - array stack underflow. Logic error.\n");
      printf("%d %s, quadruple %s %4x\n",linenum,&sub_file_stack[in_sub][0],
							code_bl,&command_bl);}
}

void em_pop_sc(int arg1)
{
  int size,i;

  size = get_size(carg1);
  for(i=((size-1)/SIZE_HOST); i>=0; i--)
    sc_mem[arg1+i] = sc_mem[sc_mem_size++];

  if (sc_mem_size >SC_MEM_SIZE)
    printf("ERROR - scalar memory underflow.\n");
}

/* ===========================================================================

   function name: em_end
   input               : ---
   output           : ---
   return value : ---

   global vars  : ---

   description   : This routine handles the 'end' intermediate opcode.

=========================================================================== */

void em_end()
{
   em_scano_1();
   printf("END quadruple detected. \n");
}

/* ===========================================================================

   function name: em_assemble
   input               : ---
   output           : ---
   return value : ---

   global vars  : input_fp      - pointer to input file

   description   : This routine handles the 'asmcode' intermediate opcode.
			    The single argument is printed on the listing file
			    unchanged.

=========================================================================== */

void em_assemble()
{
   char arg[LINE_LENGTH];       /* buffer of assembly language code */
   int i;                                /* buffer index */

   getc(input_fp);                 /* ignore additional single blank written to
						  object file by 'genicode' */
   i = 0;
   while ((arg[i++] = getc(input_fp)) != '\n')
      ;

//   arg[i-1] = '\0';  020505
   arg[i-1] = 0;  
   em_print_err(NOT_IMPLEMENTED,6);

}

/* ===========================================================================

   function name: em_stop
   input               : ---
   output           : ---
   return value : ---

   global vars  : ---

   description   : This routine handles the 'stop' intermediate opcode.

=========================================================================== */

void em_stop()
{
     em_scano_0();
     em_stack_buf();
     if(noex_bl <= 0)
       {if(table_parse == FALSE) printf("STOP quadruple detected. \n");
/*        printf("linenum=%d, routine=",linenum);
       printf(" %s\n",&sub_file_stack[in_subs[in_sub]][0]);
	dumpstack();*/
	     em_exit(1);
	 }
}

void dumpstack()
{int i,j;

/*  dump to print quadruple stacks */
//020505     if(*sub_file != '\0') printf("In subroutine %s\n",sub_file);
     if(*sub_file != 0) printf("In subroutine %s\n",sub_file);
			else printf("In main program\n");
     for(j=0;j<NOOFSTK;j++)
      {printf("Quadruple stack[%d]=\n",j);
		 for(i=0;i<30;i++)
			printf("###%s\n",(*quads_stk[j]).qpnt[i]);}
	  for(i=in_sub; i>= 0; i--)
		 printf("sub_stack[%d]=%s\n",i,&sub_file_stack[in_subs[i]][0]);
       printf("quad_dx quad_bl quad_sc toqs_bl routine\n");
       for(i=0; i<NOOFSTK; i++)
	  {printf("%7d %7d %7d %7d %s\n",quads_dx[i],quads_bl[i],quads_sc[i],
					     toqss_bl[i], &sub_file_stack[in_subs[i]][0]);}
       printf("                        %s\n",&sub_file_stack[in_subs[in_sub]][0]);
printf("sub_file_stack sub_stk sub_toqs, stack_cnt=%d \n",stack_cnt);
for(i=0; i<stack_cnt; i++)
   printf("%14s %7d %7d\n",&sub_file_stack[i][0],sub_stk[i],sub_toqs[i]);

}

/* ===========================================================================

   function name: em_label
   input               : ---
   output           : ---
   return value : ---

   global vars  : ---

   description   : This routine handles the 'label' intermediate opcode.
			    The assembly language which is generated will cause
			    a statement with a label to be printed.

=========================================================================== */

void em_label()
{
   em_scano_1();
}

/* ===========================================================================

   function name: em_setscope
   input               : ---
   output           : ---
   return value : ---

   global vars  : ---

   description   : This routine handles the 'setscope' intermediate opcode.
			    The assembly language which is generated will cause
			    a label to be generated to mark the beginning of a control
			    statement and will cause the scope stack to be accessed
			    in order to set the scope of the control statement.

=========================================================================== */
void em_setscope()
{
  em_scano_1();
  em_stack_buf();
  if(noex_bl <= 0) papamvun(fillds,MREG,1);
}

/* ===========================================================================

   function name: em_ident
   input               : ---
   output           : ---
   return value : ---

   global vars  : input_fp      - pointer to input file

   description   : This routine handles the 'ident' intermediate opcode.
			    The assembly code which is generated will identify the
			    module name and define fields for the Common register for
			    system use.

=========================================================================== */

void em_ident()
{
 }

/* ===========================================================================

   function name: em_clrarray
   input               : ---
   output           : ---
   return value : ---

   global vars  : ---

   description   : This routine handles the 'clr_array' intermediate opcode.
			    The assembly language which is generated will clear all
			    fields of the array memory.

=========================================================================== */

void em_clrarray()
{
  int p,i;

  for (i=0; i<PA_MEM_SIZE; i++)
    for (p=0; p<NOOFW; p++) pa_mem[p][i]=0;
}

/* ===========================================================================

   function name: em_initstack
   input        : ---
   output           : ---
   return value : ---

   global vars  : input_fp      - pointer to input file

   description   : This routine handles the 'init_stack' intermediate opcode.
			    The assembly language which is generated will initialize
			    the top of the parallel stack to be a vector of all ones.

=========================================================================== */

void em_initstack()
{
  int p,fls,tru,mr;

  tru = get_caddo("TRUE$");
  fls = get_caddo("FALSE$");
  mr = get_caddo("MREG");

   for (p=0; p<NOOFW; p++)
    {pa_mem[p][fls] = 0;
     pa_mem[p][tru] = -1;
    };

  lgpaxor(tru,get_add("THE"),tru,1); /* necessary to eliminate THE on top of stack */
  papamvun(tru,mr,1);
  papamvun(tru,fillds,1);
  sc_mem[get_add("SC_PERFORM")]=0;
  sc_mem[get_add("PA_PERFORM")]=0;
  sc_mem[get_add("PERFORM")]=0;
}


void em_main(int mode)
{ int i;

  em_scano_1();
  strcpy(sub_file,tolowers(carg1));
  strcat(sub_file,".iob");
  in_sub = 0;
  called = 0;
  strcpy(&sub_file_stack[in_subs[in_sub]][0],sub_file);
  sub_stack[in_sub] = input_fp;
  source_bl=INPUT;
  quad_dx=0;
  quad_bl=0;
  save_bl=0;
  noex_bl=0;
  tols_bl=0;
  toqs_bl=0;
  tosm_bl=0;
  gbl_bl =0;
  stack_cnt=0;
  noex_bl_sk=0;
  noex_bl_ext=0;
  in_subs[in_sub] = stack_cnt++;
  sub_toqs[in_subs[in_sub]] = toqs_bl;
  sub_stk[in_subs[in_sub]] = quad_dx;
  for(i=0; i<SUB_DEPTH; i++) sav_toqs[i]=0;
  strcat(sub_file,"INPUT");
  sc_mem_size = SC_MEM_SIZE; /* init top of sc memory */
  emptys = TOM-1;
  fillds = TOM;
  em_insert(T_REAL,T_SCALAR,"CREAL",0,32,1,1,0.0,"CS$");
  em_insert(T_INT,T_SCALAR,"CINT",0,32,1,1,0.0,"CS$");
  em_insert(T_LOGICAL,T_SCALAR,"CLOG",31,1,1,1,0.0,"CS$");
  em_insert(T_INT,T_SCALAR,"SC_TEMP",tosm_bl,SC_MEM_SIZE,1,1,0.0,"CS$");
  tosm_bl+=((SC_TEMP_SIZE-1)/SIZE_HOST)+1;
  em_insert(T_LOGICAL,T_PARALLEL,"MREG",PA_MEM_SIZE-1,1,NOOFW,1,0.0,"CS$");
  em_insert(T_INT,T_PARALLEL,"TEMP",PA_MEM_SIZE-INT_SIZE-2,INT_SIZE,1,0,0.0,"CS$");
  em_insert(T_INT,T_PARALLEL,"TEMP2",PA_MEM_SIZE-2*INT_SIZE-2,INT_SIZE,1,0,0.0,"CS$");
  em_insert(T_INT,T_PARALLEL,"TEMP3",PA_MEM_SIZE-3*INT_SIZE-2,INT_SIZE,1,0,0.0,"CS$");
  em_insert(T_INT,T_PARALLEL,"TEMP4",PA_MEM_SIZE-4*INT_SIZE-2,INT_SIZE,1,0,0.0,"CS$");
  em_insert(T_INT,T_PARALLEL,"TEMP5",PA_MEM_SIZE-5*INT_SIZE-2,INT_SIZE,1,0,0.0,"CS$");
if(em_debug)
  {printf("variable emptys is located at %d\n",emptys);
   printf("variable fillds is located at %d\n",fillds);
   printf("variable MREG   is located at %d\n",PA_MEM_SIZE-1);
   printf("variable TEMP is located at %d\n",PA_MEM_SIZE-INT_SIZE-2);
   printf("variable TEMP2 is located at %d\n",PA_MEM_SIZE-2*INT_SIZE-2);
   printf("variable TEMP3 is located at %d\n",PA_MEM_SIZE-3*INT_SIZE-2);
   printf("variable TEMP4 is located at %d\n",PA_MEM_SIZE-4*INT_SIZE-2);
   printf("variable TEMP5 is located at %d\n",PA_MEM_SIZE-5*INT_SIZE-2);
   printf("variable IOMASK is located at %d\n",IOMASK);
   printf("variable IOSTACK is located at %d\n",IOSTACK);
   printf("variable GLOBAL_BI is located at %d\n",GLOBAL_BI);}
}


void em_endmain()
{
  em_scano_1();
  printf("PROCESSING TERMINATED.\n");
}


void em_endsub()
{
 int i, arg1;

if(em_debug == 12)
   {printf("Entering endsub() from %s with noex_bl=%d, save_bl=%d, called=%d\n",
		      &sub_file_stack[in_subs[in_sub]][0],noex_bl,save_bl,called);
    printf("     in_sub=%d, quad_bl=%d, toqs_bl=%d quads_sc=",in_sub,quad_bl,toqs_bl);
    for(i=0; i<NOOFSTK; i++)printf(" %d,",quads_sc[i]);
    printf("\n");
	}

 em_scano_2();
 em_carg_1(&arg1);
 if(noex_bl > 0) printf("ERROR - exiting from a non executing subroutine\n");
 if(em_debug == 34)
	{for(i=0; i<in_sub; i++) printf(".");
	 printf("Exiting %s\n",&sub_file_stack[in_subs[in_sub]][0]);}
 if(arg1 <= 0)
	{sprintf((char *) buffer_bl,"%15s %x 1 %s",code_bl,command_bl,carg2);
	 em_stack_buf();
	 fclose(input_fp);}
/*printf("Before pop_sub, toqs_bl=%d, quad_bl=%d, quad_dx=%d\n",
	toqs_bl, quad_bl, quad_dx);*/
 if(source_bl == INPUT)  save_bl--;
 pop_sub();
if(em_debug == 12)
     {printf("Exiting endsub() with noex_bl=%d, save_bl=%d, called=%d\n",
		      noex_bl,save_bl,called);
      printf("     in_sub=%d, quad_bl=%d, toqs_bl=%d\n",in_sub,quad_bl,toqs_bl);
     }
}

/* entered from em_comma, probably should be moved to em_c_stm.c to
   be consistent with control aspects of "any"
*/
void em_allocate(int mode)
{
   int arg1,arg2,arg3;
   int mode2;

   mode2 = mode % SIZE_MODE2;
   if(mode2 == T_THE)
     {em_scano_1();
      em_carg_1(&arg1);
      em_stack_buf();
      if(noex_bl > 0) return;
      talloc(arg1);}
   else
     {em_scano_3();
      em_carg_3(&arg1,&arg2,&arg3);
      em_stack_buf();
      /* mode2 is set to T_ALLDIMP in T_ALLOC used in T_DIMP
	 these T_ALLOCs do not have a terminating T_ENDALLOC */
      if(mode2 == T_ALLDIMP)
	{if(noex_bl <= 0)
	   balloc(arg1,arg2,sc_mem[arg3]);}
      else
	if(noex_bl > 0)
	   noex_bl++;
	else
	   if (balloc(arg1,arg2,sc_mem[arg3]) == FAIL)
	      noex_bl++;

    }
 }

/* was global = global .and. (.not. arg1 .and. arg2)
   changed to   global = global .and. .not. (arg1 .and. arg2)
   global is one if the cell is in use!
*/
void em_release()
{
   int arg1,arg2,argg,argt;

   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
   if(noex_bl > 0) return;
   argg = get_add("GLOBAL_BI$");
   argt = get_add("TEMP");
   lgpaand(arg1,arg2,emptys,1);
   lgpanot(emptys,emptys,1);
   lgpaand(emptys,argg,argg,1);
   lgpanot(arg1,emptys,1);
   lgpaand(emptys,arg2,arg2,1);
   return;
 }

void em_bos()
/* beginning of statement quadruple */
{
     int arg1,arg2;

     em_scano_2();
     em_carg_2(&arg1,&arg2);
     em_stack_buf();
	  linenum = arg1;   /* set linenum for error messages */
     if(noex_bl <=0)
       if(arg2 != 0)
	       if(em_debug == arg2) em_debug = 0; else em_debug = arg2;

    if(em_debug == 1)
	  printf("End bos line number %d, arg1,2=%d,%d. em_debug=%d\n",
		   linenum,arg1,arg2,em_debug);
}

#define C_BLANK 32
void em_msg()
{
   char arg[LINE_LENGTH];       /* buffer of assembly language code */
   char chan[LINE_LENGTH];
	char code_bl[LINE_LENGTH];
	char *ptr;
   int i;                       /* buffer index */
   long int lw;
   FILE *lw2;
   int handin;

  if(source_bl == STACK)
	 {sscanf((*quads_stk[quad_dx]).qpnt[quad_bl],"%15s %x %s",code_bl,&command_bl,chan);
     ptr = (*quads_stk[quad_dx]).qpnt[quad_bl++]+20;
     while (*ptr++ == C_BLANK);
     while (*ptr++ != C_BLANK);}
  else
    {getc(input_fp);            /* ignore additional single blank written to*/
	  i = 0;                         /* object file by 'genicode' */
     while ((chan[i++] = getc(input_fp)) != ' ');
//	  chan[i-1] = '\0';  020505
	  chan[i-1] = 0;
	  i = 0;
     while ((arg[i++] = getc(input_fp)) != '\n');
 //    arg[i-1] = '\0'; 020505
     arg[i-1] = 0;
     sprintf((char *) buffer_bl,"%15s %4x %10s %s","T_MSG",T_MSG,chan,arg);
	  ptr=arg;
     em_stack_buf();
    }
	if(noex_bl <= 0)
     if(strcmp(chan,"SYSOT") == 0)
		 printf("%s",ptr);
	  else
       {lw = (unsigned) sc_mem[get_caddo(chan)];
	lw <<= 16;
	lw += (unsigned) sc_mem[get_caddo(chan)+1] & 0xFFFF;
	handin = fileno((FILE *) lw)-NOOFSY; /* adjust for system files*/
	lw2 = filetab[handin].streamot;
	filetab[handin].didout=TRUE;
	fprintf(lw2,"%s",ptr);}
}

long fstcd();

void em_stcd(int optype)
{
   int arg1,arg2,size,sshift;
	long int code,result;

   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
   if(noex_bl <= 0)
     {size = get_size(carg1);
	   put_size(carg2,size);
      if(size < 24) printf("WARNING - sc %x called with %s, size %d < 24 bits\n",
								 optype,carg1,size);
	   code = sc_mem[arg1+1];
	   code <<= SIZE_HOST;
	   code |= sc_mem[arg1];
      switch(optype)
       {case T_FSTCD:  result = fstcd(code);
							  break;
	case T_NXTCD:  result = 1;
							  sshift = em_fndzo(code);
							  result = result<<sshift;
							  result = code + result;
							  if(sshift != em_fndzo(result)) result = FAIL;
							  break;
	case T_PREVCD: result = 1;
							  sshift = em_fndzo(code);
							  result = result<<sshift;
							  result = code - result;
							  if(sshift != em_fndzo(result)) result = FAIL;
							  break;
	case T_TRNCD:  result = -1;
							  result = result<<(em_fndzo(code)+4);
							  result = code & result;
							  break;
	case T_TRNACD: result = -1;
							  result = result<<20;
							  result = code & result;
							  break;
	case T_PREFIX: result = code;
							  result = result>>em_fndzo(code);
							  break;
       }
      sc_mem[arg2+1] = result>>SIZE_HOST;
		sc_mem[arg2]   = result & 0xffff;
    }
}

int em_fndzo(long int code)
{ /* routine to find 'first zero' in structure code */
  /* assumes a hexidecimal code in 32 bits or less */
  /* returns multiple for four, 0,4,8, ..16,20,    */
	int i;
	long unsigned mask;

	mask =15;
	for(i=0; i<32; i+=4)
	  { if( (code & (mask<<i)) != 0) break;}
	return(i);
}

int em_fndnz(long int code)
{ /* routine to find 'first nonzero' in structure code */
  /* assumes a hexidecimal code in 32 bits or less */

	int i;
	unsigned mask;

	mask =15;
	for(i=28; i<0; i-=4) if( (code & (mask<<i)) != 0) break;
	return(i);
}

void em_stcd8(int optype)
{
   int arg1,arg2,bits;
   long int sc_templ, sc_tempr;
   unsigned mask;

   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
	put_size(carg2,get_size(carg1));
   if(noex_bl <= 0)
     {switch(optype)
       {case T_FSTCD8:  if((bits = em_fndzo8(arg1)) >= 48)
			  printf("%d ERROR - sc overflow, bits=%d\n",linenum,bits);
		       else if(bits >= 32)
			  {sc_mem[arg2+2] = sc_mem[arg1+2]+(1<<(bits-32));
			   sc_mem[arg2+1] = sc_mem[arg1+1];
			   sc_mem[arg2] = sc_mem[arg1]; }
		       else if(bits >= 16)
			  {sc_mem[arg2+2] = sc_mem[arg1+2];
			   sc_mem[arg2+1] = sc_mem[arg1+1]+(1<<(bits-16));
			   sc_mem[arg2] = sc_mem[arg1]; }
		       else if(bits >= 0)
			  {sc_mem[arg2+2] = sc_mem[arg1+2];
			   sc_mem[arg2+1] = sc_mem[arg1+1];
			   sc_mem[arg2] = sc_mem[arg1]+(1<<bits);}
		       else
								  printf("%d ERROR - sc underflow, bits=%d\n",linenum,bits);
		       break;
	case T_NXTCD8: if((bits = em_fndzo8(arg1)) >= 40)
			  printf("%d ERROR - sc overflow, bits=%d\n",linenum,bits);
		       else if(bits >= 24)
			  {sc_mem[arg2+2] = sc_mem[arg1+2]+(1<<(bits-24));
			   sc_mem[arg2+1] = sc_mem[arg1+1];
			   sc_mem[arg2] = sc_mem[arg1]; }
		       else if(bits >= 8)
			  {sc_mem[arg2+2] = sc_mem[arg1+2];
			   sc_mem[arg2+1] = sc_mem[arg1+1]+(1<<(bits-8));
			   sc_mem[arg2] = sc_mem[arg1]; }
		       else if(bits >= -8)
			  {sc_mem[arg2+2] = sc_mem[arg1+2];
			   sc_mem[arg2+1] = sc_mem[arg1+1];
			   sc_mem[arg2] = sc_mem[arg1]+(1<<(bits+8));}
		       else
								  printf("%d ERROR - sc underflow, bits=%d\n",linenum,bits);
							  if(bits != em_fndzo8(arg2))
			  {sc_mem[arg2+2] = FAIL;
			   sc_mem[arg2+1] = FAIL;
			   sc_mem[arg2] = FAIL;}
		       break;
	case T_PREVCD8:if((bits = em_fndzo8(arg1)) >= 40)
			  printf("%d ERROR - sc overflow, bits=%d\n",linenum,bits);
		       else if(bits >= 24)
			  {sc_mem[arg2+2] = sc_mem[arg1+2]-(1<<(bits-24));
			   sc_mem[arg2+1] = sc_mem[arg1+1];
			   sc_mem[arg2] = sc_mem[arg1]; }
		       else if(bits >= 8)
			  {sc_mem[arg2+2] = sc_mem[arg1+2];
			   sc_mem[arg2+1] = sc_mem[arg1+1]-(1<<(bits-8));
			   sc_mem[arg2] = sc_mem[arg1]; }
		       else if(bits >= -8)
			  {sc_mem[arg2+2] = sc_mem[arg1+2];
			   sc_mem[arg2+1] = sc_mem[arg1+1];
			   sc_mem[arg2] = sc_mem[arg1]-(1<<(bits+8));}
		       else
								  printf("%d ERROR - sc underflow, bits=%d\n",linenum,bits);
							  if(bits != em_fndzo8(arg2))
			  {sc_mem[arg2+2] = FAIL;
			   sc_mem[arg2+1] = FAIL;
			   sc_mem[arg2] = FAIL;}
		       break;
	case T_TRNCD8: mask = 0;
							  if((bits = em_fndzo8(arg1)) >= 40)
			  printf("%d ERROR - sc overflow, bits=%d\n",linenum,bits);
		       else if(bits >= 24)
			  {if(bits == 24) mask = -1<<8;
			   sc_mem[arg2+2] = sc_mem[arg1+2]&mask;
			   sc_mem[arg2+1] = sc_mem[arg1+1];
			   sc_mem[arg2] = sc_mem[arg1]; }
		       else if(bits >= 8)
			  {if(bits == 8) mask = -1<<8;
			   sc_mem[arg2+2] = sc_mem[arg1+2];
			   sc_mem[arg2+1] = sc_mem[arg1+1]&mask;
			   sc_mem[arg2] = sc_mem[arg1]; }
		       else if(bits >= -8)
			  {if(bits == -8) mask = -1<<8;
			   sc_mem[arg2+2] = sc_mem[arg1+2];
			   sc_mem[arg2+1] = sc_mem[arg1+1];
			   sc_mem[arg2] = sc_mem[arg1]&mask;}
		       else
								  printf("%d ERROR - sc underflow, bits=%d\n",linenum,bits);
			break;
	case T_TRNACD8: mask=(-1<<8);
			sc_mem[arg2+2] = sc_mem[arg1+2]&mask;
			sc_mem[arg2+1] = 0;
			sc_mem[arg2] = 0;
								break;
	case T_PREFIX8: if((bits = em_fndnz8(arg1)) >= 48)
			  printf("%d ERROR - sc overflow, bits=%d\n",linenum,bits);
			   sc_templ = sc_mem[arg1+2] ;
			   sc_tempr = sc_mem[arg1+1];
			   sc_tempr = sc_tempr<<16 | sc_mem[arg1];
			   if(bits <= 24)
									  {sc_tempr >>= bits;
									   sc_tempr |=  sc_templ << (32-bits);
			      sc_templ >>= bits;}
									else if(bits == 32)
									  {sc_tempr = sc_templ;
										sc_templ = 0;}
									else if(bits == 40)
									  {sc_tempr = sc_templ >> 8;
										sc_templ = 0;}
									else
								     printf("%d ERROR - sc underflow, bits=%d\n",linenum,bits);

		       sc_mem[arg2+2] = sc_templ;
							  sc_mem[arg2+1] = sc_tempr >> 16;
							  sc_mem[arg2] = sc_tempr;
			break;
      }
    }
}

int em_fndzo8(int arg1)
{ /* routine to find 'first zero' in structure code */
  /* assumes a hexidecimal code in 48 bits or less */
  /* returns multiple of 8. i.e. 0, 8 ,16, 24, ..       */
  /* in order from left to right 40,32,24,16,8,0 */
  /* value of 48 is error code */
	int i;
	unsigned mask;

	mask =255;
	for(i=0; i<16; i+=8)
	   if( (sc_mem[arg1] & (mask<<i)) != 0) return(i-8);
	for(i=0; i<16; i+=8)
	   if( (sc_mem[arg1+1] & (mask<<i)) != 0) return(i+8);
	for(i=0; i<16; i+=8)
	   if( (sc_mem[arg1+2] & (mask<<i)) != 0) return(i+24);
		  return(40);
}

int em_fndnz8(int arg1)
{ /* routine to find 'first nonzero' in structure code */
  /* assumes a hexidecimal code in 48 bits or less */

	int i;
	unsigned mask;

	mask =255;
	for(i=0; i<16; i+=8)
	   if( (sc_mem[arg1] & (mask<<i)) != 0) return(i);
	for(i=0; i<16; i+=8)
	   if( (sc_mem[arg1+1] & (mask<<i)) != 0) return(i+16);
	for(i=0; i<16; i+=8)
	   if( (sc_mem[arg1+2] & (mask<<i)) != 0) return(i+32);
		  return(48);
}



void em_count()
{
   int vector,answer;

   em_scano_2();
   em_carg_2(&vector,&answer);
   em_stack_buf();
   if(noex_bl > 0) return;
   put_size(carg2,SIZE_HOST);  /* set size of result to 16 bits */
   sc_mem[answer] = count(vector);

}

void em_tkncmp(int mode)
{
   int arg1,arg2;

   em_scano_5();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
/*
   if(noex_bl <= 0)
     { size = get_size(carg1);
       mindex(arg1,arg2,MREG,size);   }
*/
  printf("In tkncmp, mode=%d\n",mode);
}

/* this quadruple does not seemed to be used in the suites
   Therefore the pa_hit and sc_hit functions are comment out
   so that the file compiles.  It would appear that the
   number of args for pa_hit and sc_hit are interchanged.
   A proper fix would require a complete understanding for
   the functions which I do not remember */
void em_hit(int mode)
{
   int arg1,arg2,arg3,arg4,arg5,arg6,size;

   if ( mode == T_PARALLEL)
      {em_scano_6();
       em_carg_6(&arg1,&arg2,&arg3,&arg4,&arg5,&arg6);
 //020505      size = get_size(arg4);
       size = get_size(carg4);
//020505       pa_hit(arg1,arg2,arg3,arg4,arg5,size,arg6);
		}
   if ( mode == T_SCALAR)
      {em_scano_5();
       em_carg_5(&arg1,&arg2,&arg3,&arg4,&arg5);
//020505       sc_hit(arg1,arg2,arg3,arg4,arg5);
		}
   em_stack_buf();
/*   if(noex_bl <= 0)
     { size = get_size(carg1);
       hit(arg1,arg2,MREG,size);   }
*/
  printf("In hit, mode=%d\n",mode);
}


void em_sum(int mode)
{
  int field, answer;
  int mode1,mode2;

  mode1 = mode / SIZE_MODE2;
  mode2 = mode % SIZE_MODE2;

  em_scano_2();
  em_carg_2(&field,&answer);
  em_stack_buf();
  if(noex_bl > 0) return;

  if(mode1 == T_INT) put_size(carg2,/*INT_SIZE*/16);
  else if(mode1 == T_REAL) put_size(carg2,REAL_SIZE);
  else printf("%d ERROR - In sum, mode1=%d not recognized\n",linenum,mode1);
  sum(field,get_size(carg1),answer,mode1);
  return;
}

void em_sibdex()
{
  int arg1,arg2,arg3,size;

  em_scano_3();
  em_carg_3(&arg1,&arg2,&arg3);
  em_stack_buf();
  if(noex_bl > 0) return;
  if((size=get_size(carg1)) != FAIL)
	  sibdex(arg1,arg2,arg3,size);
  else printf("%d ERROR - can't find size of %s in sibdex\n",
					linenum,token_buf);
  return;
}

void em_shape()
{
  em_scano_2();
  return;
}

/*
void dumpstack()
{
  int i,j;

  printf("Stackdump emptys=%d, fillds=%d\nstack=\n",emptys,fillds);
  for(i=emptys; i<=fillds+1; i++)
	 {printf("i=%d, ",i);
	  for(j=0; j<NOOFW; j++) printf(" %x",pa_mem[j][i]);
	  printf("\n");}
}
*/

int em_declar()
{
   int arg1,arg2,arg3,arg4,arg5,arg6;
   int status,address;
   int mode1,mode2;
   char buffer[13];

   mode1 = T_INT;
	mode2 = T_PARALLEL;
   em_scano_6();
   em_carg_6(&arg1,&arg2,&arg3,&arg4,&arg5,&arg6);
   em_stack_buf();
   if(noex_bl <= 0)
	  {address = bitslice;
      bitslice += sc_mem[arg2]*(sc_mem[arg4]+sc_mem[arg5]);
	   if(bitslice > PA_MEM_SIZE*sizeof(int))
		  {printf("%d ERROR - parallel memory overflow.\n",linenum);
		   status = FAIL; }
		else
		  status = SUCCESS;
		if(status != FAIL)
      {
buffer[0] = toupper((unsigned) sc_mem[arg1+5] >> 8);
buffer[1] = toupper(sc_mem[arg1+5]);
buffer[2] = toupper((unsigned) sc_mem[arg1+4] >> 8);
buffer[3] = toupper(sc_mem[arg1+4]);
buffer[4] = toupper((unsigned ) sc_mem[arg1+3] >> 8);
buffer[5] = toupper(sc_mem[arg1+3]);
buffer[6] = toupper((unsigned ) sc_mem[arg1+2] >> 8);
buffer[7] = toupper(sc_mem[arg1+2]);
buffer[8] = toupper((unsigned ) sc_mem[arg1+1] >> 8);
buffer[9] = toupper(sc_mem[arg1+1]);
buffer[10] = toupper((unsigned ) sc_mem[arg1] >> 8);
buffer[11] = toupper(sc_mem[arg1]);
buffer[12] = 0;
	 em_insert(mode1,mode2,buffer,address,arg4+arg5,NOOFW,arg2,0.0,"CS$");
	 sc_mem[arg6] = address;}
	  }
	return(status);
 }

int em_getadd()
{
   int arg1, arg2, status;

   status = SUCCESS;
   em_scano_2();
   em_carg_2(&arg1,&arg2);
   em_stack_buf();
   if(noex_bl <= 0)
	  sc_mem[arg2] = get_add(carg1);
	return(status);
 }

void em_lex(int mode)
/* CHAR types are left adjusted in LEX$ and LEX_VAL$ */
/* em_adj does same */
{
   int arg1, arg2, arg3, i;
   int sarg, size2, size3;
   int lex_siz;
   int mode1, mode2;

   mode1 = mode / SIZE_MODE2;
   mode2 = mode % SIZE_MODE2;
   em_scano_3();  /* sc to pa (LEX) - masked by arg1 */
   em_carg_3(&arg1,&arg2,&arg3);/* mask,sc,pa */
   em_stack_buf();
   size2 = get_size(carg2);  /* scalar arg */
   size3 = get_size(carg3);  /* LEX$ */
   if(!noex_bl)
     {if(mode1 == T_CHAR)
	{lex_siz = size3;
	 if(lex_siz <= SC_TEMP_SIZE && (sarg=get_add("SC_TEMP")) != FAIL)
	   {/* move field into one of LEX size, then left adjust */
	    for(i=0; i<(((lex_siz-1)/SIZE_HOST)+1); i++)
	       sc_mem[sarg+i] = 0;
//020505	    for(i=0; i<(((size-1)/SIZE_HOST)+1); i++)
	    for(i=0; i<(((size2-1)/SIZE_HOST)+1); i++) // size2 is a pure guess
	       sc_mem[sarg+i] = sc_mem[arg2+i];
	    em_cnvchr(sarg,sarg,lex_siz); /* left adjusts */
	    scpamvmk(sarg,arg3,arg1,lex_siz,lex_siz);
	    }
	 else
	   {printf("%d ERROR - no SC_TEMP\n",linenum);
	    return;}
	}
      else
	scpamvmk(arg2,arg3,arg1,size2,size3);

      /* check for size3 > 1, i.e. logical,
	 so value is not overwritten by "sign" */
      if(mode1 != T_CHAR && mode1 != T_CARD &&
	 mode1 != T_LOGICAL && mode1 != T_REAL)
	   if(size2 >= size3 && size3 > 1)
	     {if((1<<(size2-1))&sc_mem[arg2])
		 papamvmk(get_add("TRUE$"),arg3,arg1,1);
	      else
		 papamvmk(get_add("FALSE$"),arg3,arg1,1);}
	   else  /* size2 < size3 */
	     pasnexmk(arg3+size3-size2,arg3,arg1,size3-size2);
    }
   return;
}

/* em_adj is of the form adj cadj$ lptmp
   The adjective cadj$ is searched for in the lexicon LEX$,  
   when found its associated column/field name is retrieved from LEX_VAL$.
   The retrieved name is used in the final search, the result of
   which is put in lptmp.   */
int em_adj()
/* CHAR types are left adjusted in LEX$ and LEX_VAL$ */
{
   int arg1, arg2, i, begi;
   int argt, sarg, size;
   int lex_add, lex_siz;
   char lex_ad_buf[13], *lex_ad;

   em_scano_2();
   em_carg_2(&arg1,&arg2); /* scalar(input), mask(output) */
   em_stack_buf();
   if(noex_bl <= 0)
    {size = get_size(carg1);
     lex_siz = get_size("LEX$");
     if(lex_siz <= SC_TEMP_SIZE && (sarg=get_add("SC_TEMP")) != FAIL)
       {/* move field into one of LEX size, then left adjust */
	for(i=0; i<(((lex_siz-1)/SIZE_HOST)+1); i++)
	   sc_mem[sarg+i] = 0;
	for(i=0; i<(((size-1)/SIZE_HOST)+1); i++)
	   sc_mem[sarg+i] = sc_mem[arg1+i];
	em_cnvchr(sarg,sarg,lex_siz); /* left adjusts */
	}
     else
       {printf("%d ERROR - no SC_TEMP\n",linenum);
	return SUCCESS;}
 
	 //look up adj token (carg1) in lexicon (LEX$)
     lex_add = get_add("LEX$");
     argt = get_add("TEMP2");
     fxcreq2(lex_add,sarg,argt,lex_siz,lex_siz);
     lgpaand(argt,MREG,argt,1);
     /* argt flags entry in LEX association */
     if(em_responders(argt) != TRUE)
       {printf("%d ERROR - adjective %x not found\n",linenum,sc_mem[arg1]);
	return FAIL;}
	 //Get its column/field name from LEX_VAL
	 //Byte swap? and left justify and put in lex_ad_buf
     first(argt);
     /* clear SC_TEMP */
     for(i=0; i<(((lex_siz-1)/SIZE_HOST)+1); i++)
	  sc_mem[sarg+i] = 0;
     lex_add = get_add("LEX_VAL$");
     lex_siz = get_size("LEX_VAL$");
     /*pascmvsx(pa , sc, mask, size)  */
     pascmvsx(lex_add,sarg,argt,lex_siz);
     /* reverse sc_mem[sarg] for char string */
     lex_ad = &(lex_ad_buf[0]);
     begi = (((lex_siz-1)/SIZE_HOST)/2);
     for(i=begi; i>=0; i--)
	{*lex_ad = sc_mem[sarg+i]>>8 & 255; lex_ad++;
	 *lex_ad = sc_mem[sarg+i] & 255; lex_ad++;}
     *lex_ad = 0;
/* left adjust arg1 */
     size = get_size(carg1);
     if(size <= SC_TEMP_SIZE && (sarg=get_add("SC_TEMP")) != FAIL)
       {/* move field into one of size, then left adjust */
	for(i=0; i<(((SC_TEMP_SIZE-1)/SIZE_HOST)+1); i++)
	   sc_mem[sarg+i] = 0;
	for(i=0; i<(((size-1)/SIZE_HOST)+1); i++)
	   sc_mem[sarg+i] = sc_mem[arg1+i];
	size = get_size(&lex_ad_buf[0]);
	em_cnvchr(sarg,sarg,size); /* left adjusts */
	}
     else
       {printf("%d ERROR - no SC_TEMP\n",linenum);
	return SUCCESS;}
	 //search the retrieved field for the adjective
     fxcreq2(get_add(&lex_ad_buf[0]),sarg,argt,size,size);
     lgpaand(argt,arg2,arg2,1);
    }
   return SUCCESS;
}

/* em_noun processed the noun - the last word in a noun phrase.
   According to suite68, the noun in the noun quadruple is the column name.  
   This code looks for it in the lexicon, but only adj are put in the lexicon.
   This code does not make sense, but does not seem to harm anything. */
void em_noun()
{
	int arg1, arg2;
	int argt;
	
	em_scano_2();
	em_carg_2(&arg1,&arg2);
	em_stack_buf();
	if(noex_bl <= 0)
	{argt = get_add("TEMP3");
	 fxcreq2(get_add("LEX$"),arg1,argt,get_size("LEX$"),get_size("LEX$"));
	 lgpaor(argt,arg2,arg2,1);
	}
}

int em_power(int mode)
{
  int result, size1, size2;
  int arg1, arg2, arg3, argt;
  int mode1,mode2,modea;

  modea = fixmode(mode);
  mode1 = modea / SIZE_MODE2;
  mode2 = modea % SIZE_MODE2;
  em_scano_3();
  em_carg_3(&arg1,&arg2,&arg3);
  em_stack_buf();
  if(noex_bl > 0) return SUCCESS;
/*
printf("In em_power, line=%d, mode=%x, modea=%x, mode1=%x, mode2=%x\n",
	linenum,mode,modea,mode1,mode2);
*/
  size1 = get_size(carg1);
  size2 = get_size(carg2);
  if(mode2 == T_COMMON_RIGHT || mode2 == T_SCALAR_RIGHT)
    {argt = em_stack_temp(size2);
     paclrun(argt,size2);
     scpamvmk(arg2,argt,MREG,size2,size2);
     result = pa_iterate(T_POWER,arg1,argt,arg3,size1,size2);
     em_pop_temp(size2);
    }
  else if(mode2 == T_COMMON_LEFT || mode2 == T_SCALAR_LEFT)
    {argt = em_stack_temp(size1);
     paclrun(argt,size1);
     scpamvmk(arg1,argt,MREG,size1,size1);
     result = pa_iterate(T_POWER,argt,arg2,arg3,size1,size2);
     em_pop_temp(size1);
    }
  else if (mode2 == T_PARALLEL)
    result = pa_iterate(T_POWER,arg1,arg2,arg3,size1,size2);
  else if (mode2 == T_SCALAR)
    result = sc_power(arg1,arg2,arg3);
  else
    {printf("%d ERROR - illegal mode2 %d in em_power\n",linenum,mode2);
     result = FAIL;}
  return result;
}

int em_sin(int mode)
{
  int arg1,arg2,result;
  int mode1,mode2;

  mode1 = mode / SIZE_MODE2;
  mode2 = mode % SIZE_MODE2;

  em_scano_2();
  em_carg_2(&arg1,&arg2);
  em_stack_buf();
  if(noex_bl > 0) return SUCCESS;
  /* the third argument is a dummy */
  if(mode2 == T_SCALAR)
     result = sc_sin(arg1,arg2);
  else
     result = pa_iterate(T_SIN,arg1,arg2,arg2,get_size(carg1),get_size(carg2));
  return result;
}

int em_cos(int mode)
{
  int arg1,arg2,result;
  int mode1,mode2;

  mode1 = mode / SIZE_MODE2;
  mode2 = mode % SIZE_MODE2;

  em_scano_2();
  em_carg_2(&arg1,&arg2);
  em_stack_buf();
  if(noex_bl > 0) return SUCCESS;
  /* the third argument is a dummy */
  if(mode2 == T_SCALAR)
     result = sc_cos(arg1,arg2);
  else
     result = pa_iterate(T_COS,arg1,arg2,arg2,get_size(carg1),get_size(carg2));
  return result;
}

int em_exp(int mode)
{
  int arg1,arg2,result;
  int mode1,mode2;

  mode1 = mode / SIZE_MODE2;
  mode2 = mode % SIZE_MODE2;

  em_scano_2();
  em_carg_2(&arg1,&arg2);
  em_stack_buf();
  if(noex_bl > 0) return SUCCESS;
  /* the third argument is a dummy */
  if(mode2 == T_SCALAR)
     result = sc_exp(arg1,arg2);
  else
     result = pa_iterate(T_EXP,arg1,arg2,arg2,get_size(carg1),get_size(carg2));
  return result;
}

int em_rand(int mode)
{
  int arg1,result;
  int mode1,mode2;

  mode1 = mode / SIZE_MODE2;
  mode2 = mode % SIZE_MODE2;

  em_scano_1();
  em_carg_1(&arg1);
  em_stack_buf();
  if(noex_bl > 0) return SUCCESS;
  if(mode1 == T_LONGINT)
    if(mode2 == T_SCALAR)
		{result = sc_rand(arg1);
		return result;}
    /*else
       rand is a scalar function only
       result = pa_iterate(T_RAND,arg1,arg1,arg1,get_size(carg1),get_size(carg1));
       */
  return SUCCESS;
}

int em_sqrt(int mode)
{
  int arg1,arg2,size1,size2,result;
  int mode1,mode2;

  mode1 = mode / SIZE_MODE2;
  mode2 = mode % SIZE_MODE2;

  em_scano_2();
  em_carg_2(&arg1,&arg2);
  em_stack_buf();
  if(noex_bl > 0) return SUCCESS;

  result = FAIL;
  size1 = get_size(carg1);
  size2 = get_size(carg2);
  /* the second arg2 is a dummy argument */
  if(mode2 == T_SCALAR)
    result = sc_sqrt(arg1,arg2);
  else if (mode2 == T_PARALLEL)
    result = pa_iterate(T_SQRT,arg1,arg2,arg2,get_size(carg1),get_size(carg2));
  else
     printf("%d ERROR - unrecognized mode2 %d for em_sqrt\n",linenum,mode2);
  return result;
}

int em_clear(int mode)
{ int arg1,size;
  int mode1,mode2;

  mode1 = mode / SIZE_MODE2;
  mode2 = mode % SIZE_MODE2;

  em_scano_1();
  em_carg_1(&arg1);
  em_stack_buf();
  if(noex_bl > 0) return SUCCESS;
  if (mode2 == T_PARALLEL)
     {size = get_size(carg1);
      paclrun(arg1,size);}
  else if (mode2 == T_SCALAR)
     {sc_mem[arg1] = 0;
      if(mode1 == T_LONGINT || mode1 ==T_REAL) sc_mem[arg1+1] = 0;}
  else  return FAIL;
  return SUCCESS;
}
