/* EM_RTNS_CMP.C 910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"

/* COMPARISON ROUTINES */

#define LESSER 0
#define EQUAL 1
#define GREATER 2

/* fixed paraller compare */
void fxpacp(int arg1, int arg2, int arg3, int size)
{
    int i,p,y,locmsk[NOOFW];

    for (p=0; p<NOOFW; p++)
      {locmsk[p] = -1;
       pa_mem[p][arg3+EQUAL] = -1;
       pa_mem[p][arg3+GREATER]=0;
		 pa_mem[p][arg3+LESSER]=0;

       for(i=0;i<size;i++)
	 {y = pa_mem[p][arg1+i]^pa_mem[p][arg2+i];
	  pa_mem[p][arg3+EQUAL] = ~y&locmsk[p]|~locmsk[p]&pa_mem[p][arg3+EQUAL];
	  pa_mem[p][arg3+GREATER] = y&pa_mem[p][arg1+i]&locmsk[p]|
					 ~locmsk[p]&pa_mem[p][arg3+GREATER];
	  pa_mem[p][arg3+LESSER]  = y&pa_mem[p][arg2+i]&locmsk[p]|
					 ~locmsk[p]&pa_mem[p][arg3+LESSER];
	  locmsk[p] = locmsk[p]&~y;
	 }
      };
    /* adjust for negative:positive */
    lgpaxor(arg1,arg2,emptys,1);
    lgpaxor(emptys,arg3+LESSER,arg3+LESSER,1);
    lgpaxor(emptys,arg3+GREATER,arg3+GREATER,1);
    inc_pa_perform(-12);
 }

/* fixed parallel less than */
void fxpalt(int arg1, int arg2, int arg3, int size)
{
    int argt,p;

    argt = get_add("TEMP");
    fxpacp(arg1,arg2,argt,size);

    for (p=0; p<NOOFW; p++)
	pa_mem[p][arg3] = pa_mem[p][argt+LESSER];
    inc_pa_perform(2);
}


/* fixed common right less than */
/* fxcrlt(pa,sc,pa,size) */
void fxcrlt(int arg1, int arg2, int arg3, int size)
{
    int argt;

    argt = get_add("TEMP2");
    scpamvun(arg2,argt,size);
    inc_pa_perform(-2*size);
    fxpalt(arg1,argt,arg3,size);
    inc_pa_perform(-2*size);
 }

/* fixed scalar less than */
/* pascmv called at the end of this and orther routines, requires a
   bit field to "step".  Originally used, MREG, but inside a null
   setscope, MREG is all zeros.  Therefore changed to THE
*/
void fxsclt(int arg1, int arg2, int arg3, int size, int size2)
{
    int argt,argt2,argt3,thearg;
    
    argt = get_add("TEMP2");
    argt2 = get_add("TEMP3");
    argt3 = get_add("TEMP4");
    thearg = get_add("THE");
    paclrun(argt,INT_SIZE);
    paclrun(argt2,INT_SIZE);
    paclrun(argt3,INT_SIZE);
    scpamvun(arg1,argt,size);
    scpamvun(arg2,argt2,size2);
    inc_pa_perform(-size*2);
    fxpalt(argt,argt2,argt3+SIZE_HOST-1,size);
    pascmv(argt3,arg3,thearg,SIZE_HOST);
    inc_pa_perform(-size*2);
}



/* fixed parallel less than or equal */
void fxpale(int arg1, int arg2, int arg3, int size)
{
    int argt,p;

    argt = get_add("TEMP");
    fxpacp(arg1,arg2,argt,size);
    for (p=0; p<NOOFW; p++)
	pa_mem[p][arg3] = pa_mem[p][argt+LESSER]| pa_mem[p][argt+EQUAL];
    inc_pa_perform(2);
}


/* fixed common right less than or equal */
/* fxcrle(pa,sc,pa,size); */
void fxcrle(int arg1, int arg2, int arg3, int size)
{
    int argt;

    argt = get_add("TEMP2");
    scpamvun(arg2,argt,size);
    inc_pa_perform(-size*2);
    fxpale(arg1,argt,arg3,size);
    inc_pa_perform(-size*2);
 }

/* fixed scalar less than or equal */
void fxscle(int arg1, int arg2, int arg3, int size, int size2)
{
    int argt,argt2,argt3,thearg;
 
    argt = get_add("TEMP2");
    argt2 = get_add("TEMP3");
    argt3 = get_add("TEMP4");
    thearg = get_add("THE");
    paclrun(argt,INT_SIZE);
    paclrun(argt2,INT_SIZE);
    paclrun(argt3,INT_SIZE);
    scpamvun(arg1,argt,size);
    scpamvun(arg2,argt2,size2);
    inc_pa_perform(-size*2);
    fxpale(argt,argt2,argt3+SIZE_HOST-1,size);
    pascmv(argt3,arg3,thearg,SIZE_HOST);
    inc_pa_perform(-size*2);
}
    



/* fixed parallel equal */
void fxpaeq(int arg1, int arg2, int arg3, int size)
{
    int argt,p;

    argt = get_add("TEMP");
    fxpacp(arg1,arg2,argt,size);

    for (p=0; p<NOOFW; p++)
	pa_mem[p][arg3] = pa_mem[p][argt+EQUAL];
}


/* fixed common right equal */
/* fxcreq(pa,sc,pa,size);*/
void fxcreq(int arg1, int arg2, int arg3, int size)
{
    int argt;
// printf("In fxcreq, arg1,2,3=%d, %d, %d, size=%d\n",arg1,arg2,arg3,size);  
    argt = get_add("TEMP2");
// printf("filld1=%d\n",fillds);
    scpamvun(arg2,argt,size);
// printf("filld2=%d\n",fillds);
    inc_pa_perform(-size*2);
    fxpaeq(arg1,argt,arg3,size);
    inc_pa_perform(-size*2);
}

/* fixed scalar equal */
void fxsceq(int arg1, int arg2, int arg3, int size, int size2)
{
    int argt,argt2,argt3,args, thearg;
   
    args = get_add("SC_TEMP");
    argt = em_stack_temp(size);
    argt2 = em_stack_temp(size2);
    argt3 = get_add("TEMP4");
    thearg = get_add("THE");
    paclrun(argt,size);
    paclrun(argt2,size2);
    paclrun(argt3,SIZE_HOST);
    em_chrcnv(arg1,args,size);
    scpamvun(args,argt,size);
    em_chrcnv(arg2,args,size2);
    scpamvun(args,argt2,size2);
    inc_pa_perform(-size*2);
    fxpaeq(argt,argt2,argt3+SIZE_HOST-1,size);
    pascmv(argt3,arg3,thearg,SIZE_HOST);
    em_pop_temp(size2);
    em_pop_temp(size);
    inc_pa_perform(-size*2);
}

/* fixed parallel greater than */
void fxpagt(int arg1, int arg2, int arg3, int size)
{
    int argt,p;

    argt = get_add("TEMP");
    fxpacp(arg1,arg2,argt,size);
    for (p=0; p<NOOFW; p++)
       pa_mem[p][arg3] = pa_mem[p][argt+GREATER];
    inc_pa_perform(2);
}


/* fixed common right greater than */
/* fxcrgt(pa,sc,pa,size) */
void fxcrgt(int arg1, int arg2, int arg3, int size)
{
    int argt;

    argt = get_add("TEMP2");
    scpamvun(arg2,argt,size);
    inc_pa_perform(-size*2);
    fxpagt(arg1,argt,arg3,size);
    inc_pa_perform(-size*2);
 }

/* fixed scalar greater than */
void fxscgt(int arg1, int arg2, int arg3, int size, int size2)
{
    int argt,argt2,argt3,thearg;
    argt = get_add("TEMP2");
    argt2 = get_add("TEMP3");
    argt3 = get_add("TEMP4");
    thearg = get_add("THE");
    paclrun(argt,size);
    paclrun(argt2,size2);
    paclrun(argt3,SIZE_HOST);
    scpamvun(arg1,argt,size);
    scpamvun(arg2,argt2,size2);
    inc_pa_perform(-size*2);
    fxpagt(argt,argt2,argt3+SIZE_HOST-1,size);
    pascmv(argt3,arg3,thearg,SIZE_HOST);
    inc_pa_perform(-size*2);
}


/* fixed parallel greater than or equal */
void fxpage(int arg1, int arg2, int arg3, int size)
{
    int argt,p;

    argt = get_add("TEMP");
    fxpacp(arg1,arg2,argt,size);

    for (p=0; p<NOOFW; p++)
	pa_mem[p][arg3] = pa_mem[p][argt+GREATER]|pa_mem[p][argt+EQUAL];
    inc_pa_perform(2);
  }


/* fixed common right greater than or equal */
/* fxcrge(pa,sc,pa,size); */
void fxcrge(int arg1, int arg2, int arg3, int size)
{
    int argt;

    argt = get_add("TEMP2");
    scpamvun(arg2,argt,size);
    inc_pa_perform(-2*size);
    fxpage(arg1,argt,arg3,size);
    inc_pa_perform(-2*size);
}

/* fixed scalar greater than or equal */
void fxscge(int arg1, int arg2, int arg3, int size, int size2)
{
    int argt,argt2,argt3,thearg;
   
    argt = get_add("TEMP2");
    argt2 = get_add("TEMP3");
    argt3 = get_add("TEMP4");
    thearg = get_add("THE");
    paclrun(argt,INT_SIZE);
    paclrun(argt2,INT_SIZE);
    paclrun(argt3,INT_SIZE);
    scpamvun(arg1,argt,size);
    scpamvun(arg2,argt2,size2);
    inc_pa_perform(-size*2);
    fxpage(argt,argt2,argt3+SIZE_HOST-1,size);
    pascmv(argt3,arg3,thearg,SIZE_HOST);
    inc_pa_perform(-size*2);
}


/* fixed parallel not equal */
void fxpane(int arg1, int arg2, int arg3, int size)
{
    int argt,p;

    argt = get_add("TEMP");
    fxpacp(arg1,arg2,argt,size);

    for (p=0; p<NOOFW; p++)
	pa_mem[p][arg3] = pa_mem[p][argt+LESSER]| pa_mem[p][argt+GREATER];
    inc_pa_perform(3);
  }


/* fixed common right not  equal */
/* fxcrne(pa,sc,pa,size) */
void fxcrne(int arg1, int arg2, int arg3, int size)
{
    int argt;

    argt = get_add("TEMP2");
    scpamvun(arg2,argt,size);
    inc_pa_perform(-2*size);
    fxpane(arg1,argt,arg3,size);
    inc_pa_perform(-2*size);
 }

/* fixed scalar not equal */
void fxscne(int arg1, int arg2, int arg3, int size, int size2)
{
    int argt,argt2,argt3,thearg;
  
    argt = get_add("TEMP2");
    argt2 = get_add("TEMP3");
    argt3 = get_add("TEMP4");
    thearg = get_add("THE");
    paclrun(argt,INT_SIZE);
    paclrun(argt2,INT_SIZE);
    paclrun(argt3,INT_SIZE);
    scpamvun(arg1,argt,size);
    scpamvun(arg2,argt2,size2);
    inc_pa_perform(-size*2);
    fxpane(argt,argt2,argt3+SIZE_HOST-1,size);
    pascmv(argt3,arg3,thearg,SIZE_HOST);
    inc_pa_perform(-size*2);
}
