/* EM_RTNS_FIND.C 910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"

/* first

   first finds the first one in a parallel bit vector.  It returns
   the pa_mem index to the word with the first one and it masks out
   all other ones in the pa_mem word.
*/

first(arg1)
int arg1;
{
  int p, i, index, mask, bit;
  unsigned word;

  index=0;
  for(p=0; (pa_mem[p][arg1] == 0)&&p<NOOFW; p++) index++;
  if (index < NOOFW)
    {mask = 1;
     word = pa_mem[index][arg1];
     bit = INT_SIZE-1;
     for(i=0;!((word>>(INT_SIZE-1-i))&mask)&&i<INT_SIZE; i++) bit--;
     pa_mem[index][arg1] = mask<<bit;
   }
   else printf("%d WARNING - first called with null mask, command=%x\n",
		linenum,command_bl);

  return (index);
}

void step(int arg1, int arg2)
{int argt;

   argt = get_add("TEMP");

   papamvun(arg1,argt,1);
   inc_pa_perform(-2);
   resvfst(argt);
   lgpaxor(arg1,argt,arg2,1);
   inc_pa_perform(-2);
}


void resvfst(int arg1)
{
  int p,start;

  start = first(arg1);
  for(p=start+1; p<NOOFW; p++)
	  pa_mem[p][arg1]=0;
}


int mindex(int arg1, int arg2, int arg3, int size)
/* mindex(inpt,outp,mask,size) */
{  int i,value, p, index;
   int argt;

   argt = get_add("TEMP");
   papamvun(arg3,argt,1); /* do not destroy MREG */
   papamvun(argt,arg2,1);
   inc_pa_perform(-2);
   for(i=0; i<size; i++)
     {for(p=0; p<NOOFW; p++)pa_mem[p][argt]=~pa_mem[p][arg1+i]&pa_mem[p][arg2];
     if(em_responders(argt) == TRUE) papamvun(argt,arg2,1); };

   /* extract value */
   index=first(arg2);
   value=0;
   for(i=0; i<size; i++)
     {if(pa_mem[index][arg1+i]&pa_mem[index][arg2]) value |= 1;
      value <<= 1; };
   value >>=1;

   return (value);
 }

void minval(int arg1, int arg2, int mask, int size)
/* minval(input,output(scalar),mask,size) */
{  int argt;

   argt=get_add("TEMP2");
   inc_pa_perform(size*2);
   mindex(arg1,argt,mask,size);
   pascmv(arg1,arg2,argt,size);
 }


void maxdex(int arg1, int arg2, int arg3, int size)
/* maxdex(input,output,mask,size) */
{  int i, p;
   int argt;

   argt = get_add("TEMP");
   papamvun(arg3,argt,1); /* do not destroy MREG */
   papamvun(argt,arg2,1);
   inc_pa_perform(-2);
   for(i=0; i<size; i++)
     {for(p=0; p<NOOFW; p++)pa_mem[p][argt]=pa_mem[p][arg1+i]&pa_mem[p][arg2];
      if(em_responders(argt) == TRUE) papamvun(argt,arg2,1);
     };

 }

void maxval(int arg1, int arg2, int mask, int size)
/* maxval(input,output(sc),mask,size) */
{  int argt;

   argt=get_add("TEMP3");
   inc_pa_perform(2*size);
   maxdex(arg1,argt,mask,size);
   pascmv(arg1,arg2,argt,size);
 }


int mthdex(int m, int arg1, int arg2, int arg3, int size)
/* mthdex(mth,input,output,mask,size) */
{  int i,value,  p, index;
   int argt, cnt;


   m = count(arg3)-m;
   cnt = 0;
   argt = get_add("TEMP");
   papamvun(arg3,argt,1); /* do not destroy MREG */
   papamvun(argt,arg2,1);
   inc_pa_perform(-2);
   for(i=0; i<size; i++)
     {for(p=0; p<NOOFW; p++)pa_mem[p][argt]=pa_mem[p][arg1+i]&pa_mem[p][arg2];
      cnt += count(argt);
		if(cnt <m) papamvun(argt,arg2,1);
		else if(cnt >= 0)
		  {m -= cnt;
			cnt = 0;
			lgpanot(argt,argt,1);
//020505			lgpaand(argt,arg2,1);}
// the MREG was added to allow compilation, do not know what it should be
			lgpaand(argt,MREG,arg2,1);}

     };
   inc_pa_perform(size*3);


   /* extract value */
   index=first(arg2);
   value=0;
   for(i=0; i<size; i++)
     {if(pa_mem[index][arg1+i]&pa_mem[index][arg2]) value |= 1;
      value <<= 1; };
   value >>=1;
   inc_pa_perform(2*size);
   return (value);
 }

int balloc(int arg1, int arg2, int arg3)
/* balloc(flag,assoc_bi,count) */
/* balloc(output,input/output,input)  */
/* arg3 is a value, if number of cells is in sc_mem, */
/* call balloc(flag,assoc_bi,sc_mem[arg3]);         */
{
  int i, glb_bi;

   glb_bi = get_add("GLOBAL_BI$");
//   printf("In balloc, glb_bi=%d, number=%d\n",glb_bi,arg3);
   papamvun(glb_bi,arg1,1);
   lgpanot(glb_bi,glb_bi,1);
   for (i=0;i<arg3;i++)
     if(em_responders(glb_bi) == TRUE)
       step(glb_bi,glb_bi);
     else
       {printf("%d ERROR - out of memory.  Allocated %d out of requested %d cells.\n",
	       linenum,i,arg3);
	return FAIL;}
   lgpanot(glb_bi,glb_bi,1);
   lgpaxor(arg1,glb_bi,arg1,1);
   lgpaor(arg1,arg2,arg2,1);
   return SUCCESS;
}

void talloc(int arg1)  /* allocate T_THE */
{  int glb_dx;

   glb_dx = get_add("GLOBAL_BI$");
   lgpanot(glb_dx,arg1,1);
   lgpanot(glb_dx,glb_dx,1);
   step(glb_dx,glb_dx);
   /* reserve first global bi for THE */
   lgpaxor(arg1,glb_dx,arg1,1);
   lgpanot(glb_dx,glb_dx,1);
   return;
}


int em_responders(int arg1)
{
	int p, result;

	result = FALSE;
	for (p=0; p<NOOFW32; p++) 
	 if(pa_mem[p][arg1]) result = TRUE;
   inc_pa_perform(1);
	return(result);
}

int count(int vector)
{
   int mask, cnt, i, p, word;

   cnt = 0;
	mask = 1;
	for(p=0; p<NOOFW; p++)
	  {word = pa_mem[p][vector] & pa_mem[p][MREG];
//	printf("In count, pa_mem[%d][%d]=%x, MREG=%x, word=%x\n",p,vector,pa_mem[p][vector],pa_mem[p][MREG],word);
		for(i=0; i<SIZE_HOST32; i++) //020505
			if(mask &(word>>i)) cnt++;
     }
	inc_pa_perform(1);
	return(cnt);
}

/*  parallel     scalar */
int sum(int field, int size, int arg2, int mode1)
{
   int mask, sum, i,j,p,cnt;
	unsigned word;

   if(mode1 == T_INT)
     {sum=0;
      mask=1;
      for(j=0; j<size; j++)
	{cnt = 0;
	 for(p=0; p<NOOFW; p++)
	  {word = pa_mem[p][field+j] & pa_mem[p][MREG];
	   for(i=0; i<SIZE_HOST32; i++)  //020505
	     if( mask&(word>>i)) cnt++;
	  }
	 sum += cnt*(1<<(size-j-1));
	}
      sc_mem[arg2] = sum;
     }
   else if (mode1 == T_REAL)
     flpasm(field,arg2);

   inc_pa_perform(1);

    return sum;
}

void sibdex(int arg1, int arg2, int arg3, int size)
/* sibdex(structure_code_field, target_code_mask, result, size) */
/* result is a two bit field, prvdex/nxtdex */
{
  int nxtdex,prvdex,equal,nxtslt,prvslt,avail,x,y;
  int i,j,mask,iobuf;
  int index;

  nxtdex = get_add("TEMP3");
  equal = nxtdex+1;
  nxtslt = nxtdex+2;
  avail = nxtdex+3;
  x = nxtdex+4;
  y = nxtdex+5;
  prvdex = nxtdex+6;
  prvslt = nxtdex+7;
  paclrun(nxtdex,8);
  lgpanot(avail,avail,1); /* set avail to ones */
  lgpaand(avail,MREG,avail,1);  /* scope it */
  iobuf = get_add("OUTBF$");/* use OUTBF as scalar temp */

  i = 0;
  mask = 1;
  resvfst(arg2);  /* uses TEMP */
  index = first(arg2);
  while(!(pa_mem[index][arg1+i]&pa_mem[index][arg2]) && i<size)
   {lgpanot(arg1+i,x,1);
    lgpaand(arg1+i,avail,y,1);
    if(em_responders(y))
      {papamvun(y,nxtdex,1);
       papamvun(y,nxtslt,1);}
    else
      {papamvun(nxtdex,nxtslt,1);
       lgpaand(x,nxtdex,nxtdex,1);}
    lgpaand(x,avail,avail,1);
   i++;
   }
  lgpaand(arg1+i,avail,equal,1);
  lgpanot(arg2,x,1);
  lgpaand(x,equal,equal,1);
  lgpanot(arg1+i,x,1);
  lgpaand(x,avail,prvdex,1);
  lgpaand(x,nxtdex,y,1);
  if(em_responders(y)>0)
    {papamvun(nxtdex,nxtslt,1);
     papamvun(y,nxtdex,1);}
  j=i+1;
    while(j<size &&(em_responders(nxtdex) || em_responders(prvdex)
		    || em_responders(equal) ))
    {if((~(pa_mem[index][arg1+j])&pa_mem[index][arg2]) != 0)
       {lgpaand(prvdex,arg1+j,y,1);
	if(em_responders(y) > 0)
	  {papamvun(prvdex,prvslt,1);
	   papamvun(y,prvdex,1);}
	lgpaand(equal,arg1+j,y,1);
	lgpanot(arg1+j,x,1);
	if(em_responders(y) > 0)
	   papamvun(y,nxtdex,1);
	else
	  {lgpaand(nxtdex,x,y,1);
	   if(em_responders(y) > 0)
	     {papamvun(nxtdex,nxtslt,1);
	      papamvun(y,nxtdex,1);}
	   }
	lgpaand(equal,x,equal,1);
       }
     else
       {lgpanot(arg1+j,x,1);
	lgpaand(nxtdex,x,y,1);
	if(em_responders(y)>0)
	  {papamvun(nxtdex,nxtslt,1);
	   papamvun(y,nxtdex,1);}
	lgpaand(x,equal,y,1);
	if(em_responders(y)>0)
	   papamvun(y,prvdex,1);
	else
	  {lgpaand(prvdex,arg1+j,y,1);
	   if(em_responders(y)>0)
	      {papamvun(prvdex,prvslt,1);
	       papamvun(y,prvdex,1);}
	  }
	lgpaand(equal,arg1+j,equal,1);
       }
    j++;
    }
   if(em_responders(nxtdex)>0) papamvun(nxtdex,nxtslt,1);
   if(em_responders(prvdex)>0) papamvun(prvdex,prvslt,1);
papamvun(prvslt,arg3,1);
papamvun(nxtslt,arg3+1,1);
}


/* scope on top of stack */
void sc_hit(int source, int sdx, int lex, int ldx, int size, int result)
{int scind, argt;

printf("In sc_hit\n");
  argt=get_add("TEMP3");

  scind = get_add("SC_TEMP");
  pascmv(source,scind,argt,size);
}


/*
  pa_hit records in count the number of hits from pattern found in
  lexicon.  Pdx selects the pattern.  Size is the field size.  The
  pattern and the lexicon entries are null terminated.
*/
#define C_NIL 0
void pa_hit(int pattern, int pdx, int lexicon, int size, int count)
  {int scpat, scnil, resp, pndr, rslt, scope;
/*  rslt flags hits.  It cha nges at random from column to column.
    resp flags lexicon entries which are still acitve.
    pndr
    scope saves the contents of MREG
*/
  int tlexicon, one_dx;

  paclrun(count, INT_SIZE);
  scnil = get_add("SC_TEMP");
  sc_mem[scnil] = C_NIL;
  scpat = get_add("SC_TEMP2");
  pascmv(pattern, scpat, pdx, size);
  one_dx = get_add("SC_TEMP3");
  sc_mem[one_dx] = 1;
  resp = get_add("TEMP");
  rslt = resp+1;
  pndr = resp+2;
  scope = resp+3;
  tlexicon = lexicon;
  fxcrne(tlexicon, scnil, resp, size);
  lgpaand(resp, MREG,scope,1);
  while(sc_mem[scpat] != C_NIL)
     {  papamvun(scope,resp,1);
	while(em_responders(resp) == TRUE)
	  {fxcreq(tlexicon, scpat, rslt, size);
	   lgpaand(rslt,scope,MREG,1);
	   fxcrad2(count,one_dx,count,INT_SIZE,INT_SIZE); /*masked*/
	   tlexicon += size;
	   fxcrne(tlexicon, scnil, resp, size);
//020505	   lgpaand(resp,scope,resp);  1 added to allow compilation
	   lgpaand(resp,scope,resp,1);
	  }
	pattern += size;
	pascmv(pattern, scpat, pdx, size);
	tlexicon = lexicon;
    }
}
