/* EM_RTNS_IO.C 910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"

/* colapse(address,size,mask,&outbuf) */
/*
A typical colapse call is:

int i,k;
if(em_debug_4 && (get_add("D") != FAIL))
  {printf("At fxpacp, arg1, arg2, arg3 \n");
   k=colapse(arg1,size,get_add("D"),&outbf[0][0]);
   k=colapse(arg2,size,get_add("D"),&outbf[1][0]);
   k=colapse(arg3,size,get_add("D"),&outbf[2][0]);
   for(i=0;i<k;i++) printf("      %d %d %x\n",outbf[0][i],outbf[1][i],
			   outbf[2][i]);
  }
*/
colapse(arg1,arg2,arg3,arg4)
/*   k=colapse(arg,size,mask,&outbf[0][0]) */
/* NOTE: this routine uses SIZE_HOST for both the size of
         the simulated sequential processor and the size of
         the memory of the processor doing the simulation */
 int arg1,arg2,arg3;
 unsigned arg4[];
{
int p,i,j,k,mregr,l;
int jsize;
unsigned mask;

k = -1;
jsize = ((arg2-1)%SIZE_HOST)+1;
for(p=0; p<NOOFW; p++)
  if((mregr=pa_mem[p][arg3]) != 0)
   {mask=1<<(SIZE_HOST-1);
    for(i=0; i<SIZE_HOST; i++)
     {if(mregr&mask)
       {arg4[++k] = 0;
        for(j=0; j<jsize; j++)
         {arg4[k] <<= 1;
          if(mask&pa_mem[p][arg1+j]) arg4[k] |= 1;}
          for(l=0; l<(arg2-1)/SIZE_HOST; l++)
            {arg4[++k]=0;
	          for(j=0; j<SIZE_HOST; j++)
	            {arg4[k] <<= 1;
                if(mask&pa_mem[p][arg1+j+jsize+l*SIZE_HOST]) arg4[k] |= 1;}
         }
      }
    mask >>= 1;}
  }
  k++;

if(arg2/SIZE_HOST > 0) return(k/(arg2/SIZE_HOST)); /* return number of entries  written */
else return k;
}
/* expand puts one value from scalar memory arg1 into the IOSTACK
   at every location of IOMASK.  No error checking is done.  IOMASK
   must be set up properly prior to entry.
*/

void expand(int arg1, int size, int mode1)
/* size is the size of OUTBF$ which should be the same as SCALAR_SIZE */
{
  int argt;

//  printf("In expand, sc_mem[%d]=%x, size=%d\n",
//	  arg1,sc_mem[arg1],size);

  argt = get_add("TEMP2");
  papamvun(IOMASK,argt,1);  /* save iomask */
  while(em_responders(IOMASK))
    {/* convert 8 bit char to 8 bit interger, i.e. left adjusted to right */
     if(mode1 == T_CHAR && size == 8) sc_mem[arg1] = sc_mem[arg1]>>8;
     scpamvmk(arg1,IOSTACK+IOSTACK_SIZE-size,IOMASK,size,size);
     arg1 += (size-1)/SIZE_HOST + 1;
     step(IOMASK,IOMASK);
   }
  papamvun(argt,IOMASK,1);
}


papaconvrt(arg1,size,basedx)
/* converts ascii data in IOSTACK to binary from decimal or octal
   depending on which basedx points to.  Converts on the fly
   moving the data in the arg1 field.  It assumes that every string
   that starts with a "-" is a negative number.
*/
int arg1,size,basedx;
{ int temp,argt,i;
  int zerodx, asc0dx, minusdx;

  if(em_debug == 2)
    printf("In papaconvrt, arg1 = %x,size=%d,basedx=%x\n",arg1,size,basedx);

  temp = get_add("LITMP$");
  put_size("LITMP$",size*2);
  paclrmk(temp,IOMASK,size*2);
  argt = get_add("TEMP");
  paclrmk(argt,IOMASK,size);
  put_size("TEMP",size);
  paclrmk(arg1,IOMASK,size);
  em_stack(MREG);
  papamvun(IOMASK,MREG,1);
  zerodx = get_add("C0D$");
  asc0dx = get_add("C48D$");  /* value of ascii zero */
  minusdx = get_add("C45D$"); /* value of ascii - */
  /* the input is left_justified with zero fill */
  /* check for -, erase, save on stack */
  fxcreq(IOSTACK, minusdx,emptys,CHAR_SIZE);
  if(em_responders(emptys)) /* below must be high bits to low */
    papamvmkhl(IOSTACK+CHAR_SIZE,IOSTACK,emptys,IOSTACK_SIZE-CHAR_SIZE);
  em_stack(emptys); /* must come after above because clears emptys */
  /* terminate IOSTACK with zeros */
  scpamvmk(zerodx,IOSTACK+IOSTACK_SIZE-CHAR_SIZE,IOMASK,CHAR_SIZE,CHAR_SIZE);
  /* process all entries in parallel */
  for(i=0; i<IOSTACK_SIZE; i += CHAR_SIZE)
    {fxcreq(IOSTACK+i,zerodx,emptys,CHAR_SIZE);
     lgpanot(emptys,emptys,1);
     lgpaand(emptys,IOMASK,MREG,1);
     if(em_responders(MREG))
	    {fxcrsb(IOSTACK+i,asc0dx,IOSTACK+i,CHAR_SIZE);
	     /* check for values larger than base ???? */
	     fxcrml(arg1,basedx,temp,size);
	     papamvmk(temp+size,arg1,MREG,size);
	     papamvmk(IOSTACK+i,argt+size-CHAR_SIZE,MREG,CHAR_SIZE);
	     fxpaadun(argt,arg1,arg1,size);
	    }
     else break; /* exit for if all words contail fill */
    }
  em_pop(MREG);   /* negate the negative numbers */
  fxpamin(arg1,arg1,size);
  em_pop(MREG);
}

/* convrtpapa uses the fact that the divide routine uses LITMP$+0 and
   leaves the remainder in the low order bits

   Input is binary data in arg1 field of length size.  Data is converted to
   ascii characters in the radix specified by basedx.
   Result is in IOSTACK where ever IOMASK is set.  Assumes IOSTACK is filled
   with blanks and terminated by zero before entry.

   Result is developed from right to left. i.e. least signif to most
   signif.  IOSTACK+IOSTACKSIZE-CHARSIZE to IOSTACK+0
*/
convrtpapa(arg1,size,basedx)
int arg1,size,basedx;
{
	int argd,argr,argq,asc0dx,ascm,zerodx;
	int i;

	argd = get_add("TEMP4");   /* dividend */
	argq = get_add("TEMP5");   /* quotient */     /* argr is remainder */
	argr = get_add("LITMP$")+2*size-CHAR_SIZE; /* right 8 bits in field*/
	asc0dx = get_add("C48D$"); /* ascii zero */
	ascm = get_add("C45D$");	/* ascii minus  */
	zerodx = get_add("C0D$");

	em_stack(MREG);
   /* process negative numbers */
	papamvmk(arg1,argd,IOMASK,size);  /* argd is all positive inputs */
	fxcrlt(arg1,zerodx,emptys,size);
	lgpaand(emptys,IOMASK,MREG,1);
 	em_stack(MREG);                 /* save negs flag on stack */
	fxpamin(arg1,argd,size);	/* masks with MREG */
	papamvun(IOMASK,MREG,1);
	i = IOSTACK_SIZE-CHAR_SIZE;  /* right most char is zero */
	while(em_responders(MREG) == TRUE && i >= 0) /*next right most is first digit*/
	 {i -= CHAR_SIZE;
	  fxcrdv(argd,basedx,argq,size);
	  papamvmk(argr,IOSTACK+i,MREG,CHAR_SIZE);
	  fxcrad(IOSTACK+i,asc0dx,IOSTACK+i,CHAR_SIZE);
	  papamvmk(argq,argd,MREG,size);
	  fxcrle(argq,zerodx,emptys,size);
	  lgpanot(emptys,emptys,1);
	  lgpaand(emptys,MREG,MREG,1);
	 }
	em_pop(MREG);	/* retrieve negs flag */
   i -= CHAR_SIZE;
	if(i >= 0)
	  scpamvmk(ascm,IOSTACK+i,MREG,CHAR_SIZE,CHAR_SIZE); /* insert - */
	else print_err("IOSTACK overflow on conversion.",0,0);
	em_pop(MREG);       /* restore MREG */
}


/* em_strcpy and em_strcat are routines that convert from string order
   to int order and back from int order to string order respectively.
   They are used by em_read and em_print.  This conversion is not necessary
   on the SUNs but is on the VAX.  They are included here for compatibility */

void em_strcpy(int index, char *pointer)
{
  int word,i,mod;

  mod = SIZE_HOST/CHAR_SIZE;
  while(*pointer != 0)
    {word = 0;
     for (i=0; i<mod && *pointer != 0; i++)
       word |= (*pointer++ & 255) << ((mod-1-i)*CHAR_SIZE);
     sc_mem[index] = word;
     index++;
    }
}

char *em_strcat(char *pointer, int index)
/* em_strcat returns the updated pointer so that it can be passed
   back as the starting place of the next piece of string */
{
  int j,mask,word;
  int charr;

/* the size of iobuf entry is fixed, based on system parameters. With
   current parameters, ther are 4 cvhar per word, 3 words per "token".
   Each entry left padded with blanks and is right justified with a zero
   string terminator */

  mask = 255;
  word = sc_mem[index];
  for (j=0; j<SIZE_HOST/CHAR_SIZE; j++)
     {charr = mask & (word >> (SIZE_HOST-CHAR_SIZE*(1+j)));
      if(charr != 0) *pointer++ = charr; else *pointer++ = ' ';}
  *pointer = 0; /* terminate string in case this is last token */
  return(pointer);
}

void printbin(int data_dx)   /* print data in binary format */
{
  int i;
  int mask;

  mask = 0x0080;  /* limit output to right most eight bits or supply size */
  for(i=0; i<8; i++)
    {if(mask & sc_mem[data_dx]) printf("1"); else printf("0");
     mask >>= 1; }
}


void fprintbin(FILE *fpnt, int data_dx)   /* print data in binary format */
{
  int i;
  int mask;

  mask = 0x0080;  /* limit output to right most eight bits or supply size */
  for(i=0; i<8; i++)
    {if(mask & sc_mem[data_dx]) fprintf(fpnt,"1"); else fprintf(fpnt,"0");
     mask >>= 1; }
}


void scanbin(char * datastr, int *address)  /* read at most 16 bits of input */
{
  int i;
  long word;

  word = 0;
  for(i=0; i<16 && *datastr != 0; i++)
    {if(*datastr == '1')
       {word <<= 1;
	     word |= 1;}
     else if (*datastr == '0' || *datastr == ' ')
	     word <<= 1;
     else
       printf("ERROR - %c,%d in binary conversion.\n",*datastr,*datastr);
     datastr++; }
  *address = word;
}


void cm_strcpy(long * bufptr, char * strptr)
{
  int word;
  int mod,i;

  mod = SIZE_HOST/CHAR_SIZE;
  while(*strptr != 0 )
    {word = 0;
     for (i=0; i<mod && *strptr != 0; i++)
        word |= ( *strptr++ & 255) << ((mod-1-i)*CHAR_SIZE);
     *bufptr++ = word;
    }
}

/* "converts" parallel memory string into a c char string */
char *em_catstr(char * pointer, int index, int size)
{
  int i,j,k,mask,word;
  int charr;
  char *sav_pt;

  sav_pt = pointer;
  mask = 255;
  k=((size-1)/SIZE_HOST);
  for(i=k; i>=0; i--)
	 {word = sc_mem[index+i];
/*
printf("In em_catstr, index=%d, word=%d\n",index+i,word);
*/
	  for (j=0; j<SIZE_HOST/CHAR_SIZE; j++)
		 if((charr = mask & (word >> (SIZE_HOST-CHAR_SIZE*(1+j)))) != 0
			  && charr != ' ')
			 *pointer++ = charr;
	 }
  *pointer = 0;

  return(pointer);
}


