#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"
extern int LOAD_FLAG;

/* em_insert(
   mode1 - T_LOGICAL
   mode2 - T_CNST,T_SCALAR
   label - name
   address - address
   width - number of bits
   depth - number of C words required for one ASPROL word
   count - number of ASPROL words in array
   value - initial value
	shape - io specification)   */

int em_insert(int mode1, int mode2, char label_arg[TOKEN_SIZE], int address_arg,
			   int width_arg, int depth_arg, int count_arg, float value_arg,
			   char shape_arg[TOKEN_SIZE])
{
  int index,stcnt,size;
  char *tmppnt;

  index = gethash(label_arg)/2;  /* adjust for 512 symboltable */
if(em_debug_2)
  printf("In em_insert. label_arg=%s, index=%d\n",label_arg,index);
  stcnt=1;
  while(fstatus[index] == BUSY && stcnt < SYMTAB_SIZE )
    {if(em_debug_2) printf("Contents of symtab at index=%d, is %s\n",
		   index,flabel[index]);
	  if(strcmp(flabel[index],label_arg) == 0)
       {if(!LOAD_FLAG) /* true if in load quadruple */
			printf("%d ERROR - Duplicate symbol, %s, found.\n",linenum,label_arg);
		return FALSE;};
     index++;
     if(index > SYMTAB_SIZE) index = 0;
     stcnt++;
     if(stcnt > SYMTAB_SIZE)
       {printf("ERROR - Symbol table overflow on insert of %s.\n",label_arg);
	return FALSE;};
   };
  size = strlen(label_arg);
  if (( tmppnt = (char *) em_alloc((unsigned long)size+1,(unsigned long)sizeof(char))) == NULL)
       {printf("ERROR - Out of symbol memory on insert of %s.\n",label_arg);
      	return FALSE;};
  flabel[index] = tmppnt;
/*printf("symtab=%p,index=%d\n",&symtab,index);*/
  strcpy(flabel[index],label_arg);
  fstatus[index]=BUSY;
  fmode1[index]=mode1;
  fmode2[index]=mode2;
  faddress[index]=address_arg;
  fwidth[index]=width_arg;
  fsignif[index]=depth_arg;  /* store depth_arg in signif */
/*symtab[index].expt                  expt not used in emulation */
  fcount[index]=count_arg;
  fvalue[index]=value_arg;
  size = strlen(shape_arg);
  if (( tmppnt = (char *) em_alloc((unsigned long)size+1,(unsigned long)sizeof(char))) == NULL)
       {printf("ERROR - Out of symbol memory on insert of shape for %s.\n",label_arg);
      	return FALSE;};
  fshape[index] = tmppnt;
  strcpy(fshape[index],shape_arg);

if(em_debug_2) printf("Saving token %s at location %d, tmppnt=%p, value=%s, shape=%s\n",
			label_arg,index, tmppnt, value_arg, shape_arg);

  return index;
}
