/* P2_CONVERT.C 910415 */
#include "p2_prototypes.h"

/* ===========================================================================

   function name: atoi
   input	       : s		- string of character digits
   output	    : ---
   return value : sign		- the integer value of character digits string

   global vars  :---

   description	 : This routine performs the translation from character digits
		            string to the integer value.

=========================================================================== */

//int atoi(char *s)   /* converts string 's' to integer       */
int em_atoi(char *s)   /* converts string 's' to integer       */
{
 int i, n, sign;

 i = 0;
 sign = 1;
 if( s[i] == '+' || s[i] == '-' )  /* determine sign of integer             */
    sign = ( s[i++] == '+' ) ? 1 : -1 ;

 for(n = 0; s[i] != '\0'; i++)     /* do conversion                         */
    n = 10 * n + s[i] - '0';

 return(sign * n);                 /* return integer value                  */
}


/* ===========================================================================

   function name: itoa
   input	       : x		- integer digits value
		            s		- the character digit value
   output	    : s		- the converted character digits string

   return value : ---

   global vars  :---

   description	 : This routine performs the convertion of the integer value
		            to character digits value string.

=========================================================================== */
// use inplace of stdlib itoa if needed
void em_itoa(int x, char *s)                     /* converts integer 'x' to characters    */
{
 int i, m;

 i = 0;

 if( x < 0 )                       /* if 'x' is negative...                 */
   {s[i++] = '-';                 /*...place a '-' in 's'                  */
    x = -x;}                       /*...and make 'x' positive               */
 else if( x == 0 )                 /* if 'x' is zero...                     */
    s[i++] = '0';            /*...place a '0' in 's' and increment it */

 for( m = 1; m <= x; m*= 10 )      /* find largest power of 10 that is <= x */
    ;

 m /= 10;

 for(  ; m >= 1; m /= 10 )         /* as long as 'm' >= 1...                */
    {s[i++] = (x/m) + '0';         /* divide 'x' by 'm' to get character    */
     x %= m;}                       /* save remainder to be new 'x'          */

 s[i] = '\0';                      /* append array terminator               */
}

void pc_ltoa(unsigned long int x, char *s)
{
#ifdef _WIN32
	ltoa(x,s,10);
#else
	sprintf( s, "%lu", x );
#endif
}
