#ifndef P2_HEADER
#define P2_HEADER
/* ==========================================================================

   This file contains preprocessor definitions and global data structure
   declarations for use with the 'genacode' assembly code generator.

=========================================================================== */


/*---type of code to generate---*/
#define STARAN	1
#define ASPRO   2
#define C       3 /* not implemented */
#define EMULATE 4
#define CM      5 /* connection machine */

/*---possible modes for operations---*/
#define FXSC	T_INT*SIZE_MODE2 + T_SCALAR
#define FXPA	T_INT*SIZE_MODE2 + T_PARALLEL
#define LISC	T_LONGINT*SIZE_MODE2 + T_SCALAR
#define LIPA	T_LONGINT*SIZE_MODE2 + T_PARALLEL
#define CHSC    T_CHAR*SIZE_MODE2 + T_SCALAR
#define CHPA    T_CHAR*SIZE_MODE2 + T_PARALLEL
#define OCSC    T_OCT*SIZE_MODE2 + T_SCALAR
#define OCPA    T_OCT*SIZE_MODE2 + T_PARALLEL
#define BNSC    T_BIN*SIZE_MODE2 + T_SCALAR
#define BNPA    T_BIN*SIZE_MODE2 + T_PARALLEL
#define HXSC    T_HEX*SIZE_MODE2 + T_SCALAR
#define HXPA    T_HEX*SIZE_MODE2 + T_PARALLEL
#define CASC    T_CARD*SIZE_MODE2 + T_SCALAR
#define CAPA    T_CARD*SIZE_MODE2 + T_PARALLEL
#define FLSC	T_REAL*SIZE_MODE2 + T_SCALAR
#define FLPA	T_REAL*SIZE_MODE2 + T_PARALLEL
#define LGSC	T_LOGICAL*SIZE_MODE2 + T_SCALAR
#define LGPA 	T_LOGICAL*SIZE_MODE2 + T_PARALLEL

#define FXCL	T_INT*SIZE_MODE2 + T_COMMON_LEFT
#define FXCR	T_INT*SIZE_MODE2 + T_COMMON_RIGHT
#define LICL	T_LONGINT*SIZE_MODE2 + T_COMMON_LEFT
#define LICR	T_LONGINT*SIZE_MODE2 + T_COMMON_RIGHT
#define CHCL	T_CHAR*SIZE_MODE2 + T_COMMON_LEFT
#define CHCR	T_CHAR*SIZE_MODE2 + T_COMMON_RIGHT
#define CACL	T_CARD*SIZE_MODE2 + T_COMMON_LEFT
#define CACR	T_CARD*SIZE_MODE2 + T_COMMON_RIGHT
#define OCCL	T_OCT*SIZE_MODE2 + T_COMMON_LEFT
#define OCCR	T_OCT*SIZE_MODE2 + T_COMMON_RIGHT
#define BNCL	T_BIN*SIZE_MODE2 + T_COMMON_LEFT
#define BNCR	T_BIN*SIZE_MODE2 + T_COMMON_RIGHT
#define HXCL	T_HEX*SIZE_MODE2 + T_COMMON_LEFT
#define HXCR	T_HEX*SIZE_MODE2 + T_COMMON_RIGHT
#define FLCL	T_REAL*SIZE_MODE2 + T_COMMON_LEFT
#define FLCR	T_REAL*SIZE_MODE2 + T_COMMON_RIGHT
#define LGCL	T_LOGICAL*SIZE_MODE2 + T_COMMON_LEFT
#define LGCR	T_LOGICAL*SIZE_MODE2 + T_COMMON_RIGHT

#define FXCN	T_INT*SIZE_MODE2 + T_CNST
#define LICN	T_LONGINT*SIZE_MODE2 + T_CNST
#define CHCN	T_CHAR*SIZE_MODE2 + T_CNST
#define CACN	T_CARD*SIZE_MODE2 + T_CNST
#define OCCN	T_OCT*SIZE_MODE2 + T_CNST
#define BNCN	T_BIN*SIZE_MODE2 + T_CNST
#define HXCN	T_HEX*SIZE_MODE2 + T_CNST
#define FLCN	T_REAL*SIZE_MODE2 + T_CNST
#define LGCN	T_LOGICAL*SIZE_MODE2 + T_CNST

#define FXMM	T_INT*SIZE_MODE2 + T_MASKEDMOVE
#define LIMM	T_LONGINT*SIZE_MODE2 + T_MASKEDMOVE
#define CHMM	T_CHAR*SIZE_MODE2 + T_MASKEDMOVE
#define CAMM	T_CARD*SIZE_MODE2 + T_MASKEDMOVE
#define OCMM	T_OCT*SIZE_MODE2 + T_MASKEDMOVE
#define BNMM	T_BIN*SIZE_MODE2 + T_MASKEDMOVE
#define HXMM	T_HEX*SIZE_MODE2 + T_MASKEDMOVE
#define FLMM	T_REAL*SIZE_MODE2 + T_MASKEDMOVE
#define LGMM	T_LOGICAL*SIZE_MODE2 + T_MASKEDMOVE


/*---machine specific definitions---*/
#define STARAN_MAXBITADD	8000
#define ASPRO_MAXBITADD		4000


/*---global declarations---*/

 FILE	*input_fp,	/* input file descriptor */
 	*output_fp,	/* output file dexcriptor */
 	*scalar_fp,	/* common scalar file dexcriptor for c jlp 880622*/
	*fopen();	/* system routine to open file */

 char    *scalarfile;    /* added 880622 jlp */
 int	bitslice;	/* number of bitslices allocated */

#endif
