/* p2_main.c 910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"
#include "p2_parser.h"
#include "p2_prototypes.h"

#define BOAM 0   /* beginning of array memory - allow space for system stuff */
int em_debug_1,em_debug_2,em_debug_3,em_debug_4,em_debug_5,em_debug;
int LOAD_FLAG;
/* Replaced  '0' with '\0'   020505 
   But ' ' with '\ ' causes warnings */
// em_stop is disabled, so that *.std file may not match *.tst 

/* ===========================================================================

   function name: main
   input	       : argc		- number of command line arguments
		            argv		- array of character pointers to arguments
   output	    : ---
   return value : exit_value	- 0, if no errors
				                  - 1, otherwise

   global vars  : input_fp	- intermediate object file descriptor
		            output_fp	- assembly language listing file descriptor

   description	 : This function is the driver for an assembly code generator
		            program. The program converts a SIMD intermediate code
	  	            into either STARAN-E or ASPRO assembly language. If no
		            errors are detected, 0 is returned; otherwise 1 is returned.
		            (These values were chosen to be consistent with the UNIX
		            standard return values.)

=========================================================================== */
/* NOTE this main program is set up to run the testfile if no parameters are 
   input.  May be confusing for novice users that don't put in the correct
   values, but should be OK otherwise  */

char testfile[] = "c:\\asc\\asc\\suites\\asc\\suite.iob";  //vc_test
char tbuffer[100];
main(argc,argv)
int argc;
char *argv[];
{  int i;
   int exit_value;	       /* value returned by main program */
   char *make_filename();   /* routine to make a new file name */
   char *inputfile;	       /* pointer to input file name */
/* char *scalarfile;          in p2_header.h               */

   exit_value = 0;
   srand(time(NULL)); /* seed the random number generator */
 /*
 * Check for correct command usage:
 *      genacode -e filename
 */
   if ((argc == 3) || (argc == 1) )
    {if (argc == 3) inputfile = argv[2];
     else     
		{printf("Proper Usage:\n  asc.exe -e filename.  argc=%d\n",argc);
         printf("Default debugging action with execute -e1 suite.iob\n");
		inputfile = testfile;  // vc_test
		}
      /* check for correct input file suffix */
	 if(index_ss (inputfile, ".") != NULL)
		{if (strcmp (index_ss (inputfile, "."), ".iob") != 0 &&
  			 strcmp (index_ss (inputfile, "."), ".aob") != 0)
			{printf ("wrong file suffix: %s\n", inputfile);
		     em_exit(1);}
		 if(strcmp (index_ss (inputfile, "."), ".aob") == 0)
			table_parse = TRUE; else table_parse = FALSE;
		}
      /*  open input file for reading */
      if ((input_fp = fopen(inputfile, "r")) == NULL)
		{printf ("can't open %s\n", inputfile);
	      em_exit(1);}
//printf("Opening %s\n",inputfile);
      bitslice = BOAM;
      if(table_parse == FALSE)
	  printf("-- Pass 2 ");
      /* check for options */
	  // argc == 1 is for vc_debug, must be first to short cut argv[1] access
      if ( (argc == 1) || (strcmp (argv[1], "-e") >= 0))
	{code_type = EMULATE;
	  // argc == 1 when vc_debug, test must be first to short cut argv[1] access
      if((argc == 3) && (strlen(argv[1])>2))
		{em_debug=0; em_debug_1=0; em_debug_2=0;em_debug_3=0;em_debug_4=0; em_debug_5=0;
		      em_debug = atoi(argv[1]+2);
/*	         em_debug_1 = 1 & em_debug;
		 em_debug_2 = 2 & em_debug;
		 em_debug_3 = 4 & em_debug;
		 em_debug_4 = 8 & em_debug;
		 em_debug_5 = 16 & em_debug; */
	   }
	  else if (argc == 1)
		  // vc_test debugging option
		  em_debug = 1;  //dump on BOS

	   if(table_parse == FALSE)
	      printf("(020505) e option  --\n");
	 flag = 12345;

     /* LOAD_FLAG suppresses duplicate symbol error message when in
	    the em_load subroutine */
	 LOAD_FLAG = FALSE;

	 for(i=0; i<NOOFSTK; i++)
	    quads_stk[i] =
				  (qspnt *)em_alloc((unsigned long)Q_STACK_SIZE/NOOFSTK,(unsigned long)sizeof(qspnt));

	 /* int pa_mem[NOOFW][PA_MEM_SIZE]; */
//	 flabel = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(labelpnt)));
	 fstatus = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 fmode1 = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 fmode2 = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 faddress = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 fwidth = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 fsignif = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 fexpt = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 fcount = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 fvalue = (float *) em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(float)));
	 ftemp = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
//	 fshape = (char *) em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 fatabnum = em_alloc((unsigned long)SYMTAB_SIZE+2,((unsigned long)sizeof(int)));
	 init_symtab();
 
	 exit_value=em_commands();
	 if(sc_mem[get_add("PERFORM")])
			  {printf("%d parallel instructions executed\n",sc_mem[get_add("PA_PERFORM")]);
			   printf("%d scalar instructions executed\n",sc_mem[get_add("SC_PERFORM")]);}
	if(em_debug > 0) printf("Returning from em_commands();\n");
	 fclose(input_fp);
	 em_exit(exit_value);
	}
     else
       {printf("ERROR - unrecognized option %s\n",argv[1]);
		  em_exit(1); };
	 }
  else
    {printf("Usage:\n  asc.exe -e filename.  argc=%d\n",argc);
     em_exit(1);}
}

/* ============================================================================

   function name: make_filename
   input	       : base		- name of file containing base name of new file
			    suffix	- suffix of new file name
   output	    : ---
   return value : new_file_name - pointer to new file name

   global vars  : ---

   description	 : This routine constructs a file name from a given file name
		            by removing the suffix, if any, and replacing it with a
		            different suffix. A pointer is returned to the new file name.

============================================================================ */

char *make_filename (base, suffix)
char *base, *suffix;
{
   char *loc;			      /* location of '.' in base name */
   char *new_file_name;		/* pointer to new file name */

   new_file_name = (char *)em_malloc (strlen (base) + strlen (suffix) + 1);
   strcpy (new_file_name, base);
   loc = index_ss (new_file_name, ".");

   if (loc != NULL)
      strcpy (loc, suffix);
   else
      strcat (new_file_name, suffix);

   return(new_file_name);
}


/* ***************************************************

performance monitor routines

   *************************************************** */


void inc_pa_perform(int cnt)
{
  if(sc_mem[get_add("PERFORM")])
	  sc_mem[get_add("PA_PERFORM")] = sc_mem[get_add("PA_PERFORM")] + cnt;
}


void inc_sc_perform(int cnt)
{
  if(sc_mem[get_add("PERFORM")])
	  sc_mem[get_add("SC_PERFORM")] = sc_mem[get_add("SC_PERFORM")] + cnt;
}
