/* P2_MAIN_ERR.C 910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_common.h"
#include "p2_header.h"


void cm_print_err(int mess, int sub_mess)
{
  em_print_err(mess,sub_mess);
}

void em_print_err(int mess, int sub_mess)
{
switch(mess)
  {case FLOAT:
     printf("%d ERROR - floating point",linenum);
     switch(sub_mess)
       {case 1: printf(" addition "); break;
        case 2: printf(" subtraction "); break;
        case 3: printf(" multiplication "); break;
        case 4: printf(" division "); break;
        case 5: printf(" comparison "); break;
        case 6: printf(" boolean operations "); break;
        case 7: printf(" negation "); break;
        case 8: printf(" conversion "); break;
        default: printf("**error**"); break;
       };
     printf("NOT implemented. linenum=%d, quadruple=%x\n",linenum,command_bl);
     break;

   case NOT_IMPLEMENTED:
     printf("%d ERROR -",linenum);
     switch(sub_mess)
       { case 1: printf(" subroutine "); break;
         case 2: printf(" call "); break;
         case 3: printf(" return "); break;
         case 4: printf(" entry "); break;
         case 5: printf(" extrn "); break;
         case 6: printf(" asmcode "); break;
         default: printf(" ???? "); break;
       };
       printf("quadruple not implemented.\n");
     break;

   case SIZE:
     printf("%d SIZE ERROR -",linenum);
     switch(sub_mess)
       { case 1: printf(" quadruple arguments not equal size\n"); break;
         case 2: printf(" moving larger field into smaller.\n");  break;
         default: printf(" ???? "); break;
       };
     break;
   default:printf("unrecognized error code called, mess=%d, sub_mess=%d\n",
            mess,sub_mess);
   };
}

