/* P2_PRINT_CODE.C  910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "em_common.h"
#include "p2_header.h"

/* ===========================================================================

   function name: print_code
   input	       : label		- pointer to label
		            opc1		- pointer to opcode
		            opc2		- pointer to opcode extension
 		            arg1,arg2,arg3- pointers to arguments
   output	    : ---
   return value : ---

   global vars  : output_fp	- pointer to output file

   description	 : This routine prints an assembly language instruction to the
		            listing file pointed to by 'output_fp'.

=========================================================================== */

print_code(label,opc1,opc2,arg1,arg2,arg3)
char *label,*opc1,*opc2,*arg1,*arg2,*arg3;
{
   int num_spaces;			/* number of spaces to print */

/*
 * Print label, if any, and pad to 16 spaces.
 */
   num_spaces = 16;
   if(label != NULL)
     {fprintf(output_fp,"%s",label);
      num_spaces = 16 - strlen(label);}
   if(num_spaces <= 0) num_spaces = 1;
   while (num_spaces > 0)
     {fprintf(output_fp," ");
      num_spaces--;}

/*
 * Print opcode (always present).
 */
   fprintf(output_fp,"%s",opc1);
   num_spaces = 16 - strlen(opc1);

/*
 * Print opcode extension, if any, and pad to 16 spaces.
 */
   if (opc2 != NULL)
     {fprintf(output_fp,",");
      num_spaces--;
      fprintf(output_fp,"%s",opc2);
      num_spaces = num_spaces - strlen(opc2);}
   if(num_spaces <= 0) num_spaces = 1;
   while (num_spaces > 0)
     {fprintf(output_fp," ");
      num_spaces--;}

/*
   Print the arguments, if any.
 */
   if (arg1 != NULL)
     {fprintf(output_fp,"%s",arg1);
      if (arg2 != NULL)
        {fprintf(output_fp,",%s",arg2);
         if (arg3 != NULL)
            fprintf(output_fp,",%s",arg3);
        }
     }

   fprintf(output_fp,"\n");
}


/* ===========================================================================

   function name: print_err
   input	       : msg		- pointer to character string message
   output	    : ---
   return value : --

   global vars  : output_fp	- pointer to output file

   description	 : This routine prints an error message to both the
		            standard output and the file pointed to by 'output_fp'.

=========================================================================== */
extern int linenum;
print_err(msg)
char *msg;
{

if(code_type == EMULATE)
   printf("%d ERROR - %s\n",linenum,msg);
  else
   fprintf(output_fp,"ERROR - %s\n",msg);
}





