#ifndef P2_SYMTAB
#define P2_SYMTAB

/* symbol table definitions */
/* symtab stores the defined symbols during pass2 */
/* symbol_table is the pass 1 equivalent of symtab */
/* WARNING: "symtab" of pass2 does NOT have the same format as
            "symbol_table" of pass1 */

#define SYMTAB_SIZE  1136  /* size of the symbol table */
#define IDLE  0    /* for symbol table */
#define BUSY  1    /* for symbol table */

/* In order to avoid large arrays, the syumbol table is broken up into
   peices which are dynamically allocated in main.c */
   char *flabel[SYMTAB_SIZE+2];
   int  *fstatus;
   int  *fmode1;
   int  *fmode2;
   int  *faddress;
   int  *fwidth;   /* the total number of bits in the variable */
   int  *fsignif;  /* the number of bits in the mantissa of the real number */
   int  *fexpt;    /* the number of bits in the exponent of the real number */
   int  *fcount;   /* the number of fields in the array */
   float *fvalue;  /* the initial value of the variable */
   int  *ftemp;    /* TRUE if the varialbe is a temp field, i.e. IPTMP$ */
   char *fshape[SYMTAB_SIZE+2];
   int  *fatabnum;     /* the association number */
/* fatabnum is currently set in em_load and used in em_store only */

/*struct stable symtab[SYMTAB_SIZE];*/
/* string names of parameters
   set by cm_util_scan
   used by various quadruples to update size parameter */
 int flag;
 char  carg1[100],carg2[100],carg3[100],carg4[100],carg5[100],
            carg6[100],carg7[100],carg8[100],carg9[100];
 char fetch_buf[100];

#define MAX_ATAB_SIZE 10 /* max number of associations */  
#define MAX_ACOL_NUM  10 /* max number of associations (cols) per assoc */ 

/* the following is for associations
   Currently only use is load and store commands
*/
 
 struct asstab {
	int symtabdx[MAX_ACOL_NUM];  /* symtab indexes of col names */
	int acol_num; /* number of columns in associaition */
    int assocdx;  /* symbol table index of associaition name */
    int acol_size; /* total width of association */
 } ;

struct asstab atab[MAX_ATAB_SIZE];
int atab_num;  /* the current number of associations */

#endif

