/* P2_UTIL.C  910415 */
/* EM_UTIL.C  910415 */

#include "stdarg.h"
#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "p2_symtab.h"
#include "p2_common.h"
#include "p2_header.h"
#include "em_common.h"

#define CM_cube_address_length 16
#define SIZE 3
#define NON_TEMP_ID_END  1023


extern int em_debug_1,em_debug_2,em_debug_3,em_debug_4,em_debug_5,em_debug;

/* em_common.h and p2_cm_common.h differ in filld$ and empty$ being
   a variable  or  a constant(define). p2_util does not use these
   so either common is acceptable.
*/

int fetch(char *label_arg)
/* char label_arg[TOKEN_SIZE];*/
{
  int indx,stcnt;
  int done, sindex;

  stcnt=1;
  indx = gethash(label_arg)/2;
  sindex = indx;
  if(em_debug == 2) printf("In fetch, looking for %s, indx=%d\n",
					  label_arg,indx);

  //dump_symtab();
  sindex = indx;
  while (fstatus[indx] == BUSY)
    {if(strcmp(flabel[indx],label_arg) == 0)
       {if(em_debug ==2) printf("Token found at %d.\n",indx);
	  return indx;};
     if(em_debug ==2)
       printf("Token not at %d. %s is.\n",indx,flabel[indx]);
     indx++;
     if(indx > (SYMTAB_SIZE - 1)) indx = 0;
     stcnt++;
     if (stcnt > SYMTAB_SIZE) break;
    };
  done = 0;
  if(sindex <= NON_TEMP_ID_END && indx >= NON_TEMP_ID_END && !done)
	 {indx = 0;
	  while (!done && fstatus[indx] == BUSY)
		 {if(strcmp(flabel[indx], label_arg) == 0)
	  {
	  return indx;}
		  else
			 {indx++;
			  if(indx>sindex) done=TRUE;}
		 }
	 }

  if(em_debug == 2)
    printf("ERROR - Undefined symbol, %s.\n",label_arg);
  return FAIL;
}

int get_signif_size(char *carg)
{
  int ind;

  if((ind = cm_fetch(carg)) != FAIL) return(fsignif[ind]);
  else return FAIL;
}

get_expt_size(carg)
char *carg;
{
  int ind;

  if((ind = cm_fetch(carg)) != FAIL) return(fexpt[ind]);
  else return FAIL;
}

int put_size(char *carg, int size)
{
  int ind;

  if(strcmp(carg,"IPTMP$") == 0)
       {*(carg+6) = '$';
	if((ind = cm_fetch(carg)) == FAIL)
	  em_insert(T_INT,T_PARALLEL,carg,0,size,0,0,0.0,"CS$");
		  else fwidth[ind]=size;
if(em_debug == 6)printf("put_size for %s is %d\n",carg,size);
		  *(carg+6) = 0;}
  else
    if(strchr(carg,'$') != 0)
      if((ind = cm_fetch(carg)) != FAIL) fwidth[ind]=size;
      else return FAIL;

  return SUCCESS;
}

put_signif_size(carg,size)
char *carg;
int size;
{
  int ind;

  if((ind = cm_fetch(carg)) != FAIL) fsignif[ind]=size;
  else return FAIL;
  return SUCCESS;
}

put_expt_size(carg,size)
char *carg;
int size;
{
  int ind;

  if((ind = cm_fetch(carg)) != FAIL) fexpt[ind]=size;
  else return FAIL;
  return SUCCESS;
}

float get_value(char * carg)
{
  int indx;

/* use fix to force conversion - value stored as real */
  if((indx = cm_fetch(carg)) != FAIL)
    if(fmode2[indx]==T_SCALAR)
      return(fvalue[indx]);
    else
      return (fvalue[indx]);
  else return (float) FAIL;
}

gethash(carg)
char *carg;
{
  int hash,size;

  size=strlen(carg);
  hash=0;
  switch(size)
    { default: hash = carg[size/2]*8;
      case  2: hash += carg[size-1]*32;
      case  1: hash += carg[0];};
  hash %= SYMTAB_SIZE;
  return hash;
}


get_add(arg1)
/* get_add translates the symbol name into the internal emulator address. */
/* char arg1[TOKEN_SIZE];*/
char *arg1;
{
  int ind,addr;

  if((ind = fetch(arg1)) != FAIL)
    {addr=faddress[ind];
     return(addr);}
  if(em_debug_5) printf("ERROR - address not found for %s.\n",arg1);
  return FAIL;
}


get_mode1(arg1)  //int, real type
/* get_add translates the symbol name into the internal emulator address. */
/* char arg1[TOKEN_SIZE];*/
char *arg1;
{
  int ind,addr;
//printf("In get_mode1, arg1=%s\n",arg1);
  if((ind = fetch(arg1)) != FAIL)
    { addr=fmode1[ind];
//printf("ind=%d, mode1=%d\n",ind,addr);
	      return(addr);}
  if(em_debug_5) printf("ERROR - address not found for %s.\n",arg1);
  return FAIL;
}

/*  return CM_cube_address_length */
int get_size(char arg1[TOKEN_SIZE])
{
  int ind;

  if(strcmp(arg1,"IPTMP$") == 0)
       {*(arg1+6) = '$';
	if((ind = cm_fetch(arg1)) != FAIL)
		    {*(arg1+6) = 0;
	     return(fwidth[ind]);}
	else if (noex_bl <= 0)
	 /* this exit is taken if putsize was not called previously */
			printf("%d %x ERROR in get_size for %s\n",linenum,command_bl,arg1);
       }
  else if((ind = cm_fetch(arg1)) != FAIL)
	   return(fwidth[ind]);
  else if (strcmp(arg1,"CM_cube_address") == 0)
    return(CM_cube_address_length);
  else
	 return FAIL;
return FAIL;
}



checksize_3()
{
  int size1,result;

  result = SUCCESS;
  size1 = get_size(carg1);
  if((size1 != get_size(carg2)) | (size1 != get_size(carg3)))
    {cm_print_err(SIZE,1);
     result = FAIL; }
  return result;
}


checksize_2()
{
  int size1,result;

  result = SUCCESS;
  size1 = get_size(carg1);
  if(size1 != get_size(carg2))
    {cm_print_err(SIZE,1);
     result = FAIL; }
  return result;
}



int cm_fetch(char *arg1)
/* cm_fetch strips off leading (, and trailing ,,+, and )
   and then calls fetch.  */
{
  char *pnt;

  if((pnt = index_ss(arg1,"(")) != NULL)  pnt++;  else pnt = arg1;
  strcpy(&fetch_buf[0],pnt);
//if((pnt = index_ss(fetch_buf,",")) != NULL ) *(--pnt) = '\0'; 020505
  if((pnt = index_ss(fetch_buf,",")) != NULL ) *(--pnt) = 0;
  if((pnt = index_ss(fetch_buf,"+")) != NULL ) *(--pnt) = 0;
  if((pnt = index_ss(fetch_buf,")")) != NULL ) *(--pnt) = 0;
  return fetch(fetch_buf);
}

int ptemp(char *carg)
{
  int ind;

  if((ind = cm_fetch(carg)) != FAIL) return(ftemp[ind]);
  else return FAIL;
}

/* a cm function
int get_mode1(char *carg)
{
  int ind;

  if((ind = cm_fetch(carg)) != FAIL) return(fmode1[ind]);
  else return FAIL;
}
*/

get_mode2(carg)
char *carg;
{
  int ind;

  if((ind = cm_fetch(carg)) != FAIL) return(fmode2[ind]);
  else return FAIL;
}

void dump_symtab()
{ int i;
  printf("Dump of symtab:\n");
  for(i=0; i<SYMTAB_SIZE; i++)
   if (fstatus[i] == BUSY)
    printf("Token at %d is %s.\n",i,flabel[i]);
}

void init_symtab()
{ int i;

if(em_debug == 2)
   printf("In init_symtab\n");
  for(i=0; i<SYMTAB_SIZE; i++)
  { if(em_debug == 2)
		printf("init_symtab[%d], fstatus=%p, before=%d",i,(fstatus+i),fstatus[i]);
	 fstatus[i] = IDLE;
    if(em_debug == 2)
		printf(", after=%d\n",fstatus[i]);
  }
  atab_num = -1;  //increment before use
}

void em_exit(int arg)
{
//	stop();
  if(em_debug == 2)	printf("em_exit function executed\n");
	exit(1);
}


/* allocate size1*size2 integers */
int * em_alloc(unsigned long size1, unsigned long size2)
{   int * pnt;

    if(em_debug == 2) printf("In em_alloc, allocating,  %d X %d\n",size1,size2);
	pnt = (int *) malloc(size1*size2);
	if(pnt == NULL)
		printf("ERROR - em_alloc function returned NULL\n");
    if(em_debug == 2) printf("address  %p\n",pnt);
	return pnt;
}

// malloc is in stdlib.h
// It returns bytes, should use sizeof for int, etc.
/* allocate size1 integers/characters */
void * em_malloc(unsigned long size1)
{   void * pnt;
	pnt = malloc(sizeof(size1));
	if(pnt == NULL)
		printf("ERROR - malloc function returned NULL\n");
	return pnt;
}


void em_free(void *arg1)
{
	free(arg1);
	//printf("ERROR - em_free function executed\n");
}


